// Ionic erosland App
var app_version = "1.4.4";

// id utente loggato
var userId = localStorage.getItem("userId");
// upi id utente loggato
var userUpiId = localStorage.getItem("userUpiId");

var myUserData = {};
try {
	myUserData = JSON.parse(localStorage.getItem("myUserData"));
} catch (e) {
	myUserData = {};
}

var mySubscription = null;

var analytics = null;

function gaSend(type, page){
	try {
		if(device.platform != "browser"){
			if(analytics != null){
				analytics.sendAppView(page, function(data){}, function(data){});
			}
		} else {
			ga('send', 'pageview', page);
		}
	} catch (e) {
	}
}

function log(txt, obj){
	if(console != undefined){
		console.log(txt, obj != undefined ? obj : "");
	}
}

var geolocationLastWatchTime = 0;

function watchGeolocationSuccess(position){
	
	if(localStorage.getItem("my_position") == "1"){
		// se abbiamo abilitato la geolocalizzazione
		
		var t = (new Date()).getTime();
		if(geolocationLastWatchTime == 0 || t - geolocationLastWatchTime > 180000){
			// aggiornamento ogni 3 min
			geolocationLastWatchTime = t;
			
			localStorage.setItem("currentLat", ""+position.coords.latitude);
			localStorage.setItem("currentLng", ""+position.coords.longitude);
			
			$.ajax({
			    type: "GET",
			    url: "https://www.erosland.it/nicom1/nicom1",
				data: 'service=json&context=JsonSetGeolocation&sp='+userId+'&sp=S'+position.coords.latitude+'&sp=S'+position.coords.longitude+'&sp=0&sp=S0.0.0.0&sp=F',
				dataType: "json",
			    cache: false,
			    success: function(data) {
					var myLatLng = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
					var map = new google.maps.Map(document.getElementById('map_my_position'), {
						zoom: 11,
						center: myLatLng,
						mapTypeId: google.maps.MapTypeId.ROADMAP,
						disableDefaultUI: true,
						overviewMapControl: false
					});
					var marker = new google.maps.Marker({
						position: myLatLng,
						map: map,
						title: ""
					});
			    }
			});
			
		}
	}
}

function watchGeolocationError(error){
	log('code: '+error.code+'\n message: '+error.message+'\n');
}

function onDeviceReady() {
	
	//navigator.globalization.getPreferredLanguage(preferredLangSuccess, preferredLangError);
	//navigator.globalization.getLocaleName(localeNameSuccess, localeNameError);

	try {
		
		//alert("DEVICE: "+device.platform+" - "+device.version+" - "+device.model+" - "+device.cordova);
		
		pushNotification = window.plugins.pushNotification;
		
		if(userId != undefined && userId != null){
			if ( device.platform == 'android' || device.platform == 'Android'){
				pushNotification.register(pushRegisterSuccessHandler, pushRegisterErrorHandler, {"senderID":androidAppId,"ecb":"onNotification"});
			} else {
				pushNotification.register(pushRegisterTokenHandler, pushRegisterErrorHandler, {"badge":"true","sound":"true","alert":"true","ecb":"onNotificationAPN"});
			}
		}
		
	} catch (e) {
		log("ERROR. init pushNotification: "+e);
	}
	
	document.addEventListener("resume", function() {
		log("The application is resuming from the background");
		
		$(document).trigger("refreshMessages", null);
		
		// azzerare push notifications badge
		try {
			if ( device.platform == 'android' || device.platform == 'Android'){
				resetGCMBadge();
			} else {
				resetPushNotificationsBadge();
			}
		} catch (e) {
		}
		
		// controllare se l'utente e' ancora attivo
		$.ajax({
		    type: "GET",
		    url: "https://www.erosland.it/ajax/checkUserActive.php",
		    data: {
		    	'uid':userId
		    },
		    dataType: "json",
		    cache: false,
		    success: function(data) {
		    	if(data != null && data.user_active == userId){
		    		log("utente attivo");
		    	} else {
		    		log("utente non attivo -> logout");
		    		$(document).trigger("forceLogout", null);
		    	}
		    }
		});
		
	}, false);		
	
	document.addEventListener("pause", function() {
//		log("The application is put into the background");
	}, false);		

	/*
	document.addEventListener("backbutton", function(evt){
		// bloccare tasto back
		alert("BACK BUTTON");
	}, false);
	 */
	document.addEventListener("menubutton", function(evt){
		// bloccare tasto back
		evt.preventDefault();
		//alert("MENU BUTTON");
	}, false);

}

/*
 * PUSH NOTIFICATIONS. INIZIO
 * ---------------------------------------------
 */
var androidAppId = "905566473021";
var pushNotification;
var push_token_ios = "";
var push_token_android = "";

function pushRegisterSuccessHandler(result){
	log("pushRegisterSuccesHandler. result: "+result);
}

function pushRegisterErrorHandler(error){
	log("pushRegisterErrorHandler. error: "+error);
}

function pushRegisterTokenHandler(result) {
    // Your iOS push server needs to know the token before it can push to this device
    // here is where you might want to send it the token for later use.
	log("pushRegisterTokenHandler. result: "+result);
	push_token_ios = result;
	$.ajax({
	    type: "POST",
	    url: "https://www.erosland.it/ajax/pushNotificationsDeviceToken.php",
	    data: {
	    	'uid':userId,
	    	'pndt':result,
	    	'version':device.version,
	    	'model':device.model,
	    	'app_version':app_version,
	    	'uuid':device.uuid
	    },
	    dataType: "json",
	    cache: false,
	    success: function(data) {
	    	if(data != null){
	    		log("pushNotificationsDeviceToken: "+data.pndt);
	    	}
	    }
	});
}

function appBadgeSuccessHandler(resutl){
	log("appBadgeSuccessHandler. result: "+result);
}

function appBadgeErrorHandler(error){
	log("appBadgeErrorHandler. error: "+error);
}

function resetPushNotificationsBadge(){
	if(push_token_ios != "" && !isNaN(userId)){
		$.ajax({
		    type: "POST",
		    url: "https://www.erosland.it/ajax/pushNotificationsDeviceToken.php",
		    data: {
		    	'uid':userId,
		    	'pndt':push_token_ios,
		    	'reset':1,
		    	'version':device.version,
		    	'model':device.model,
		    	'app_version':app_version,
		    	'uuid':device.uuid
		    },
		    dataType: "json",
		    cache: false,
		    success: function(data) {
		    	if(data != null){
		    		log("pushNotificationsDeviceToken: "+data.pndt);
		    	}
		    }
		});
	}
}

function resetGCMBadge(){
	
	if(push_token_android != "" && !isNaN(userId)){
		$.ajax({
		    type: "POST",
		    url: "https://www.erosland.it/ajax/gcmRegId.php",
		    data: {
		    	'uid':userId,
		    	'gcm':push_token_android,
		    	'reset':1,
		    	'version':device.version,
		    	'model':device.model,
		    	'app_version':app_version,
		    	'uuid':device.uuid
		    },
		    dataType: "json",
		    cache: false,
		    success: function(data) {
		    	if(data != null){
		    		log("gcmRegId: "+data.gcm);
		    	}
		    }
		});
	}
}

function checkNotification(pn, foreground){
	
	$(document).trigger("refreshCountNotifications", null);
	
	if(pn.n_type == 1 || pn.n_type == 2 || pn.n_type == 4 || pn.n_type == 11 || pn.n_type == 12 || pn.n_type == 13 || pn.n_type == 15 || pn.n_type == 16){
		if(foreground){
			$('.icon-notifications-all').removeClass("animated notif-swing");
			$('.icon-notifications-all').parent().find(".badge").removeClass("animated notif-swing");
			setTimeout(function(){
				$('.icon-notifications-all').addClass("animated notif-swing");
				$('.icon-notifications-all').parent().find(".badge").addClass("animated notif-swing");
			}, 500);
			$(document).trigger("loadNewNotifications", null);
		} else {
			//$(document).trigger("notifModalUser", pn.s_id);
			$(document).trigger("notifShow", null);
			setTimeout(function(){
				$(document).trigger("refreshNotifications", null);
			}, 2000);
		}
	} else if(pn.n_type == 3){
		if(foreground){
		} else {
			$(document).trigger("notifModalFeedbacks", pn.s_id);
		}
	} else if(pn.n_type == 17){
		if(foreground){
			$('.icon-notifications-message').parent().find(".badge").removeClass("animated notif-pulse-big");
			setTimeout(function(){$('.icon-notifications-message').parent().find(".badge").addClass("animated notif-pulse-big");}, 500);
			$(document).trigger("loadNewMessages", null);
		} else {
			$(document).trigger("messagesShow", null);
		}
	}
}

// iOS
function onNotificationAPN (event) {
	
	if(event.foreground){
	} else {
		// azzerare push notifications badge
		resetPushNotificationsBadge();
	}
	
	if (event.alert){
		//navigator.notification.alert(event.alert);
	}

	/*
	if (event.sound){
		try {
			var snd = new Media("file://www/glass_ping.mp3");
			snd.play();
		} catch (e) {
			alert(e);
		}
		try {
			var snd = new Media("www/glass_ping.mp3");
			snd.play();
		} catch (e) {
			alert(e);
		}
	}
	*/
	
	if (event.badge && false){
		pushNotification.setApplicationIconBadgeNumber(appBadgeSuccessHandler, appBadgeErrorHandler, event.badge);
	}
	
	if(event.n_type != null){
		checkNotification(event, event.foreground);
	}
}

// android
function onNotification(e) {
	
	switch( e.event ){
		case 'registered':
			if ( e.regid.length > 0 ){
				// Your GCM push server needs to know the regID before it can push to this device
				// here is where you might want to send it the regID for later use.
				push_token_android = e.regid;
				$.ajax({
				    type: "POST",
				    url: "https://www.erosland.it/ajax/gcmRegId.php",
				    data: {
				    	'uid':userId,
				    	'gcm':e.regid,
				    	'version':device.version,
				    	'model':device.model,
				    	'app_version':app_version,
				    	'uuid':device.uuid
				    },
				    dataType: "json",
				    cache: false,
				    success: function(data) {
				    	if(data != null){
				    		log("gcm: "+data.gcm);
				    	}
				    }
				});
				
			}
			break;
			
		case 'message':
			if ( e.foreground ){
				/*
				try {
					var soundfile = e.soundname || e.payload.sound;
					//var my_media = new Media("/android_asset/www/"+ soundfile);
					var my_media = new Media("/android_asset/www/glass_ping.mp3");
					my_media.play();
				} catch (e) {
				}
				*/
				if(e.payload.n_type != null){
					checkNotification(e.payload, 1);
				}
			} else {
				if ( e.coldstart ){
				} else {
				}
				if(e.payload.n_type != null){
					checkNotification(e.payload, 0);
				}
			}
			break;
			
		case 'error':
			break;
			
		default:
			break;
	}
}

/*
 * ---------------------------------------------
 * PUSH NOTIFICATIONS. FINE
 */

function dec2char ( n ) {
	// converts a single string representing a decimal number to a character
	// note that no checking is performed to ensure that this is just a hex number, eg. no spaces etc
	// dec: string, the dec codepoint to be converted
	var result = '';
    if (n <= 0xFFFF) {
    	result += String.fromCharCode(n);
    } else if (n <= 0x10FFFF) {
		n -= 0x10000
		result += String.fromCharCode(0xD800 | (n >> 10)) + String.fromCharCode(0xDC00 | (n & 0x3FF));
	} else {
		result += 'dec2char error: Code point out of range: '+dec2hex(n);
	}
	return result;
}

function convertDecNCR2Char ( str ) { 
	// converts a string containing &#...; escapes to a string of characters
	// str: string, the input
	// convert up to 6 digit escapes to characters
	str = str.replace(/&#([0-9]{1,7});/g, function(matchstr, parens) {return dec2char(parens);});
	return str;
}

angular.module('erosland', ['ionic',
                            'ionicLazyLoad',
                            'pascalprecht.translate',
                            'ctrl.app',
                            'ctrl.tabs',
                            'ctrl.signin', 
                            'ctrl.home', 
                            'ctrl.friends', 
                            'ctrl.messages', 
                            'ctrl.notifications', 
                            'ctrl.search',
                            'ctrl.events',
                            'ctrl.lastminute',
                            'ctrl.friendsmap',
                            'ctrl.myphotos',
                            'ctrl.myvideos',
                            'ctrl.myfeedbacks',
                            'ctrl.personallymet',
                            'ctrl.eventinvites',
                            'ctrl.registration',
                            'ctrl.registration-m',
                            'ctrl.video',
                            'srv.home',
                            'srv.user',
                            'srv.friends',
                            'srv.search',
                            'srv.events',
                            'srv.lastminute',
                            'srv.signin',
                            'srv.camera',
                            'srv.friendsmap',
                            'srv.messages',
                            'srv.files',
                            'srv.eventinvites',
                            'srv.video',
                            'erosland.services',
                            'pasvaz.bindonce',
                            'customFilters'], function($httpProvider){
	// Use x-www-form-urlencoded Content-Type
	$httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded;charset=utf-8';
	
	// Override $http service's default transformRequest
	$httpProvider.defaults.transformRequest = [function(data){
		/**
		 * The workhorse; converts an object to x-www-form-urlencoded serialization.
         * @param {Object} obj
         * @return {String}
         */
		var param = function(obj){
			var query = '';
			var name, value, fullSubName, subName, subValue, innerObj, i;
			for(name in obj){
				value = obj[name];
				if(value instanceof Array){
					for(i=0; i<value.length; ++i){
						subValue = value[i];
						fullSubName = name + '[' + i + ']';
						innerObj = {};
						innerObj[fullSubName] = subValue;
						query += param(innerObj) + '&';
					}
				} else if(value instanceof Object){
					for(subName in value){
						subValue = value[subName];
						fullSubName = name + '[' + subName + ']';
						innerObj = {};
						innerObj[fullSubName] = subValue;
						query += param(innerObj) + '&';
					}
				} else if(value !== undefined && value !== null){
					query += encodeURIComponent(name) + '=' + encodeURIComponent(value) + '&';
				}
			}
			return query.length ? query.substr(0, query.length - 1) : query;
		};
		return angular.isObject(data) && String(data) !== '[object File]' ? param(data) : data;
	}];
})

.config(function($stateProvider, $urlRouterProvider, $translateProvider, $ionicConfigProvider) {
	
	//$ionicConfigProvider.scrolling.jsScrolling(false);
	
	$ionicConfigProvider.tabs.style("standard");
	$ionicConfigProvider.tabs.position("bottom");
	$ionicConfigProvider.navBar.alignTitle("center");
	
	$translateProvider.translations('it', i18n_langs['it']);
	$translateProvider.translations('en', i18n_langs['en']);
	$translateProvider.preferredLanguage("it");
	$translateProvider.fallbackLanguage("it");	
	
	$stateProvider
	
	.state('registration', {
		url: '/registration',
		templateUrl: 'templates/registration.html',
		controller: 'RegistrationCtrl'
	})

	.state('registration-m', {
		url: '/registration-m',
		templateUrl: 'templates/registration-m.html',
		controller: 'RegistrationMobileCtrl'
	})

	.state('signin', {
		url: '/sign-in',
		templateUrl: 'templates/sign-in.html',
		controller: 'SignInCtrl'
	})
	
	.state('forgotpassword', {
		url: '/forgot-password',
		templateUrl: 'templates/forgot-password.html'
	})
	
	.state('tab', {
		url: "/tab",
		abstract: true,
		templateUrl: "templates/tabs.html",
		controller: 'TabsCtrl'
	})
	
	.state('tab.home', {
		url: '/home',
		views: {
			'tab-home': {
				templateUrl: 'templates/tab-home.html',
				controller: 'HomeCtrl'
			}
		}
	})

	.state('tab.friends', {
		url: '/friends',
		views: {
			'tab-friends': {
				templateUrl: 'templates/tab-friends.html',
				controller: 'FriendsCtrl'
			}
		}
	})
	
	.state('tab.messages', {
		url: '/messages',
		views: {
			'tab-messages': {
				templateUrl: 'templates/tab-messages.html',
				controller: 'MessagesCtrl'
			}
		}
	})

	.state('tab.notifications', {
		url: '/notifications',
		views: {
			'tab-notifications': {
				templateUrl: 'templates/tab-notifications.html',
				controller: 'NotificationsCtrl'
			}
		}
	})

	.state('tab.search', {
		url: '/search',
		views: {
			'tab-search': {
				templateUrl: 'templates/tab-search.html',
				controller: 'SearchCtrl'
			}
		}
	})
	
	.state('tab.myphotos', {
		url: '/myphotos',
		views: {
			'tab-myphotos': {
				templateUrl: 'templates/tab-myphotos.html',
				controller: 'MyPhotosCtrl'
			}
		}
	})

	.state('tab.myvideos', {
		url: '/myvideos',
		views: {
			'tab-myvideos': {
				templateUrl: 'templates/tab-myvideos.html',
				controller: 'MyVideosCtrl'
			}
		}
	})

	.state('tab.myfeedbacks', {
		url: '/myfeedbacks',
		views: {
			'tab-myfeedbacks': {
				templateUrl: 'templates/tab-myfeedbacks.html',
				controller: 'MyFeedbacksCtrl'
			}
		}
	})

	.state('tab.friendsmap', {
		url: '/friendsmap',
		views: {
			'tab-friendsmap': {
				templateUrl: 'templates/tab-friendsmap.html',
				controller: 'FriendsMapCtrl'
			}
		}
	})

	.state('tab.events', {
		url: '/events',
		views: {
			'tab-events': {
				templateUrl: 'templates/tab-events.html',
				controller: 'EventsCtrl'
			}
		}
	})
	
	.state('tab.lastminute', {
		url: '/lastminute',
		views: {
			'tab-lastminute': {
				templateUrl: 'templates/tab-lastminute.html',
				controller: 'LastMinuteCtrl'
			}
		}
	})
	
	.state('tab.personallymet', {
		url: '/personallymet',
		views: {
			'tab-personallymet': {
				templateUrl: 'templates/tab-personallymet.html',
				controller: 'PersonallyMetCtrl'
			}
		}
	})

	.state('tab.eventinvites', {
		url: '/eventinvites',
		views: {
			'tab-eventinvites': {
				templateUrl: 'templates/tab-eventinvites.html',
				controller: 'EventInvitesCtrl'
			}
		}
	})

	.state('tab.video', {
		url: '/video',
		views: {
			'tab-video': {
				templateUrl: 'templates/tab-video.html',
				controller: 'VideoCtrl'
			}
		}
	});

	if(userId != null && userUpiId != null && !isNaN(userId) && !isNaN(userUpiId)){
		$urlRouterProvider.otherwise('/tab/home');
	} else {
		$urlRouterProvider.otherwise('/sign-in');
	}
})

.run(function($ionicPlatform, $translate, $rootScope, $state, ModalUser, $ionicModal, $q, UserProfile, $ionicSlideBoxDelegate, LastMinute, $ionicScrollDelegate, $ionicLoading, Abuse, $ionicPopup, $sce, PersonallyMet, Friends, $timeout, $ionicActionSheet, MyCamera, Messages, Settings, Files) {
	
	$ionicPlatform.ready(function() {
		
		console.log("platform ready", device);
		
		$rootScope.mobileBrowser = false;
		
		$rootScope.mobilePlatform = true;
		try {
			$rootScope.mobilePlatform = device.platform != "browser";
		} catch (e) {
			$rootScope.mobilePlatform = false;
		}
		
		//if($rootScope.blurOptionChecked == undefined || !$rootScope.blurOptionChecked){
			$rootScope.blur_enabled = true;
			$rootScope.blurOption = false;
			try {
				
				if(device.platform == "browser"){
					$rootScope.mobileBrowser = true;
				} else {
					if(typeof navigator.analytics !== "undefined") {
						analytics = navigator.analytics;
						analytics.setTrackingId('UA-60865317-1');
			        } else {
			        	//log("Google Analytics Unavailable");
			        }
				}
				
				$rootScope.blurOption = true;
				$rootScope.blur_enabled = localStorage.getItem("opt_blur") == "1";					
				/*
				if(device.platform.toLowerCase() == "android" || device.platform == "browser"){
					$rootScope.blurOption = true;
					$rootScope.blur_enabled = localStorage.getItem("opt_blur") == "1";	
				} else {
					var deferred_settings = $q.defer();
					var promise_settings = deferred_settings.promise;
					promise_settings.then(function(result){
						//log(result.app_setting_status);
						if(result.app_setting_status == true){
							$rootScope.blurOption = true;
							$rootScope.blur_enabled = localStorage.getItem("opt_blur") == "1";	
						} else {
							$rootScope.blur_enabled = true;
							$rootScope.blurOption = false;
						}
					}, function(reason){
					});
					Settings.check_setting(userId, 1, deferred_settings);
				}
				*/
			} catch (e) {
				$rootScope.blurOption = true;
				$rootScope.blur_enabled = localStorage.getItem("opt_blur") == "1";
				/*
				$rootScope.blurOption = true;
				$rootScope.blur_enabled = localStorage.getItem("opt_blur") == "1";
				*/
			}
			//$rootScope.blurOptionChecked = true;
		//}
		
		$ionicPlatform.registerBackButtonAction(function () {
			// do nothing
		}, 100);
		
		if(typeof navigator.globalization !== "undefined") {
			navigator.globalization.getPreferredLanguage(function(language) {
				$translate.use((language.value).split("-")[0]).then(function(data) {
				}, function(error) {
					log("lang ERROR -> " + error);
				});
			}, null);
		}
		
		document.addEventListener("deviceready", onDeviceReady, false);
		
		if(localStorage.getItem("opt_blur") == null){
			localStorage.setItem("opt_blur", "0");
		}
		
		/*
		if(navigator){
			log(navigator.platform+", "+device.model);
		}
		*/
		
		//$rootScope.sideMenuWidth = $(window).width() > 768 ? Math.round($(window).width()*0.4) : Math.round($(window).width()*0.85);
		$rootScope.sideMenuWidth = Math.round($(window).width()*0.85);
		var mcw = $(window).width()*0.85;
		if(mcw > 775){
			mcw = 775;
		}
		var mch = (($(window).width()*0.85) * 300 / 775);
		if(mch > 300){
			mch = 300;
		}
		$rootScope.myCoverWidth = mcw+'px';
		$rootScope.myCoverHeight = mch;
		$rootScope.appHeight = $(window).height();
		$rootScope.myUData = myUserData;
		
		// Hide the accessory bar by default (remove this to show the accessory bar above the keyboard for form inputs)
		if(window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
			//alert("window.cordova.keyboad OK!");
			cordova.plugins.Keyboard.disableScroll(true);
			cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
		} else {
			//alert("window.cordova.keyboad NO!");
		}

		if(window.StatusBar) {
			// org.apache.cordova.statusbar required
			//alert("window.StatusBar ok");
			if(userId != null && userUpiId != null && !isNaN(userId) && !isNaN(userUpiId)){
				StatusBar.styleBlackOpaque();
			} else {
				StatusBar.styleDefault();
			}
		} else {
			//alert("window.StatusBar no");
		}
		
	});
	
	$rootScope.bindHtmlText = function(txt){
		if(txt != null){
			return txt.replace(/\r\n/g, '<br>');
		} else {
			return "";
		}
	};
	
	// DIAGNOSTIC GPS
	$rootScope.diagnosticGPS = function(force){
		
		if(force){
			localStorage.setItem("diagnostic_gps", "0");
		}
		
		if(localStorage.getItem("diagnostic_gps") != "1"){
			localStorage.setItem("diagnostic_gps", "1");
			try {
				cordova.plugins.diagnostic.isLocationEnabled(
					function(e){
						//alert("isLocationEnabled. success: "+e);
						if(e == true || e == 1 || e == "1"){
						} else {
							if (device.platform == 'android' || device.platform == 'Android'){
								$ionicPopup.confirm({
									title: $translate.instant('gps_off'),
									template: $translate.instant('gps_attiva'),
									okText: $translate.instant('impostazioni'),
									cancelText: $translate.instant('annulla')
								}).then(function(res){
									if(res){
										cordova.plugins.diagnostic.switchToLocationSettings();
									}
								});
							} else {
								$ionicPopup.alert({
									title: $translate.instant('gps_off'),
									template: $translate.instant('gps_attiva_ios')
								}).then(function(res){
								});
							}
							
						}
					},
					function(e){
						//alert("isLocationEnabled. error: "+JSON.stringify(e));
					}
				);			
			} catch (e) {
				//alert("diagnosticGPS error: "+e);
			}
		}
	};
	
	/*
	 * MODAL USER (global). INIZIO
	 * ---------------------------------------------
	 */
	
	$rootScope.showModalUser_ = function($scope, uid, slideLastMinute_){
		
		gaSend("pageview", "user."+uid);
		
		log("showModalUser_: "+uid+", lm: "+slideLastMinute_);
		
		$scope.selectedMUId = uid;
		
		if(!$scope.modalUsers){
			$scope.modalUsers = [];
			$scope.mud = [];
			$scope.muTempl = [];
			$scope.mufTempl = [];
		}
		
		var modalUserAdd = true;
		
		for ( var usr = 0; usr < $scope.modalUsers.length; usr++) {
			if($scope.modalUsers[usr].id == uid){
				modalUserAdd = false;
				break;
			}
		}
		
		if(modalUserAdd){

			var muObj = {id:$scope.selectedMUId};
			$scope.modalUsers.push(muObj);
			
			$scope.mud["modalData"+$scope.selectedMUId] = {};
			
			$scope.slideLastMinute = slideLastMinute_;
			
			// preload content
			var deferred_mud = $q.defer();
			var promise_mud = deferred_mud.promise;
			promise_mud.then(function(result){
				
				$scope.mud["modalData"+$scope.selectedMUId] = result;

				$scope.mud["modalData"+$scope.selectedMUId].myUD = myUserData;
				
				$scope.mud["modalData"+$scope.selectedMUId].slideLastMinute = $scope.slideLastMinute;
				
				$ionicSlideBoxDelegate.$getByHandle('modalUserSlideBox_modalData'+$scope.selectedMUId).update();
				$ionicSlideBoxDelegate.$getByHandle('modalUserSlideBox_modalData'+$scope.selectedMUId).enableSlide(false);
				
				// tasso di risposta
				var deferred_replyRate = $q.defer();
				var promise_replyRate = deferred_replyRate.promise;
				promise_replyRate.then(function(result){
					if(result.user_reply_rate > 0){
						$scope.mud["modalData"+$scope.selectedMUId].replyRate = '<font class="'+(result.user_reply_rate >= 50 ? "color-verde" : "color-rosso")+'">'+result.user_reply_rate+' %</font> <font class="color-grigio">'+$translate.instant('tasso_di_risposta')+'</font>';
						$scope.mud["modalData"+$scope.selectedMUId].replyRateNum = result.user_reply_rate;
					}
				}, function(reason){
				});
				ModalUser.getReplyRate($scope.selectedMUId, deferred_replyRate);
				
				// conosciuti di persona
				// se non siamo amici carico la lista di conosciuti di persona
				
				var deferred_friends = $q.defer();
				var promise_friends = deferred_friends.promise;
				promise_friends.then(function(result){
					if(result.are_friends == "true"){
						$scope.mud["modalData"+$scope.selectedMUId].friends = true;
						// se siamo amici (ma non conoscenti) mostro il pulsante per visualizzare i conosciuti di persona (per poter effettuare la richiesta)
						var deferred_personallyMet = $q.defer();
						var promise_personallyMet = deferred_personallyMet.promise;
						promise_personallyMet.then(function(result){
							if(result.user_contact != null && result.user_contact == "check_false"){
								$scope.mud["modalData"+$scope.selectedMUId].personallyMet = true;
								$scope.mud["modalData"+$scope.selectedMUId].personallyMetCnt = 0;
								$scope.mud["modalData"+$scope.selectedMUId].personallyMetList = [];
								
								$ionicScrollDelegate.$getByHandle('modalUserScroll_modalData'+$scope.selectedMUId).resize();
								
								var deferred_personallyMet = $q.defer();
								var promise_personallyMet = deferred_personallyMet.promise;
								promise_personallyMet.then(function(result){
									if(result.user_contact != null && result.user_contact.cnt != null && result.user_contact.cnt > 0){
										$scope.mud["modalData"+$scope.selectedMUId].personallyMetCnt = result.user_contact.cnt;
										$scope.mud["modalData"+$scope.selectedMUId].personallyMetList = result.user_contact.list;
									}
								}, function(reason){
								});
								PersonallyMet.list($scope.selectedMUId, 0, deferred_personallyMet);
							} else {
								// do nothing
							}
						}, function(reason){
						});
						PersonallyMet.check(userId, $scope.selectedMUId, deferred_personallyMet);
					} else {
						/*
						if($scope.mud["modalData"+$scope.selectedMUId].profileValueId != null && $scope.mud["modalData"+$scope.selectedMUId].profileValueId == 51){
							$scope.mud["modalData"+$scope.selectedMUId].friends = true;
							// TODO: richiesta amicizia club -> diventa subito fan
						} else {
						}
						*/
						$scope.mud["modalData"+$scope.selectedMUId].friends = false;
						
						var deferred_personallyMet = $q.defer();
						var promise_personallyMet = deferred_personallyMet.promise;
						promise_personallyMet.then(function(result){
							if(result.user_contact != null && result.user_contact.cnt != null && result.user_contact.cnt > 0){
								$scope.mud["modalData"+$scope.selectedMUId].personallyMet = true;
								$scope.mud["modalData"+$scope.selectedMUId].personallyMetCnt = result.user_contact.cnt;
								$scope.mud["modalData"+$scope.selectedMUId].personallyMetList = result.user_contact.list;
							}
						}, function(reason){
						});
						PersonallyMet.list($scope.selectedMUId, 0, deferred_personallyMet);
					}
					
				}, function(reason){
				});
				Friends.areFriends(userId, $scope.selectedMUId, deferred_friends);
				
				$timeout(function(){
					try {
						$scope.muTempl["modalData"+$scope.selectedMUId].show();
						$scope.loadingActionEnd();
					} catch (e) {
						//alert("modal user err: "+e);
					}
				}, 1000);

			}, function(reason){
			});
			
			if(window.StatusBar && device.platform != 'android' && device.platform != 'Android'){
				StatusBar.hide();
			}
			
			$scope.muTempl["modalData"+$scope.selectedMUId] = $ionicModal.fromTemplate(getModalUserTemplate("modalData"+$scope.selectedMUId), {
				id: "lm-user",
				scope: $scope,
				animation: 'slide-in-right',
				hardwareBackButtonClose: false
			});
			ModalUser.init($scope.selectedMUId, deferred_mud);
			
		} else {
			$scope.muTempl["modalData"+$scope.selectedMUId].show();
			$scope.loadingActionEnd();
		}
				
	};
	
	$rootScope.closeModalUser = function($scope){
		
		$scope.muTempl["modalData"+$scope.selectedMUId].hide();
		$scope.muTempl["modalData"+$scope.selectedMUId].remove();
		
		$scope.mud["modalData"+$scope.selectedMUId] = null;
		var usrToRemove = $scope.modalUsers.pop();
		usrToRemove = null;
		if($scope.modalUsers.length > 0){
			$scope.selectedMUId = $scope.modalUsers[$scope.modalUsers.length-1].id;
			
//			$scope.currentModalData = "modalData"+$scope.selectedMUId;
		} else {
			$scope.selectedMUId = null;
//			$scope.currentModalData = null;
			if(window.StatusBar){
				StatusBar.show();
			}
		}
		
	};
	
	$rootScope.modalUserGoToSlide = function($scope, index){
		$ionicSlideBoxDelegate.$getByHandle('modalUserSlideBox_modalData'+$scope.selectedMUId).slide(index);
	};
		
	$rootScope.modalUserSlideChanged_ = function($scope, index){
		log("modalUserSlideChanged_: "+index);
		if(index == 0){
			// profilo
		} else if(index == 1){
			// foto
			$scope.mud["modalData"+$scope.selectedMUId].photodim = (($(window).width()/3)-7)+'px';
			
			if($scope.mud["modalData"+$scope.selectedMUId].slidePhotoViewed == undefined || $scope.mud["modalData"+$scope.selectedMUId].slidePhotoViewed == null){
				// prima volta in slide foto
				$scope.mud["modalData"+$scope.selectedMUId].slidePhotoViewed = true;
				$scope.mud["modalData"+$scope.selectedMUId].userPhotosPage = 0;
				$rootScope.loadPhotos($scope, false);
			} else {
				
			}
		} else if(index == 2){
			// last minute
			var deferred_lm = $q.defer();
			var promise_lm = deferred_lm.promise;
			promise_lm.then(function(result){
				$scope.mud["modalData"+$scope.selectedMUId].last_minute_list = result.last_minute_list;
			}, function(reason){
			});
			LastMinute.getLastMinute(userId, $rootScope.sqr_lat1, $rootScope.sqr_lat2, $rootScope.sqr_lng1, $rootScope.sqr_lng2, $scope.selectedMUId, deferred_lm);
		}
	};
	
	$rootScope.loadPhotos = function($scope, update){
		
		log("loadPhotos. update : "+update+", page: "+$scope.mud["modalData"+$scope.selectedMUId].userPhotosPage);
		
		if(update){
			// TODO: ricaricare solo foto selezionata
		}
		
		if($ionicScrollDelegate.$getByHandle('scrollerPhoto_modalData'+$scope.selectedMUId).getScrollPosition().top == 0 && $scope.mud["modalData"+$scope.selectedMUId].userPhotosPage > 0){
			log("scroll.infiniteScrollComplete");
			$scope.mud["modalData"+$scope.selectedMUId].userPhotosPage--;
			log("loadPhotos. page: "+$scope.mud["modalData"+$scope.selectedMUId].userPhotosPage);
			$scope.$broadcast('scroll.infiniteScrollComplete');
			return;
		}
		
		var deferred_userProfilePhotos = $q.defer();
		var promise_userProfilePhotos = deferred_userProfilePhotos.promise;
		promise_userProfilePhotos.then(function(result){
			
			if($scope.mud["modalData"+$scope.selectedMUId].userPhotosPage == 0){
				$scope.mud["modalData"+$scope.selectedMUId].files = result.files;
			} else {
				$scope.mud["modalData"+$scope.selectedMUId].files = $scope.mud["modalData"+$scope.selectedMUId].files.concat(result.files);
				$scope.files = $scope.mud["modalData"+$scope.selectedMUId].files;
				if($scope.modalUP != null && $scope.modalUP.isShown()){
					log("modal-photo is shown -> update");
					$ionicSlideBoxDelegate.$getByHandle('photoSlider').update();
				}
				$scope.$broadcast('scroll.infiniteScrollComplete');
			}
			if(result.files.length < 24){
				$scope.mud["modalData"+$scope.selectedMUId].showLoadMorePhotos = false;
			} else {
				$scope.mud["modalData"+$scope.selectedMUId].showLoadMorePhotos = true
			}
			
		}, function(reason){
		});
		if($rootScope.mobileBrowser){
			log("UserProfile.getPhotos page: "+$scope.mud["modalData"+$scope.selectedMUId].userPhotosPage);
			UserProfile.getPhotos(userId, $scope.selectedMUId, $scope.mud["modalData"+$scope.selectedMUId].userPhotosPage, deferred_userProfilePhotos);
		} else {
			log("UserProfile.getPhotosApproved page: "+$scope.mud["modalData"+$scope.selectedMUId].userPhotosPage);
			UserProfile.getPhotosApproved(userId, $scope.selectedMUId, $scope.mud["modalData"+$scope.selectedMUId].userPhotosPage, deferred_userProfilePhotos);
		}
	};
	
	$rootScope.loadMorePhotos = function($scope){
		$scope.mud["modalData"+$scope.selectedMUId].userPhotosPage = $scope.mud["modalData"+$scope.selectedMUId].userPhotosPage+1;
		$rootScope.loadPhotos($scope, false);
	};
	
	$rootScope.modalUserLoadMorePhotos_ = function($scope){
		if($ionicScrollDelegate.$getByHandle('scrollerPhoto_modalData'+$scope.selectedMUId).getScrollPosition().top == 0 && $scope.mud["modalData"+$scope.selectedMUId].userPhotosPage == 0){
			//$scope.mud["modalData"+$scope.selectedMUId].userPhotosPage--;
			$scope.$broadcast('scroll.infiniteScrollComplete');
		} else {
			$rootScope.loadMorePhotos($scope);
		}
	};
	
	// FEEDBACKS. inizio
	
	$rootScope.modalUserShowFeedback = function($scope){
		
		$scope.mud["modalData"+$scope.selectedMUId].showLoadMoreFeedbacks = false;
		$scope.mud["modalData"+$scope.selectedMUId].feedbacksPage = 0;
		$scope.mud["modalData"+$scope.selectedMUId].feedbacksInfo.title = $translate.instant('feedbacks');
		$scope.mud["modalData"+$scope.selectedMUId].feedbackSendDisabled = $scope.selectedMUId == userId;

		/*
		$scope.mufTempl["modalData"+$scope.selectedMUId] = $ionicModal.fromTemplate(getModalUserFeedbacksTemplate("modalData"+$scope.selectedMUId), {
			id: "feedbacks",
			scope: $scope,
			animation: 'slide-in-up'
		});
		*/
		
		$scope.modalFbData = $scope.mud["modalData"+$scope.selectedMUId];
		$ionicModal.fromTemplateUrl('templates/modal-feedbacks.html', {
			id: "feedbacks",
			scope: $scope,
			animation: 'slide-in-up',
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.mufTempl["modalData"+$scope.selectedMUId] = modal;
			$rootScope.modalUserShowUserFeedback_($scope);
		});
		
	};
	
	$rootScope.modalUserShowUserFeedback_ = function($scope){
		var deferred_userFeedbacks = $q.defer();
		var promise_userFeedbacks = deferred_userFeedbacks.promise;
		promise_userFeedbacks.then(function(result){
			
			$scope.$broadcast('scroll.infiniteScrollComplete');
			
			if(result.feedbacks.length >= 0){
				
				if($scope.mud["modalData"+$scope.selectedMUId].feedbacksPage == 0){
					$scope.mud["modalData"+$scope.selectedMUId].feedbacks = result.feedbacks;
				} else {
					$scope.mud["modalData"+$scope.selectedMUId].feedbacks = $scope.mud["modalData"+$scope.selectedMUId].feedbacks.concat(result.feedbacks);
				}
				
				if(result.feedbacks.length < 40){
					$scope.mud["modalData"+$scope.selectedMUId].showLoadMoreFeedbacks = false;
				} else {
					$scope.mud["modalData"+$scope.selectedMUId].showLoadMoreFeedbacks = true;
				}				
				
				if($scope.mud["modalData"+$scope.selectedMUId].feedbacksPage > 0){
					//$ionicScrollDelegate.$getByHandle('modalScroll').scrollBottom(true);
					$ionicScrollDelegate.$getByHandle('modalScroll').scrollTo(0, $ionicScrollDelegate.$getByHandle('modalScroll').getScrollPosition().top + 100, true);
				}
			}
			
			if($scope.mud["modalData"+$scope.selectedMUId].feedbacksPage == 0){
				$scope.mufTempl["modalData"+$scope.selectedMUId].show();				
			}
			
			$ionicLoading.hide();			
			
		}, function(reason){
		});
		UserProfile.showUserFeedback($scope.selectedMUId, $scope.mud["modalData"+$scope.selectedMUId].feedbacksPage, deferred_userFeedbacks);
	};
	
	$rootScope.modalUserShowUserFeedbacksMore = function($scope){
		$scope.mud["modalData"+$scope.selectedMUId].feedbacksPage = $scope.mud["modalData"+$scope.selectedMUId].feedbacksPage+1;
		$rootScope.modalUserShowUserFeedback_($scope);
	};
	
	$rootScope.modalUserSendUserFeedback = function($scope){
		
		var deferred_userFeedback = $q.defer();
		var promise_userFeedback = deferred_userFeedback.promise;
		promise_userFeedback.then(function(result){
			
			log("feedback: "+result.feedback_check);
			
			if(result.feedback_check == "ok"){
				$rootScope.modalUserWriteFeedback($scope);
			} else {
				$ionicPopup.alert({
					title: $translate.instant('feedback'),
					template: $translate.instant('feedback_no')
				});
			}
			
		}, function(reason){
			log("feedback err: "+reason);
		});
		UserProfile.canFeedback(userId, $scope.selectedMUId, deferred_userFeedback);
	};
	
	$rootScope.modalUserWriteFeedback = function($scope){
		
//		if(window.StatusBar){
//			StatusBar.styleDefault();
//		}
		
		$scope.myFeedback = {'value':"", 'positive':true};
		$scope.feedbackTextHeight = (($(window).height()*0.9)*0.35)+'px';
		
		try {
			cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
		} catch (e) {
		}
		
		// mostra like/nolike
		$ionicModal.fromTemplateUrl('templates/modal-feedback-write.html', {
			id: 'modal-feedback',
			scope: $scope,
			animation: 'slide-in-up',
			focusFirstInput: true,
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalF = modal;
			$scope.modalF.show();
		});
		
	};
	
	$rootScope.modalUserSendFeedback = function($scope){
		var deferred_feedback = $q.defer();
		var promise_feedback = deferred_feedback.promise;
		promise_feedback.then(function(result){
			if(result != null && result.send_feedback == "ok"){
				$scope.modalF.hide();
				$scope.modalF.remove();
				
				$scope.mud["modalData"+$scope.selectedMUId].showLoadMoreFeedbacks = false;
				$scope.mud["modalData"+$scope.selectedMUId].feedbacksPage = 0;
				$scope.mud["modalData"+$scope.selectedMUId].feedbacksInfo.title = $translate.instant('feedbacks');
				$rootScope.modalUserShowUserFeedback_($scope);
				
				$ionicPopup.alert({
					title: $translate.instant('feedback'),
					template: $translate.instant('feedback_inviato')
				});
			}
		}, function(reason){
			$ionicPopup.alert({
				title: $translate.instant('feedback'),
				template: $translate.instant('errore')
			});
		});
		ModalUser.sendFeedback(userId, $scope.selectedMUId, $scope.myFeedback.value, $scope.myFeedback.positive ? 1 : 2, deferred_feedback);
	};
	
	// FEEDBACKS. fine
	
	// VIDEO. inizio
	
	$rootScope.loadVideos = function($scope, update){
		var deferred_userProfileVideos = $q.defer();
		var promise_userProfileVideos = deferred_userProfileVideos.promise;
		promise_userProfileVideos.then(function(result){
			if(update){
				//TODO: ricaricare solo il video selezionato
				$scope.currentVideo = result.files[$scope.currentVideoIdx].file;
				$scope.videos[$scope.currentVideoIdx].file = result.files[$scope.currentVideoIdx].file;
			}/* else {
				$scope.videos = result.files;
				if(result.files.length > 0){
					$scope.showVideos = true;
					$scope.coverAndProfileHeightVideos = (ch+35+35+65)+'px';
					$scope.contentViewHeight = ($(window).height() - (ch+35+35+40+65))+'px';
					$scope.slideHeight = ($(window).height() - (ch+35+35+45+35+65))+'px';
				}
			}
			*/
		}, function(reason){
		});
		$scope.userVideosPage = 0;
		UserProfile.getVideos(userId, $scope.selectedMUId, $scope.userVideosPage, deferred_userProfileVideos);
	};

	$rootScope.modalUserShowVideo = function($scope, videoFile){
		
		$scope.videoFile = videoFile;
		$scope.videos = $scope.mud["modalData"+$scope.selectedMUId].videos;
		$scope.abusePhoto = false;
		
		for ( var vidx = 0; vidx < $scope.videos.length; vidx++) {
			if($scope.videos[vidx].file.fileId == videoFile.fileId){
				$scope.currentVideoIdx = vidx;
				break;
			}
		}
		
		var deferred_fileView = $q.defer();
		var promise_fileView = deferred_fileView.promise;
		promise_fileView.then(function(result){
		}, function(reason){
		});
		Files.fileView(videoFile.fileId, deferred_fileView);
		
		$scope.videoWidth = $(window).width();
		
		$ionicModal.fromTemplateUrl('templates/modal-video.html', {
			id: "video",
			scope: $scope,
			animation: 'slide-in-up',
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalUV = modal;
			$scope.modalUV.show();
		});
	};
	
	$rootScope.videoClicked = function(){
		log("video clicked");
	};
	
	$rootScope.modalUserVideoSlideHasChanged = function($scope, index){
		$scope.currentVideoIdx = index;
		$scope.currentVideo = $scope.videos[index].file;
		$scope.currentVideoId = $scope.videos[index].file.fileId;
		
		$scope.videoSource = $sce.trustAsResourceUrl("https://www.erosland.it/nicom1/users/"+$scope.selectedMUId+"/files/"+$scope.currentVideoId+".mp4");
		$scope.videoPoster = $sce.trustAsResourceUrl("https://www.erosland.it/nicom1/users/"+$scope.selectedMUId+"/files/"+$scope.currentVideoId+".jpg");
		
		//$('.video-containers').html("");
		if($('#video_container_'+$scope.currentVideoId).find("video").length==0){
//			log("inject video");
			$('#video_container_'+$scope.currentVideoId).html('<video controls type="video/mp4" src="'+$scope.videoSource+'" poster="'+$scope.videoPoster+'" preload="none"></video>');
		} else {
//			log("video present");
		}
		
		if($scope.videoTag.indexOf($scope.currentVideoId) == -1){
			$scope.videoTag.push($scope.currentVideoId);
		}
		
		setTimeout(function(){
			
			var video_found = false;
			
			for ( var ve = 0; ve < $scope.videoElement.length; ve++) {
				var veObj = $scope.videoElement[ve];
				if(veObj.vid == $scope.currentVideoId){
					video_found = true;
					break
				}
			}
			
//			log("video found: "+video_found);
			
			if(!video_found){
				var player = null;
				try {
					player = document.getElementsByTagName("video")[$scope.videoTag.indexOf($scope.currentVideoId)];
//					log("get player: "+($scope.videoTag.indexOf($scope.currentVideoId)+1)+" / "+$scope.videoTag.length);
					$scope.videoElement.push({vid:$scope.currentVideoId, video:player});
				} catch (e) {
				}
				if(player != null && player != undefined){
					player.addEventListener('webkitbeginfullscreen', function(){
					}, false);
					player.addEventListener('webkitendfullscreen', function(){
//						log("video elements: "+$scope.videoElement.length);
						$scope.videoElement.splice($scope.videoElement.indexOf({vid:$scope.currentVideoId, video:player}), 1);
//						log("video elements: "+$scope.videoElement.length);
//						log("player: "+player.src);
						player.pause();
						player.src = "";
						player.load();
						//$('#video_container_'+$scope.currentVideoId).html('<video controls type="video/mp4" src="'+$scope.videoSource+'" poster="'+$scope.videoPoster+'" preload="none"></video>');
						$('#video_container_'+$scope.currentVideoId).html("");
						$rootScope.modalUserVideoSlideHasChanged($scope, index);
					}, false);
				}
			}
			
		}, 1000);
	};
	
	$rootScope.modalUserShowVideoVotes = function($scope){
		$scope.photoType = false;
		$ionicModal.fromTemplateUrl('templates/modal-video-votes.html', {
			id: "video_votes",
			scope: $scope,
			animation: 'slide-in-up',
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalVV = modal;
			$scope.modalVV.show();
		});
	};
	
	$rootScope.modalUserShowVideoComments = function($scope){
		$scope.photoType = false;
		$ionicModal.fromTemplateUrl('templates/modal-video-comments.html', {
			id: "video_comments",
			scope: $scope,
			animation: 'slide-in-right',
			focusFirstInput: false,
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalVC = modal;
			$scope.modalVC.show();
		});
	};

	// VIDEO. fine
	
	// PHOTO. inizio
	
	$rootScope.showTextArea_ = function($scope){
		$scope.showTA = true;
	};

	$rootScope.modalUserShowPhoto = function($scope, photoFile){
		
		$scope.files = $scope.mud["modalData"+$scope.selectedMUId].files;
		$scope.user = $scope.mud["modalData"+$scope.selectedMUId].user;
		$scope.coverWidth = $scope.mud["modalData"+$scope.selectedMUId].coverWidth;
		$scope.wHeight = $scope.mud["modalData"+$scope.selectedMUId].wHeight;
		$scope.photoFile = photoFile;
		$scope.abusePhoto = true;
		
		for ( var fidx = 0; fidx < $scope.files.length; fidx++) {
			if($scope.files[fidx].file.fileId == photoFile.fileId){
				$scope.currentPhotoIdx = fidx;
				break;
			}
		}
		
		$ionicModal.fromTemplateUrl('templates/modal-photo.html', {
			id: "photo",
			scope: $scope,
			animation: 'slide-in-up',
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalUP = modal;
			$scope.modalUP.show();
		});
	};
	
	// classe stelle voto
	$rootScope.getStarClass = function(rank, star){
		if(star == 1){
			return rank != null ? (rank == 1 ? "ion-ios-star-half" : (rank >= 2 ? "ion-ios-star" : "ion-ios-star-outline")) : "ion-ios-star-outline";
		} else if(star == 2){
			return rank != null ? (rank == 3 ? "ion-ios-star-half" : (rank >= 4 ? "ion-ios-star" : "ion-ios-star-outline")) : "ion-ios-star-outline";
		} else if(star == 3){
			return rank != null ? (rank == 5 ? "ion-ios-star-half" : (rank >= 6 ? "ion-ios-star" : "ion-ios-star-outline")) : "ion-ios-star-outline";
		} else if(star == 4){
			return rank != null ? (rank == 7 ? "ion-ios-star-half" : (rank >= 8 ? "ion-ios-star" : "ion-ios-star-outline")) : "ion-ios-star-outline";
		} else if(star == 5){
			return rank != null ? (rank >= 9 && rank < 10 ? "ion-ios-star-half" : (rank == 10 ? "ion-ios-star" : "ion-ios-star-outline")) : "ion-ios-star-outline";
		}
	};
	
	$rootScope.modalUserPhotoSlideHasChanged = function($scope, index){
		
		//log("modalUserPhotoSlideHasChanged. index ", index);
		
		$scope.currentPhotoIdx = index;
		$scope.currentPhoto = $scope.files[index].file;
		$scope.currentPhotoId = $scope.files[index].file.fileId;
		$scope.photoViewed[$scope.currentPhotoId] = true;
		
		if(index == $scope.files.length -1){
			//log("loadMorePhotos");
			$rootScope.loadMorePhotos($scope);
		}
	};
	
	$rootScope.modalUserShowPhotoVotes = function($scope){
		$scope.photoType = true;
		$ionicModal.fromTemplateUrl('templates/modal-video-votes.html', {
			id: "video_votes",
			scope: $scope,
			animation: 'slide-in-up',
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalVV = modal;
			$scope.modalVV.show();
		});
	};
	
	$rootScope.modalUserCloseVideoVotesModal = function($scope){
		$scope.modalVV.hide();
		$scope.modalVV.remove();
	};
	
	$rootScope.modalUserVoteFile = function($scope, vote){
		var templateString = "";
		if(vote == 10){
			templateString = $translate.instant('voto_10');
		} else if(vote == 9){
			templateString = $translate.instant('voto_9');
		} else if(vote == 8){
			templateString = $translate.instant('voto_8');
		} else if(vote == 7){
			templateString = $translate.instant('voto_7');
		} else if(vote == 6){
			templateString = $translate.instant('voto_6');
		} else if(vote == 5){
			templateString = $translate.instant('voto_5');
		} else if(vote == 4){
			templateString = $translate.instant('voto_4');
		} else if(vote == 3){
			templateString = $translate.instant('voto_3');
		} else if(vote == 2){
			templateString = $translate.instant('voto_2');
		} else if(vote == 1){
			templateString = $translate.instant('voto_1');
		}
		var confirmVote = $ionicPopup.confirm({
			title: $translate.instant('conferma_voto'),
			template: templateString,
			cancelText: $translate.instant('annulla')
		});
		confirmVote.then(function(res) {
			if(res) {
				
				$scope.closeVideoVotesModal();
				
				var deferred_fileVotes = $q.defer();
				var promise_fileVotes = deferred_fileVotes.promise;
				promise_fileVotes.then(function(result){
					$(result).find('file_vote').each(function (){
						var fc_id = $(this).find('id').text();
						if(fc_id != "0"){
							$ionicPopup.alert({
								title: $translate.instant('vota'),
								template: $translate.instant('vota_grazie')
							}).then(function(vres){
								try {
									if($scope.photoType){
										$rootScope.loadPhotos($scope, true);
									} else {
										$rootScope.loadVideos($scope, true);
									}
								} catch (e) {
									//alert("reload videos error");
								}
							});
						} else {
							$ionicPopup.alert({
								title: $translate.instant('vota'),
								template: $translate.instant('gia_votato')
							}).then(function(vres){
							});
						}
					});
				}, function(reason){
				});
				
				UserProfile.actFileVotes("add", $scope.photoType ? $scope.currentPhotoId : $scope.currentVideoId, vote, userUpiId, null, deferred_fileVotes);
			}
		});
	};
	
	$rootScope.modalUserShowPhotoComments = function($scope){
		$scope.photoType = true;
		$ionicModal.fromTemplateUrl('templates/modal-video-comments.html', {
			id: "video_comments",
			scope: $scope,
			animation: 'slide-in-right',
			focusFirstInput: false,
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalVC = modal;
			$scope.modalVC.show();
		});
	};
	
	$rootScope.modalUserCloseVideoCommentsModal = function($scope){
		$scope.showTA = false;
		$scope.modalVC.hide();
		$scope.modalVC.remove();
	};
	
	$rootScope.modalUserShowPreviousComments = function($scope){
		$scope.fileCommentsPage++;
		$rootScope.modalUserLoadFileComments($scope, false);
	};
	
	$rootScope.modalUserLoadFileComments = function($scope, scrollBottom){
		
//		log("modalUserLoadFileComments. $scope.showPrevComments: "+$scope.showPrevComments);
		
		if($scope.showPrevComments){
			var deferred_fileComments = $q.defer();
			var promise_fileComments = deferred_fileComments.promise;
			promise_fileComments.then(function(result){
				
				if($(result).find("file_comment").length < 5){
					$scope.showPrevComments = false;
				}
				$(result).find("file_comment").each(function(){
					//id, id_file, id_upi, file_user_id, user_image, user_nick, user_link, user_profile, comment, date
					var comment = {};
					comment.id = $(this).find("id").text();
					comment.user_nick = $(this).find("user_nick").text();
					comment.user_image = $(this).find("user_image").text();
					comment.id_upi = $(this).find("id_upi").text();
					comment.comment_text = $(this).find("comment").text();
					comment.comment_date = $(this).find("date").text();
					comment.app_approved = $(this).find("app_approved").text() == 'true' ? true : false;
					comment.profile_value_id = $(this).find("profile_value_id").text();
					$scope.comments.unshift(comment);
				});
				if(scrollBottom){
					$ionicScrollDelegate.$getByHandle('commentsModalScroll').scrollBottom(true);
				}
				
				if($scope.fileCommentsPage > 0){
					$scope.$broadcast('scroll.refreshComplete');
				}
			}, function(reason){
				log("comments err: "+reason);
			});
			
//			log("actFileComments. $scope.photoType: "+$scope.photoType+", $scope.currentPhotoId: "+$scope.currentPhotoId+", $scope.currentVideoId: "+$scope.currentVideoId+", $scope.fileCommentsPage: "+$scope.fileCommentsPage);
			
			UserProfile.actFileComments("list", $scope.photoType ? $scope.currentPhotoId : $scope.currentVideoId, null, null, $scope.fileCommentsPage, userUpiId, userId, deferred_fileComments);
		} else {
			$scope.$broadcast('scroll.refreshComplete');
		}
		
	};
	
	$rootScope.modalUserDeleteComment = function($scope, commentId){
		$ionicPopup.confirm({
			title: $translate.instant('elimina_commento'),
			template: $translate.instant('elimina_commento_conferma'),
			cancelText: $translate.instant('annulla')
		}).then(function(res) {
			if(res){
				
				var deferred_fileComments = $q.defer();
				var promise_fileComments = deferred_fileComments.promise;
				promise_fileComments.then(function(result){
					$('#comment_'+commentId).fadeOut();
					$scope.currentVideo.commentsCount = $scope.currentVideo.commentsCount-1;
				}, function(reason){
					log("comments err: "+reason);
				});
				UserProfile.actFileComments("del", null, commentId, null, null, null, null, deferred_fileComments);
				
			}
		});
	};
	
	$rootScope.autoExpand_ = function($scope) {
		if($scope.content_bottom == 0){
			$scope.content_bottom = $('#comment_content').css("bottom");
		}
		var comment_text = document.getElementById("comment_text");
		var scrollHeight = comment_text.scrollHeight;
		if(scrollHeight > 39){
			$('#comment_text').css("height", scrollHeight + "px");
			$('#comment_footer').css("height", scrollHeight + 10 + "px");
			var cnt_bottom = $scope.content_bottom;
			cnt_bottom = parseInt(cnt_bottom.replace("px",""));
			if($('#comment_footer').height() > $scope.footer_height){
				$('#comment_content').css("bottom", (cnt_bottom+($('#comment_footer').height() - $scope.footer_height))+'px');
			}
		}
	};
	
	$rootScope.modalUserFileComment = function($scope){
		
		var txt = $scope.commentText.value;
		$scope.commentText.value = "";

		var deferred_fileComments = $q.defer();
		var promise_fileComments = deferred_fileComments.promise;
		promise_fileComments.then(function(result){
			// reload last comments
			if($scope.photoType){
				$scope.currentPhoto.commentsCount = $scope.currentPhoto.commentsCount+1;
			} else {
				$scope.currentVideo.commentsCount = $scope.currentVideo.commentsCount+1;
			}
			$scope.showPrevComments = true;
			$scope.fileCommentsPage = 0;
			$scope.comments = [];
			$rootScope.modalUserLoadFileComments($scope, true);
		}, function(reason){
			log("comments err: "+reason);
		});
		
		UserProfile.actFileComments("add", $scope.photoType ? $scope.currentPhotoId : $scope.currentVideoId, null, txt, null, userUpiId, null, deferred_fileComments);
		
	};
	
	// PHOTO. fine
	
	// OCCHIOLINI. inizio
	$rootScope.sendWink = function($scope){
		var deferred_mud = $q.defer();
		var promise_mud = deferred_mud.promise;
		promise_mud.then(function(result){
			if(result != null && result.send_wink != null){
				if(result.send_wink == "black_list"){
					$ionicPopup.alert({
						title: $translate.instant('occhiolino'),
						template: $translate.instant('occhiolino_bloccato')
					});
				} else if(result.send_wink == "ok"){
					$ionicPopup.alert({
						title: $translate.instant('occhiolino'),
						template: $translate.instant('occhiolino_inviato')
					});
				} else {
					$ionicPopup.alert({
						title: $translate.instant('occhiolino'),
						template: $translate.instant('errore')
					});
				}
			} else {
				$ionicPopup.alert({
					title: $translate.instant('occhiolino'),
					template: $translate.instant('errore')
				});
			}
		}, function(reason){
		});
		ModalUser.sendWink(userId, $scope.selectedMUId, deferred_mud);
	};
	// OCCHIOLINI. fine
	
	// BLACKLIST. inizio
	$rootScope.addToBlacklist = function($scope, uidToAdd){
		$ionicPopup.confirm({
			title: $translate.instant('in_blacklist'),
			template: $translate.instant('in_blacklist_conferma'),
			cancelText: $translate.instant('annulla')
		}).then(function(res) {
			if(res){
				var deferred_blacklist = $q.defer();
				var promise_blacklist = deferred_blacklist.promise;
				promise_blacklist.then(function(result){
					if(result != null && result.result == "true"){
						$ionicPopup.alert({
							title: $translate.instant('in_blacklist'),
							template: $translate.instant('in_blacklist_ok')
						}).then(function(res){
							log("blacklist alert ok");
						});
					} else {
						$ionicPopup.alert({
							title: $translate.instant('in_blacklist'),
							template: $translate.instant('errore')
						}).then(function(res){
							log("blacklist alert ok");
						});
					}
				}, function(reason){
				});
				ModalUser.addToBlacklist(userId, uidToAdd, deferred_blacklist);
				
			}
		});
	};
	// BLACKLIST. fine
		
	// PREFERITI. inizio
	$rootScope.modalUserAddToFavorites = function($scope, uidToAdd){
		
		var deferred_favorites = $q.defer();
		var promise_favorites = deferred_favorites.promise;
		promise_favorites.then(function(result){
			if(result != null && result.add_to_favorites == "ok"){
				$ionicPopup.alert({
					title: $translate.instant('preferiti_aggiungi'),
					template: $translate.instant('preferiti_aggiunto')
				});
			} else {
				$ionicPopup.alert({
					title: $translate.instant('preferiti_aggiungi'),
					template: $translate.instant('preferiti_non_aggiunto')
				});
			}
		}, function(reason){
		});
		ModalUser.addToFavorites(userId, uidToAdd, deferred_favorites);
		/*
		$ionicPopup.confirm({
			title: 'Aggiungi ai preferiti',
			template: "Vuoi aggiungere l'utente ai tuoi preferiti?"
		}).then(function(res) {
			if(res){
			}
		});
		*/
	};
	// PREFERITI. fine
	
	// LAST MINUTE. inizio
	$rootScope.modalUserLastMinuteRequest = function($scope, lastMinuteId){
		
		log("modalUserLastMinuteRequest: "+lastMinuteId);
		
		$scope.lmRequest = {'value':"", lmid:lastMinuteId};
		$scope.lmrTextHeight = (($(window).height())*0.35)+'px';
		
		cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
		
		// mostra like/nolike
		$ionicModal.fromTemplateUrl('templates/modal-last-minute-request.html', {
			id: 'modal-last-minute-request',
			scope: $scope,
			animation: 'slide-in-up',
			focusFirstInput: true,
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalLMR = modal;
			$scope.modalLMR.show();
		});
	};
	
	$rootScope.modalUserSendLastMinuteRequest = function($scope){
		var deferred_lastminute = $q.defer();
		var promise_lastminute = deferred_lastminute.promise;
		promise_lastminute.then(function(result){
			if(result != null && result.last_minute_request == "ok"){
				$ionicPopup.alert({
					title: $translate.instant('last_minute'),
					template: $translate.instant('last_minute_richiesta')
				});
				$scope.modalLMR.hide();
				$scope.modalLMR.remove();
				$rootScope.modalUserSlideChanged_($scope, 2);
			}
		}, function(reason){
			$ionicPopup.alert({
				title: $translate.instant('last_minute'),
				template: $translate.instant('errore')
			});
		});
		ModalUser.sendLastMinuteRequest(userId, $scope.lmRequest.lmid, $scope.lmRequest.value, deferred_lastminute);
	};
	// LAST MINUTE. fine
	
	// INVITA TRA I TUOI AMICI. inizio
	$rootScope.modalUserAddFriend = function($scope, uid){
		if($scope.mud["modalData"+$scope.selectedMUId].user.profileValueId != null && $scope.mud["modalData"+$scope.selectedMUId].user.profileValueId == 51){
			// diventa amico subito
			$ionicPopup.confirm({
				title: $translate.instant('diventa_amico'),
				template: $translate.instant('diventa_amico_conferma')+" <font class='color-rosso'>"+$scope.mud["modalData"+$scope.selectedMUId].user.nick+"</font> ?",
				cancelText: $translate.instant('no'),
				okText: $translate.instant('si'),
			}).then(function(res) {
				if(res){
					var deferred_friend = $q.defer();
					var promise_friend = deferred_friend.promise;
					promise_friend.then(function(result){
						if($(result)[1].nextSibling.innerText.trim() == "0"){
							var deferred_friend_2 = $q.defer();
							var promise_friend_2 = deferred_friend_2.promise;
							promise_friend_2.then(function(result){
								if($(result)[1].nextSibling.innerText.trim() == "1"){
									$timeout(function(){
										$ionicPopup.alert({
											title: $translate.instant('diventa_amico'),
											template: $translate.instant('ora_sei_amico')+" <font class='color-rosso'>"+$scope.mud["modalData"+$scope.selectedMUId].user.nick+"</font>"
										}).then(function(res){
										});
									}, 600);
								} else {
									$timeout(function(){
										$ionicPopup.alert({
											title: $translate.instant('diventa_amico'),
											template: $translate.instant('errore')
										}).then(function(res){
										});
									}, 600);
								}
							}, function(reason){
							});
							Friends.addFan(userId, uid, deferred_friend_2);
						} else {
							$timeout(function(){
								$ionicPopup.alert({
									title: $translate.instant('diventa_amico'),
									template: $translate.instant('sei_gia_amico')+" <font class='color-rosso'>"+$scope.mud["modalData"+$scope.selectedMUId].user.nick+"</font>"
								}).then(function(res2){
								});
							}, 600);
						}
					}, function(reason){
					});
					Friends.checkFan(userId, uid, deferred_friend);
				}
			});
		} else {
			// invia richiesta amicizia
			$ionicPopup.confirm({
				title: $translate.instant('richiedi_amicizia'),
				template: $translate.instant('richiedi_amicizia_conferma')+" <font class='color-rosso'>"+$scope.mud["modalData"+$scope.selectedMUId].user.nick+"</font> ?",
				cancelText: $translate.instant('annulla'),
				okText: $translate.instant('invia_richiesta'),
			}).then(function(res) {
				if(res){
					var deferred_friend = $q.defer();
					var promise_friend = deferred_friend.promise;
					promise_friend.then(function(result){
						if(result != null && result.send_friendship_request == "ok"){
							$timeout(function(){
								$ionicPopup.alert({
									title: $translate.instant('richiedi_amicizia'),
									template: $translate.instant('richiedi_amicizia_ok')
								}).then(function(res){
								});
							}, 600);
						} else {
							$timeout(function(){
								$ionicPopup.alert({
									title: $translate.instant('richiedi_amicizia'),
									template: $translate.instant('errore')
								}).then(function(res){
								});
							}, 600);
						}
					}, function(reason){
					});
					Friends.addFriend(userId, uid, deferred_friend);
				}
			});
		}
	};
	// CONTROLLO + INVITA TRA I TUOI AMICI. fine
	
	// INVIA MESSAGGIO. inizio
	$rootScope.modalUserWriteMessage = function($scope, uid){
		if(window.StatusBar){
			StatusBar.styleDefault();
		}
		
		$scope.messageToSend = {subject:"", text:"", attachments: [], attachUploading: 0};
		$scope.messageTextHeight = (($(window).height()*0.9)*0.15)+'px';
		$scope.messageAttachHeight = (($(window).height() * 0.65) - 60)+'px';
		
		try {
			cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
		} catch (e) {
		}
		
		$ionicModal.fromTemplateUrl('templates/modal-message-write.html', {
			id: 'modal-message-write',
			scope: $scope,
			animation: 'slide-in-up',
			focusFirstInput: true,
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalMW = modal;
			$scope.modalMW.show();
		});
		
		$scope.closeModalMW = function() {
			$scope.messageToSend = null;
			$scope.modalMW.hide();
			$scope.modalMW.remove();
			try {
				cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
			} catch (e) {
			}
			if(window.StatusBar){
				StatusBar.styleBlackOpaque();
			}
		};
	};
	var attachmentsUploaded = [];
	$rootScope.modalSendMessageAttachment = function($scope){
		if($scope.messageToSend.attachments.length-1 >= $scope.messageToSend.attachUploadIdx){
			var attach = $scope.messageToSend.attachments[$scope.messageToSend.attachUploadIdx];
			var params = {};
			params.uid = userId;
			params.fn = attach.uri.substr(attach.uri.lastIndexOf('/') + 1);
			params.img = attach.type == "pic" ? 1 : 0;
			var options = new FileUploadOptions();
			options.fileName = params.fn;
			options.params = params;
			var ft = new FileTransfer();
			ft.onprogress = function(progressEvent) {
				if (progressEvent.lengthComputable) {
					$('#upload_progress_'+attach.id).css("width", ((progressEvent.loaded / progressEvent.total)*100)+"%");
				} else {
				}
			};		
			ft.upload(attach.uri, encodeURI("https://www.erosland.it/erosland_app_upload_attachment.php?uid="+userId+"&fn="+params.fn+"&img="+params.img), 
				function(r){
					if(r.response != "error_move" && r.response != "error_params"){
						attachmentsUploaded.push(r.response);
					}
					$scope.messageToSend.attachUploadIdx++;
					$rootScope.modalSendMessageAttachment($scope);
				},
				function(r){
					log("Message attachment upload error: "+error);
				},
				options
			);
		} else {
			$rootScope.modalSendMessage_($scope);
		}
	};
	$rootScope.modalUserSendMessage = function($scope){
		$scope.messageToSend.sending = true;
		attachmentsUploaded = [];
		// controllo allegati
		if($scope.messageToSend.attachments != null && $scope.messageToSend.attachments.length > 0){
			$scope.messageToSend.attachUploadIdx = 0;
			$scope.messageToSend.attachUploading = 1;
			$rootScope.modalSendMessageAttachment($scope);
		} else {
			$rootScope.modalSendMessage_($scope);
		}
		
	};
	$rootScope.modalSendMessage_ = function($scope){
		
		var deferred_messages = $q.defer();
		var promise_messages = deferred_messages.promise;
		promise_messages.then(function(result){
			$scope.messageToSend.sending = false;
			$scope.messageToSend.attachUploading = 0;
			$scope.messageToSend.subject = "";
			$scope.messageToSend.text = "";
			$scope.messageToSend.attachments = [];
			
			$scope.closeModalMW();
			$timeout(function(){
				$ionicPopup.alert({
					title: $translate.instant('invia_messaggio'),
					template: $translate.instant('messaggio_inviato')
				}).then(function(res) {
				});
			},600);
			
		}, function(reason){
		});
		Messages.sendNewMessage(userId, $scope.selectedMUId, $scope.messageToSend.subject, $scope.messageToSend.text, attachmentsUploaded.toString(), deferred_messages);

	};
	$rootScope.modalUserSelectAttachments = function($scope){
		$ionicActionSheet.show({
			buttons: [{text: $translate.instant('scatta_foto')},{text: $translate.instant('fai_video')},{text: $translate.instant('scegli_foto_esistente')},{text: $translate.instant('scegli_video_esistente')}],
			titleText: $translate.instant('allega_foto_video'),
			cancelText: $translate.instant('chiudi'),
			cancel: function() {
				// add cancel code..
			},
			buttonClicked: function(index) {
				if(index == 0){
					$scope.messageAttachPhoto();
				} else if(index == 1){
					$scope.messageAttachVideo();
				} else if(index == 2){
					$scope.messageAttachPhotoLibrary();
				} else if(index == 3){
					$scope.messageAttachVideoLibrary();
				}
				return true;
			}
		});
	};
	// INVIA MESSAGGIO. fine

	// TRA DI NOI. inizio
	
	var busListener = false;
	
	$rootScope.busChatDate = function(time){
		var chat_date = new Date(time*1000);
		return (chat_date.getDate() + "-" + (chat_date.getMonth()+1) + "-" + chat_date.getFullYear() + " " +  chat_date.toLocaleTimeString()).replace("CEST","");
	};
	
	$rootScope.showBetweenUsData = function($scope){
		var deferred_mud = $q.defer();
		var promise_mud = deferred_mud.promise;
		promise_mud.then(function(result){
			
			if($scope.busData.interactionType == 1){
				
				if($scope.busData.page1 == 0){
					if(result.interactions != null && result.interactions.length > 0){
						$('.bus_messages_no_results').hide();
						$scope.busData.interactions_messages = result.interactions;
					} else {
						$('.bus_messages_no_results').show();
					}
				} else {
					$scope.busData.interactions_messages = $scope.busData.interactions_messages.concat(result.interactions);
				}
				
				if(result != null && result.interactions.length==10){
					$('#bus_other_messages').show();
				}
				
				
			} else if($scope.busData.interactionType == 2){
				
				if($scope.busData.page2 == 0){
					if(result.interactions != null && result.interactions.length > 0){
						$('.bus_shorts_no_results').hide();
						$scope.busData.interactions_shorts = result.interactions;
					} else {
						$('.bus_shorts_no_results').show();
					}
				} else {
					$scope.busData.interactions_shorts = $scope.busData.interactions_shorts.concat(result.interactions);
				}
				
				if(result != null && result.interactions.length==10){
					$('#bus_other_shorts').show();
				}

			} else if($scope.busData.interactionType == 3){
				
				if($scope.busData.page3 == 0){
					if(result.interactions != null && result.interactions.length > 0){
						$('.bus_winks_no_results').hide();
						$scope.busData.interactions_winks = result.interactions;
					} else {
						$('.bus_winks_no_results').show();
					}
				} else {
					$scope.busData.interactions_winks = $scope.busData.interactions_winks.concat(result.interactions);
				}
				
				if(result != null && result.interactions.length==10){
					$('#bus_other_winks').show();
				}
				
			} else if($scope.busData.interactionType == 4){
				
				if($scope.busData.page4 == 0){
					if(result.chat_history != null && result.chat_history.length > 0){
						$('.bus_chat_no_results').hide();
						
						$scope.busData.interactions_chat = [];
						for ( var cht = 0; cht < result.chat_history.length; cht++) {
							$scope.busData.interactions_chat.unshift(result.chat_history[cht]);
						}
						$scope.busData.last_chat_time = result.chat_history[result.chat_history.length-1].message.time;
						
					} else {
						$('.bus_chat_no_results').show();
					}
					
				} else {
					
					for ( var cht = 0; cht < result.chat_history.length; cht++) {
						$scope.busData.interactions_chat.unshift(result.chat_history[cht]);
					}
					$scope.busData.last_chat_time = result.chat_history[result.chat_history.length-1].message.time;
				}
				
				if(result != null && result.chat_history.length>0){
					if(result.chat_history.length==10){
						$('#bus_other_chat').show();
					}
				}

			}
			
		}, function(reason){
		});
		
		var page = 0;
		if($scope.busData.interactionType == 1){
			$scope.busData.interactionTypeTitle = $translate.instant('messaggi');
			page = $scope.busData.page1;
		} else if($scope.busData.interactionType == 2){
			$scope.busData.interactionTypeTitle = $translate.instant('shorts');
			page = $scope.busData.page2;
		} else if($scope.busData.interactionType == 3){
			$scope.busData.interactionTypeTitle = $translate.instant('occhiolini');
			page = $scope.busData.page3;
		} else if($scope.busData.interactionType == 4){
			$scope.busData.interactionTypeTitle = $translate.instant('chat');
			page = $scope.busData.page4;
		}
		
		ModalUser.getInteractions(userId, $scope.selectedMUId, $scope.busData.interactionType, page, $scope.busData.last_chat_time, deferred_mud);
	};
	
	$rootScope.showBetweenUsMore = function($scope){

		if($scope.busData.interactionType == 1){
			$('#bus_other_messages').hide();
			$scope.busData.page1++;
		} else if($scope.busData.interactionType == 2){
			$('#bus_other_shorts').hide();
			$scope.busData.page2++;
		} else if($scope.busData.interactionType == 3){
			$('#bus_other_winks').hide();
			$scope.busData.page3++;
		} else if($scope.busData.interactionType == 4){
			$('#bus_other_chat').hide();
			$scope.busData.page4++;
		}
		
		$rootScope.showBetweenUsData($scope);
	};
	
	$rootScope.closeModalPersonallyMet = function($scope){
		$scope.modalPM.hide();
		$scope.modalPM.remove();
		$scope.pmData = null;
	};
	
	$rootScope.getPersonallyMetProfile = function(uc){
		var user_profile = "";
		if(uc.uc_u_profile_value_id > 41){
			user_profile = uc.uc_profile != null ? uc.uc_profile.split("|")[0] : "";
		} else if(uc.uc_u_profile_value_id == 4){
			user_profile = "<font class='color-blu'>"+(uc.uc_u_age1 > 0 ? uc.uc_u_age1 : "")+"</font>";
		} else if(uc.uc_u_profile_value_id == 5){
			user_profile = "<font class='color-rosa'>"+(uc.uc_u_age1 > 0 ? uc.uc_u_age1 : "")+"</font>";
		} else if(uc.uc_u_profile_value_id == 6){
			user_profile = "<font class='color-blu'>"+(uc.uc_u_age1 > 0 ? uc.uc_u_age1 : "")+"</font>";
			user_profile += "&nbsp;&nbsp;<font class='color-rosa'>"+(uc.uc_u_age2 > 0 ? uc.uc_u_age2 : "")+"</font>";
		} else if(uc.uc_u_profile_value_id == 7){
			user_profile = "<font class='color-blu'>"+(uc.uc_u_age1 > 0 ? uc.uc_u_age1 : "")+"</font>";
			user_profile += "&nbsp;&nbsp;<font class='color-blu'>"+(uc.uc_u_age2 > 0 ? uc.uc_u_age2 : "")+"</font>";
		} else if(uc.uc_u_profile_value_id == 9){
			user_profile = "<font class='color-rosa'>"+(uc.uc_u_age1 > 0 ? uc.uc_u_age1 : "")+"</font>";
			user_profile += "&nbsp;&nbsp;<font class='color-rosa'>"+(uc.uc_u_age2 > 0 ? uc.uc_u_age2 : "")+"</font>";
		}
		return user_profile;
	};
	
	$rootScope.modalListMorePersonallyMet = function($scope, pmData){
		var deferred_personallyMet = $q.defer();
		var promise_personallyMet = deferred_personallyMet.promise;
		promise_personallyMet.then(function(result){
			if($scope.pmData.pmpage > 0){
				$scope.pmData.pml = $scope.pmData.pml.concat(result.user_contact.list);
				$scope.$broadcast('scroll.infiniteScrollComplete');
			} else {
				$scope.pmData.pml = result.user_contact.list;
			}
			if(result.user_contact.list == null || result.user_contact.list.length < 10){
				$scope.pmData.showLoadMorePersonallyMet = false;
			} else {
				$scope.pmData.showLoadMorePersonallyMet = true;
			}
			$scope.pmData.isLoading = false;
		}, function(reason){
		});
		if(!$scope.pmData.isLoading){
			$scope.pmData.isLoading = true;
			$scope.pmData.pmpage++;
			PersonallyMet.list($scope.selectedMUId, $scope.pmData.pmpage, deferred_personallyMet);
		}
	};

	$rootScope.showPersonallyMet = function($scope){
		$scope.pmMD = "modalData"+$scope.selectedMUId;
		$scope.pmData = {isLoading: false, pmpage: 0, pml: $scope.mud["modalData"+$scope.selectedMUId].personallyMetList, pmc: $scope.mud["modalData"+$scope.selectedMUId].personallyMetCnt, showLoadMorePersonallyMet: $scope.mud["modalData"+$scope.selectedMUId].personallyMetList.length == 10, pmReq: userId!=$scope.selectedMUId}; // myUD: myUserData, 
		$ionicModal.fromTemplateUrl('templates/modal-personally-met.html', {
			id: "personally-met",
			scope: $scope,
			animation: 'slide-in-up',
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalPM = modal;
			$scope.modalPM.show();
		});
		
		if(userId!=$scope.selectedMUId){
			
			$scope.pmData.pmReq = false;
			
			var deferred_friends = $q.defer();
			var promise_friends = deferred_friends.promise;
			promise_friends.then(function(result){
				if(result.are_friends == "true"){
					var deferred_personallyMet = $q.defer();
					var promise_personallyMet = deferred_personallyMet.promise;
					promise_personallyMet.then(function(result){
						$scope.pmData.pmReq = result.user_contact != null && result.user_contact == "check_false";
					}, function(reason){
					});
					PersonallyMet.check(userId, $scope.selectedMUId, deferred_personallyMet);
				}
				
			}, function(reason){
			});
			Friends.areFriends(userId, $scope.selectedMUId, deferred_friends);
		}
		
	};
	
	$rootScope.personallyMetRequest = function($scope){
		$ionicPopup.confirm({
			title: $translate.instant('conosci_di_persona'),
			template: $translate.instant('conosciuti_di_persona_conferma_richiesta'),
			cancelText: $translate.instant('annulla')
		}).then(function(res) {
			if(res){
				$rootScope.closeModalPersonallyMet($scope);
				
				/*
				$timeout(function(){
					var deferred_personallyMet = $q.defer();
					var promise_personallyMet = deferred_personallyMet.promise;
					promise_personallyMet.then(function(result){
						if(result.user_contact != null && result.user_contact == "add_ok"){
							$ionicPopup.alert({
								title: $translate.instant('conosci_di_persona'),
								template: $translate.instant('conosci_di_persona_richiesta_inviata')
							}).then(function(abuse_res) {
							});
						}
					}, function(reason){
					});
					PersonallyMet.add(userId, $scope.selectedMUId, deferred_personallyMet);
				}, 500);
				*/
				
				$timeout(function(){
					$ionicPopup.alert({
						title: $translate.instant('conosci_di_persona'),
						template: $translate.instant('conosci_di_persona_richiesta_inviata')
					}).then(function(abuse_res) {
					});
				}, 1000);
			}
		});
	};

	$rootScope.showBetweenUs = function($scope){
		
		$ionicLoading.show({
			template: '<ion-spinner icon="circles" class="spinner-bianco"></ion-spinner>'
		});
		
		$scope.busMD = "modalData"+$scope.selectedMUId;
		$scope.busData = {busView:[], page1:0, page2:0, page3:0, page4:0, interactionType:1, interactionTypeTitle:$translate.instant('messaggi'), last_chat_time: 0, myUid: userId, myUD: myUserData};

		$ionicModal.fromTemplateUrl('templates/modal-between-us.html', {
			id: "between-us",
			scope: $scope,
			animation: 'slide-in-up',
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalBU = modal;
			/*
			if(!busListener){
				busListener = true;
				$scope.$on('modal.shown', function(event, modal){
					log("modalBU modal.shown: "+modal.id);
					$(".bus-slider").find(".slider-pager-page").eq(0).find("i").removeClass("ion-record").addClass("ion-chatbubbles");
					$(".bus-slider").find(".slider-pager-page").eq(1).find("i").removeClass("ion-record").addClass("ion-chatbox-working");
					$(".bus-slider").find(".slider-pager-page").eq(2).find("i").removeClass("ion-record").addClass("ion-ios-paper-outline");
					$(".bus-slider").find(".slider-pager-page").eq(3).find("i").removeClass("ion-record").addClass("ion-eye");
					
					$scope.busData.busView[0] = true;
					$rootScope.showBetweenUsData($scope);
					
				});
			}
			*/
			$scope.modalBU.show();
			
			setTimeout(function(){
				log("modalBU modal.shown: "+modal.id);
				$(".bus-slider").find(".slider-pager-page").eq(0).find("i").removeClass("ion-record").addClass("ion-chatbubbles");
				$(".bus-slider").find(".slider-pager-page").eq(1).find("i").removeClass("ion-record").addClass("ion-chatbox-working");
				$(".bus-slider").find(".slider-pager-page").eq(2).find("i").removeClass("ion-record").addClass("fa fa-align-left").css("font-size","80%");
				$(".bus-slider").find(".slider-pager-page").eq(3).find("i").removeClass("ion-record").addClass("ion-eye");
				
				$scope.busData.busView[0] = true;
				$rootScope.showBetweenUsData($scope);
				
				$ionicLoading.hide();
				
				$ionicSlideBoxDelegate.$getByHandle('busSlideBox').enableSlide(false);
				
			}, 500);
			
		});
		
	};
	
	$rootScope.closeModalBetweenUs = function($scope){
		$scope.modalBU.hide();
		$scope.modalBU.remove();
		$scope.busData = null;
		busListener = false;
	};
	
	$rootScope.busGoToSlide = function(index){
		$ionicSlideBoxDelegate.$getByHandle('busSlideBox').slide(index);
	};
	
	$rootScope.busSlideChanged = function($scope, index){
		
		if(index == 0){
			$scope.busData.interactionTypeTitle = $translate.instant('messaggi');
			$scope.busData.interactionType = 1;
			if(!$scope.busData.busView[index]){
				$scope.busData.busView[index] = true;
				$scope.busData.page = 0;
				$rootScope.showBetweenUsData($scope);
			}
		} else if(index == 1){
			$scope.busData.interactionTypeTitle = $translate.instant('chat');
			$scope.busData.interactionType = 4;
			if(!$scope.busData.busView[index]){
				$scope.busData.busView[index] = true;
				$scope.busData.page = 0;
				$rootScope.showBetweenUsData($scope);
			}
		} else if(index == 2){
			$scope.busData.interactionTypeTitle = $translate.instant('shorts');
			$scope.busData.interactionType = 2;
			if(!$scope.busData.busView[index]){
				$scope.busData.busView[index] = true;
				$scope.busData.page = 0;
				$rootScope.showBetweenUsData($scope);
			}
		} else if(index == 3){
			$scope.busData.interactionTypeTitle = $translate.instant('occhiolini');
			$scope.busData.interactionType = 3;
			if(!$scope.busData.busView[index]){
				$scope.busData.busView[index] = true;
				$scope.busData.page = 0;
				$rootScope.showBetweenUsData($scope);
			}
		}
	};
	
	$rootScope.busMessageDetail = function($scope, message){
		if(message.count_r > 0){
			
			$ionicLoading.show({
				template: '<ion-spinner icon="circles" class="spinner-bianco"></ion-spinner>'
			});
			
			$scope.bmd = {};
			$scope.bmd.message = message;
			
			var deferred_mud = $q.defer();
			var promise_mud = deferred_mud.promise;
			promise_mud.then(function(result){
				
				$scope.bmd.resp_messages = result.message_detail;
				
				$ionicModal.fromTemplateUrl('templates/modal-bus-message-detail.html', {
					id: "bus-message-detail",
					scope: $scope,
					animation: 'slide-in-up',
					hardwareBackButtonClose: false
				}).then(function(modal) {
					$scope.modalBMD = modal;
					$scope.modalBMD.show();
					$ionicLoading.hide();
				});
				
			}, function(reason){
			});
			ModalUser.getMessageDetail(message.id, deferred_mud);
		}
	};
	
	$rootScope.closeBusMessageDetail = function($scope){
		$scope.modalBMD.hide();
		$scope.modalBMD.remove();
		$scope.bmd = null;
	};
	
	/*
	 * ---------------------------------------------
	 * MODAL USER (global). FINE
	 */
	
	/*
	 * SEGNALAZIONE ABUSI. INIZIO
	 * ---------------------------------------------
	 */

	$rootScope.abuseReport = function(object_id, object_type, sender_id, message){
		var deferred_abuse = $q.defer();
		var promise_abuse = deferred_abuse.promise;
		promise_abuse.then(function(result){
			$ionicPopup.alert({
				title: $translate.instant('segnalazione_abuso'),
				template: $translate.instant('segnalazione_inviata')
			}).then(function(abuse_res) {
			});
		}, function(reason){
		});
		Abuse.report(object_id, object_type, sender_id, message, deferred_abuse);
	};
	
	$rootScope.reportAbuse_ = function($scope){
		try {
			cordova.plugins.Keyboard.disableScroll(false);
			cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
		} catch (e) {
		}
		
		$scope.abuse = {};
		
		$ionicPopup.show({
			title: $translate.instant('segnalazione_abuso'),
			templateUrl: 'templates/popup-abuse.html',
			scope: $scope,
			buttons: 
			[{
				text: $translate.instant('annulla')
			},
			{
				text: '<b>'+$translate.instant('Invia')+'</b>',
				type: 'button-positive',
				onTap: function(e) {
					return $scope.abuse.text;
				}
			}]
		}).then(function(res) {
			
			try {
				cordova.plugins.Keyboard.disableScroll(true);
				cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
			} catch (e) {
			}
			
			if(res){
				
				setTimeout(function(){
					if($scope.abuseShortId != null){
						$rootScope.abuseReport($scope.abuseShortId, "shorts", userId, res);
					} else {
						$rootScope.abuseReport($scope.abusePhoto ? $scope.currentPhotoId : $scope.currentVideoId, "file", userId, res);
					}
				}, 500);
			}
			
		});
	};
	
	/*
	 * ---------------------------------------------
	 * SEGNALAZIONE ABUSI. FINE
	 */
	
	
})

.directive('imageonload', function() {
	return {
		restrict: 'A',
		link: function(scope, element, attrs) {
			element.bind('load', function() {
				//log('image is loaded', attrs.id);
				$('#loading_'+attrs.id).hide();
				$('#'+attrs.id).fadeIn();
			});
		}
	};
})

.directive('showFocus', function($timeout) {
	return function(scope, element, attrs) {
		scope.$watch(attrs.showFocus, 
		function (newValue) { 
			$timeout(function() {
				newValue && element[0].focus();
			});
		},true);
	};
})

.directive('a', function () {
	return {
		restrict: 'E',
		link: function (scope, element, attrs) {
			if ( !attrs.href ){
				return;
			}
			var url = attrs.href;
			if ( url.lastIndexOf('http',0) === 0 ){
				element.on('click',function(e){
					e.preventDefault();
					if(attrs.ngClick){
						scope.$eval(attrs.ngClick);
					}
					
					var eventId = url.match(/.*event[^\/]?\/[0-9]+_([0-9]+)\//);
					if(eventId == null){
						eventId = url.match(/.*eventi\/[0-9]+\/[0-9]+_([0-9]+)\//);
					}
					
					if(eventId != null){
						scope.showEvent(eventId[1]);
					} else {
						window.open(encodeURI(url), '_system');
					}
				});
			};
		}
	};
});