angular.module('ctrl.eventinvites', [])

.controller('EventInvitesCtrl', function($scope, $q, $rootScope, $state, $ionicScrollDelegate, $ionicSideMenuDelegate, EventInvites, $ionicModal, Events, $ionicLoading, $translate) {
	
	$rootScope.lastMinuteView = false;
	
	$scope.lineWidth = ($(window).width()-80)+'px';
	
	$scope.eventInvitePage = 0;
	
	$scope.showLoadMoreEventInvites = false;
	
	$scope.listEventInvites = function(){
		var deferred_evt = $q.defer();
		var promise_evt = deferred_evt.promise;
		promise_evt.then(function(result){
			if($scope.eventInvitePage > 0){
				$scope.evt_list = $scope.evt_list.concat(result.event_invites);
				$scope.$broadcast('scroll.infiniteScrollComplete');
			} else {
				$scope.evt_list = result.event_invites;
				$ionicScrollDelegate.$getByHandle('eventInviteScroller').scrollTop(false);
			}
			if(result.event_invites == null || result.event_invites.length < 10){
				$scope.showLoadMoreEventInvites = false;
			} else {
				$scope.showLoadMoreEventInvites = true;
			}
			
		}, function(reason){
		});
		EventInvites.list(userId, $scope.eventInvitePage, deferred_evt);
	};
	
	$scope.listMoreEventInvites = function(){
		$scope.eventInvitePage = $scope.eventInvitePage+1;
		$scope.listEventInvites();
	};
	
	$scope.listEventInvites();
	
	$scope.evtYes = function(ei){
		$('#evt_loading_'+ei.eid).show();
		$('#evt_decision_'+ei.eid).hide();
		var deferred_evt = $q.defer();
		var promise_evt = deferred_evt.promise;
		promise_evt.then(function(result){
			if(result.event_join == "ok"){
				ei.evt_yes = true;
				ei.evt_no = false;
				ei.evt_maybe = false;
				$('#evt_loading_'+ei.eid).hide();
				$('#evt_decision_'+ei.eid).show();
			}
		}, function(reason){
		});
		EventInvites.eventJoin(userId, ei.event_id, "T", "F", "F", deferred_evt);
	};
		
	$scope.evtNo = function(ei){
		$('#evt_loading_'+ei.eid).show();
		$('#evt_decision_'+ei.eid).hide();
		var deferred_evt = $q.defer();
		var promise_evt = deferred_evt.promise;
		promise_evt.then(function(result){
			if(result.event_join == "ok"){
				ei.evt_yes = false;
				ei.evt_no = true;
				ei.evt_maybe = false;
				$('#evt_loading_'+ei.eid).hide();
				$('#evt_decision_'+ei.eid).show();
			}
		}, function(reason){
		});
		EventInvites.eventJoin(userId, ei.event_id, "F", "T", "F", deferred_evt);
	};
	
	$scope.evtMaybe = function(ei){
		$('#evt_loading_'+ei.eid).show();
		$('#evt_decision_'+ei.eid).hide();
		var deferred_evt = $q.defer();
		var promise_evt = deferred_evt.promise;
		promise_evt.then(function(result){
			if(result.event_join == "ok"){
				ei.evt_yes = false;
				ei.evt_no = false;
				ei.evt_maybe = true;
				$('#evt_loading_'+ei.eid).hide();
				$('#evt_decision_'+ei.eid).show();
			}
		}, function(reason){
		});
		EventInvites.eventJoin(userId, ei.event_id, "F", "F", "T", deferred_evt);
	};
	
	$scope.evtIgnore = function(eid){
		$('#evt_loading_'+eid).show();
		$('#evt_decision_'+eid).hide();
		var deferred_evt = $q.defer();
		var promise_evt = deferred_evt.promise;
		promise_evt.then(function(result){
			if(result.event_invite_delete == "ok"){
				$('#ei_'+eid).fadeOut();
				$scope.checkEventInvites();
			} else {
				alert($translate.instant("errore"));
				$('#evt_loading_'+eid).hide();
				$('#evt_decision_'+eid).show();
			}
		}, function(reason){
		});
		EventInvites.deleteInvite(eid, deferred_evt);
	};
	
	$(document).off('refreshInvites').on('refreshInvites', function(evt, data){
		$scope.eventInvitePage = 0;
		$scope.showLoadMoreEventInvites = false;
		$scope.listEventInvites();
	});

	if(window.StatusBar){
		StatusBar.show();
	}
});