angular.module('ctrl.events', [])

.controller('EventsCtrl', function($state, $scope, $compile, Events, $q, $filter, $ionicModal, $ionicScrollDelegate, UserProfile, $ionicLoading, $rootScope, $ionicSideMenuDelegate, $translate, $timeout) {
	
	$rootScope.lastMinuteView = false;
	
	try {
		cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
	} catch (e) {
	}
	
	var search_radius = 50000;
	var circle_bounds;
	var sqr_lat1;
	var sqr_lng1;
	var sqr_lat2;
	var sqr_lng2;
	var rectangle = null;
	var markerIndex = 0;
	var userMarkers = {};
	var currentLat;
	var currentLng;
	var infowindow_;
	var map = null;
	//var myinfowindow;
	
	$scope.evt = {dateStr: new Date(), distance: 50}; // $filter('date')(new Date(), "yyyy-MM-dd") // (new Date()).toLocaleString()
	
	$scope.mapHeight = ($(window).height() - $('#event_search_form').height() - 88);
	
	$scope.getMyLocationEvents_ = function(my_position){
		
		if(my_position != null && my_position.coords != null && my_position.coords.latitude != null && my_position.coords.longitude != null){
			//alert("LocationEvents: "+my_position.coords.latitude+", "+my_position.coords.longitude);
						
			try {
				search_radius = $scope.evt.distance * 1000;
				currentLat = my_position.coords.latitude;
				currentLng = my_position.coords.longitude;
				
				var myLatLng = new google.maps.LatLng(currentLat, currentLng);
				
				if(map == null){
					map = new google.maps.Map(document.getElementById('map_canvas'), {
						zoom: 8,
						center: myLatLng,
						mapTypeId: google.maps.MapTypeId.ROADMAP,
						disableDefaultUI: true,
						overviewMapControl: false
					});
				} else {
					map.setCenter(myLatLng);
				}
				
				circle_bounds = new google.maps.Circle({center: myLatLng, radius: search_radius}).getBounds();
				if(rectangle != null){
					rectangle.setMap(map);
					rectangle.setBounds(circle_bounds);
				} else {
					rectangle = new google.maps.Rectangle({
						strokeColor: '#999999',
						strokeOpacity: 1,
						strokeWeight: 0.5,
						fillColor: '#000000',
						fillOpacity: 0.1,
						map: map,
						bounds: circle_bounds
					});
				}
				
				sqr_lat1 = circle_bounds.getNorthEast().lat();
				sqr_lng1 = circle_bounds.getNorthEast().lng();
				sqr_lat2 = circle_bounds.getSouthWest().lat();
				sqr_lng2 = circle_bounds.getSouthWest().lng();
				
				var deferred_events = $q.defer();
				var promise_events = deferred_events.promise;
				promise_events.then(function(result){
					if(userMarkers != null){
						for (var m_uid in userMarkers) {
					    	var user_marker = userMarkers[m_uid];
					    	user_marker.setMap(null);
						}
					}
					if(result != null && result.event_geolocations != null && result.event_geolocations.length > 0){
						for(var eg = 0; eg < result.event_geolocations.length; eg++){
							var event_gl = result.event_geolocations[eg]["event_gl"];
							var latlng_ = new google.maps.LatLng(event_gl["latitude"], event_gl["longitude"]);
							infowindow_ = new google.maps.InfoWindow();
							var user_avatar = "";
							if(event_gl['app_approved']){
								user_avatar = "<img src='https://www.erosland.it"+event_gl['avatar']+"' height='40px' />";
							} else if(!event_gl['app_approved'] && event_gl['profile_value_id'] == 6){
								user_avatar = '<div class="app-approved-30-map-c"><i class="ion-person color-blu"></i><i class="ion-person color-rosa app-approved-30-map-c-2"></i></div>';
							} else if(!event_gl['app_approved'] && event_gl['profile_value_id'] == 7){
								user_avatar = '<div class="app-approved-30-map-c"><i class="ion-person color-blu"></i><i class="ion-person color-blu app-approved-30-map-c-2"></i></div>';
							} else if(!event_gl['app_approved'] && event_gl['profile_value_id'] == 9){
								user_avatar = '<div class="app-approved-30-map-c"><i class="ion-person color-rosa"></i><i class="ion-person color-rosa app-approved-30-map-c-2"></i></div>';
							} else if(!event_gl['app_approved'] && event_gl['profile_value_id'] == 4){
								user_avatar = '<div class="app-approved-30-map-s"><i class="ion-person color-blu"></i></div>';
							} else if(!event_gl['app_approved'] && event_gl['profile_value_id'] == 5){
								user_avatar = '<div class="app-approved-30-map-s"><i class="ion-person color-rosa"></i></div>';
							} else if(!event_gl['app_approved'] && event_gl['profile_value_id'] == 42){
								user_avatar = '<div class="app-approved-30-map-g"><i class="ion-ios-people color-grigio-scuro"></i></div>';
							} else if(!event_gl['app_approved'] && event_gl['profile_value_id'] == 50){
								user_avatar = '<div class="app-approved-30-map-s"><i class="ion-person color-grigio-scuro"></i></div>';
							} else if(!event_gl['app_approved']){
								user_avatar = '<div class="app-approved-30-map-s"><i class="ion-person color-rosso"></i></div>';
							}
							var link = event_gl["event_html"].match(/href='[^']+'/);
							link = link[0].replace("href='", "").replace("'", "");
							var event_html = "<div style='width: 250px; line-height: normal ! important'>" +
								"<a href='https://www.erosland.it"+link+"' style='text-decoration: none;'>"+
									"<div style='display: flex; align-items: center;'>"+
										"<div style='margin-right: 10px;' class='user-avatar circle-40'>"+user_avatar+"</div>" +
										"<div>" +
											"<div class='color-rosso'>"+
												event_gl['nick'] +
											"</div>"+
											"<div style='margin-top: 3px;' class='color-grigio'>" +
												event_gl['hour'] +
											"</div>" +
										"</div>" +
									"</div>"+
									"<div class='color-nero' style='margin-top: 5px;'>" +
										event_gl['name'] +
									"</div>" +
								"</a>"+
							"</div>";
							
							var marker_ = new google.maps.Marker({
								id: event_gl['eid'],
								position: latlng_,
								map: map,
								title: event_gl["name"],
								html: $compile(event_html)($scope)[0],
								icon: "https://www.erosland.it/img/map_marker_blu.png"
							});
							marker_.setZIndex(0);
							userMarkers[event_gl["eid"]] = marker_;
							google.maps.event.addListener(marker_, 'click', (function(marker_) {
								//log("click marker listener ", marker_);
								return function() {
									//log("click marker", marker_);
									infowindow_.setContent(this.html);
									infowindow_.open(map, marker_);
									//myinfowindow.close();
									//$('.gm-style-iw').css("width", "260px").css("height","90px").css("overflow","hidden");
								}
							})(marker_));
							
						}
					}
					
				}, function(reason){
				});
				//var dateTime = new Date($scope.evt.dateStr).getTime();
				var dateTime = $scope.evt.dateStr.getTime();
				//var dateTime = new Date().getTime();
				Events.getEvents(sqr_lat1, sqr_lat2, sqr_lng1, sqr_lng2, dateTime, deferred_events);
				//Marker + infowindow + angularjs compiled ng-click
				var contentString = "<div></div>";
				var compiled = $compile(contentString)($scope);
				var infowindow = new google.maps.InfoWindow({
					content: compiled[0]
				});
				var marker = new google.maps.Marker({
					position: myLatLng,
					map: map,
					title: $translate.instant('mia_posizione')
				});
				google.maps.event.addListener(marker, 'click', function() {
					infowindow.open(map,marker);
				});
			} catch (e) {
				//$ionicLoading.hide();
				//alert("error: "+e);
			}
		}
		
	};
	
	$scope.getMyLocationEvents = function() {
		
		var my_geoloc_status = JSON.parse(localStorage.getItem("my_geolocation_status"));
		
		if(my_geoloc_status != null && my_geoloc_status.latitude != null && my_geoloc_status.longitude != null){
			//alert("set event map my_geolocation_status");
			$scope.getMyLocationEvents_({coords:{latitude:my_geoloc_status.latitude, longitude:my_geoloc_status.longitude}});
		}
		
		$rootScope.diagnosticGPS(true);
		
		/*
		$ionicLoading.show({
			template: '<ion-spinner icon="circles" class="spinner-bianco"></ion-spinner>'
		});
		*/
		
		$timeout(function(){
			navigator.geolocation.getCurrentPosition(function(geo_position) {
				if(geo_position != null && geo_position.coords != null && geo_position.coords.latitude != null && geo_position.coords.longitude != null){
					$scope.getMyLocationEvents_(geo_position);
				}
			}, function(error) {
				//$ionicLoading.hide();
				//alert("position: no gps. error: "+JSON.stringify(error));
			});
		},1000);
		
	};
	
	setTimeout(function(){$scope.getMyLocationEvents()}, 1000);
	
	$scope.showEvent_ = function(eventLink){
		
		$scope.selectedEventId = eventLink.match(/\/[0-9]+\/[0-9]+_([0-9]+)\//)[1];
		
		$scope.showEvent($scope.selectedEventId);
		
		/*
		if(window.StatusBar && device.platform != 'android' && device.platform != 'Android'){
			StatusBar.hide();
		}

		$ionicModal.fromTemplateUrl('templates/modal-event.html', {
			id: "event",
			scope: $scope,
			animation: 'slide-in-right',
			focusFirstInput: false
		}).then(function(modal) {
			$scope.modalE = modal;
			$scope.modalE.show();
		});
		*/
		
	};
	
	$scope.clickTest = function() {
	};

	if(window.StatusBar){
		StatusBar.show();
	}
});