angular.module('ctrl.friends', [])

.controller('FriendsCtrl', function($scope, Friends, $q, $ionicScrollDelegate, $ionicPopup, $rootScope, $ionicSideMenuDelegate, $state, $translate, $timeout, $ionicLoading) {
	
	$scope.friendsLoading = true;
	
	$scope.showLoadMoreRequestsSuggestions = false;
	
	$scope.testMaterialButton = function(){
		log("test material button");
	};
	
	$rootScope.lastMinuteView = false;
	
	$scope.contentTop = "78px";
	try {
		if(device.platform.toLowerCase() == "android"){
			$scope.contentTop = "78px";
		} else {
			$scope.contentTop = "98px";
		}
	} catch (e) {
	}
	
	$scope.showHideRequestOptions = function(oid){
		if($('#r_opts_btn_'+oid).hasClass("ion-ios-arrow-down")){
			$('#r_opts_btn_'+oid).removeClass("ion-ios-arrow-down").addClass("ion-ios-arrow-up");
			$('#frs_'+oid).css("background-color","rgb(247,243,241)");
		} else {
			$('#r_opts_btn_'+oid).removeClass("ion-ios-arrow-up").addClass("ion-ios-arrow-down");
			$('#frs_'+oid).css("background","none");
		}
		//$('#r_opts_'+oid).toggle({duration:400});
		$('#r_opts_'+oid).toggle();
		//$('#r_opts_'+oid).removeClass("ion-ios-arrow-down").addClass("animated fadeInLeft");
	};

	$scope.showHideSuggestionOptions = function(oid){
		if($('#s_opts_btn_'+oid).hasClass("ion-ios-arrow-down")){
			$('#s_opts_btn_'+oid).removeClass("ion-ios-arrow-down").addClass("ion-ios-arrow-up");
			$('#frs_'+oid).css("background-color","rgb(247,243,241)");
		} else {
			$('#s_opts_btn_'+oid).removeClass("ion-ios-arrow-up").addClass("ion-ios-arrow-down");
			$('#frs_'+oid).css("background","none");
		}
		//$('#r_opts_'+oid).toggle({duration:400});
		$('#s_opts_'+oid).toggle();
	};
	
	$scope.updateNotifCounter = function(){
		if($rootScope.n_friends > 0){
			$rootScope.n_friends = $rootScope.n_friends-1;
		}
	};

	$scope.frsAccept = function(notif){
		$scope.currentNotif = notif;
		$ionicPopup.confirm({
			title: $scope.friend_requests ? $translate.instant('accetta_richiesta') : $translate.instant('accetta_suggerimento'),
			template: $scope.friend_requests ? $translate.instant('accetta_richiesta_conferma') : $translate.instant('accetta_suggerimento_conferma'),
			cancelText: $translate.instant('no'),
			okText: $translate.instant('si')
		}).then(function(res) {
			if(res){
				$ionicLoading.show({
					template: '<ion-spinner icon="circles" class="spinner-bianco"></ion-spinner>'
				});
				if($scope.friend_requests){
					var deferred_friends = $q.defer();
					var promise_friends = deferred_friends.promise;
					promise_friends.then(function(result){
						$('#frs_'+$scope.currentNotif.i_id).fadeOut();
						$scope.updateNotifCounter();
						$ionicLoading.hide();
					}, function(reason){
					});
					Friends.friendRequestAction(userId, $scope.currentNotif.i_id, 1, deferred_friends);
				} else {
					var deferred_friends = $q.defer();
					var promise_friends = deferred_friends.promise;
					promise_friends.then(function(result){
						$('#frs_'+$scope.currentNotif.s_id).fadeOut();
						$scope.updateNotifCounter();
						$ionicLoading.hide();
					}, function(reason){
					});
					Friends.friendSuggestionAction(userId, $scope.currentNotif.s_id, 1, deferred_friends);
				}
			}
		});
	};
	
	$scope.frsReject = function(notif){
		$scope.currentNotif = notif;
		$ionicPopup.confirm({
			title: $scope.friend_requests ? $translate.instant('rifiuta_richiesta') : $translate.instant('rifiuta_suggerimento'),
			template: $scope.friend_requests ? $translate.instant('rifiuta_richiesta_conferma') : $translate.instant('rifiuta_suggerimento_conferma'),
			cancelText: $translate.instant('no'),
			okText: $translate.instant('si')
		}).then(function(res) {
			if(res){
				$ionicLoading.show({
					template: '<ion-spinner icon="circles" class="spinner-bianco"></ion-spinner>'
				});
				if($scope.friend_requests){
					var deferred_friends = $q.defer();
					var promise_friends = deferred_friends.promise;
					promise_friends.then(function(result){
						$('#frs_'+$scope.currentNotif.i_id).fadeOut();
						$scope.updateNotifCounter();
						$ionicLoading.hide();
					}, function(reason){
					});
					Friends.friendRequestAction(userId, $scope.currentNotif.i_id, 2, deferred_friends);
				} else {
					var deferred_friends = $q.defer();
					var promise_friends = deferred_friends.promise;
					promise_friends.then(function(result){
						$('#frs_'+$scope.currentNotif.s_id).fadeOut();
						$scope.updateNotifCounter();
						$ionicLoading.hide();
					}, function(reason){
					});
					Friends.friendSuggestionAction(userId, $scope.currentNotif.s_id, 2, deferred_friends);
				}
			}
		});
	};
	
	$scope.frsIgnore = function(notif){
		$scope.currentNotif = notif;
		$ionicPopup.confirm({
			title: $scope.friend_requests ? $translate.instant('ignora_richiesta') : $translate.instant('ignora_suggerimento'),
			template: $scope.friend_requests ? $translate.instant('ignora_richiesta_conferma') : $translate.instant('ignora_suggerimento_conferma'),
			cancelText: $translate.instant('no'),
			okText: $translate.instant('si')
		}).then(function(res) {
			if(res){
				$ionicLoading.show({
					template: '<ion-spinner icon="circles" class="spinner-bianco"></ion-spinner>'
				});
				if($scope.friend_requests){
					var deferred_friends = $q.defer();
					var promise_friends = deferred_friends.promise;
					promise_friends.then(function(result){
						$('#frs_'+$scope.currentNotif.i_id).fadeOut();
						$scope.updateNotifCounter();
						$ionicLoading.hide();
					}, function(reason){
					});
					Friends.friendRequestAction(userId, $scope.currentNotif.i_id, 3, deferred_friends);
				} else {
					var deferred_friends = $q.defer();
					var promise_friends = deferred_friends.promise;
					promise_friends.then(function(result){
						$('#frs_'+$scope.currentNotif.s_id).fadeOut();
						$scope.updateNotifCounter();
						$ionicLoading.hide();
					}, function(reason){
					});
					Friends.friendSuggestionAction(userId, $scope.currentNotif.s_id, 3, deferred_friends);
				}
			}
		});
	};
	
	/*
	 * RICHIESTE DI AMICIZIA. INIZIO
	 * ---------------------------------------------
	 */
	
	$scope.showFriendRequests_ = function(){
		var deferred_friends = $q.defer();
		var promise_friends = deferred_friends.promise;
		promise_friends.then(function(result){
			
			if($scope.frs_page > 0){
				$scope.friend_rs_list = $scope.friend_rs_list.concat(result.notifications);
				$scope.$broadcast('scroll.infiniteScrollComplete');
			} else {
				$ionicScrollDelegate.$getByHandle('notifications').scrollTop(true);
				$scope.friend_rs_list = result.notifications;
				
				// carichiamo subito la seconda pagina (problema tablet con lista che non arriva fino in fondo)
				if(result.notifications.length == 10){
					$scope.getMoreRequestsSuggestions();
				}
			}
			if(result.notifications.length < 10){
				$scope.showLoadMoreRequestsSuggestions = false;
			} else {
				$timeout(function(){$scope.showLoadMoreRequestsSuggestions = true;}, 1000);
			}
			
			$timeout(function(){$scope.friendsLoading = false;}, 1000);
			
		}, function(reason){
		});
		$scope.friend_requests = true;
		Friends.getRequests(userId, $scope.frs_page, deferred_friends);
	};
	
	$scope.showFriendRequests = function(){
		
		$scope.friendsLoading = true;
		
		$('#friend_requests').removeClass("button-stable").addClass("button-rosso").css("border-bottom","1px solid rgb(164,44,69)");
		$('#friend_suggestions').removeClass("button-rosso").addClass("button-stable").css("border-bottom","1px solid rgb(214,214,214)");
		$scope.frs_page = 0;
		$scope.showFriendRequests_();
	};
	
	$scope.getUserProfileRequest = function(notif){
		var user_profile = "";
		/*
		if(notif.i_user_profile_type > 41){
			user_profile = notif.i_user_profile.split("|")[0];
		} else if(notif.i_user_profile_type == 4){
			user_profile = "<i class='ion-male color-blu'></i> "+(notif.i_user_age1 > 0 ? notif.i_user_age1 : "");
		} else if(notif.i_user_profile_type == 5){
			user_profile = "<i class='ion-female color-rosa'></i> "+(notif.i_user_age1 > 0 ? notif.i_user_age1 : "");
		} else if(notif.i_user_profile_type == 6){
			user_profile = "<i class='ion-male color-blu'></i> "+(notif.i_user_age1 > 0 ? notif.i_user_age1 : "");
			user_profile += "&nbsp;&nbsp;<i class='ion-female color-rosa'></i> "+(notif.i_user_age2 > 0 ? notif.i_user_age2 : "");
		} else if(notif.i_user_profile_type == 7){
			user_profile = "<i class='ion-male color-blu'></i> "+(notif.i_user_age1 > 0 ? notif.i_user_age1 : "");
			user_profile += "&nbsp;&nbsp;<i class='ion-male color-blu'></i> "+(notif.i_user_age2 > 0 ? notif.i_user_age2 : "");
		} else if(notif.i_user_profile_type == 9){
			user_profile = "<i class='ion-female color-rosa'></i> "+(notif.i_user_age1 > 0 ? notif.i_user_age1 : "");
			user_profile += "&nbsp;&nbsp;<i class='ion-female color-rosa'></i> "+(notif.i_user_age2 > 0 ? notif.i_user_age2 : "");
		}
		*/
		if(notif.i_user_profile_type > 41){
			user_profile = notif.i_user_profile.split("|")[0];
		} else if(notif.i_user_profile_type == 4){
			user_profile = "<font class='color-blu'>"+(notif.i_user_age1 > 0 ? notif.i_user_age1 : "")+"</font>";
		} else if(notif.i_user_profile_type == 5){
			user_profile = "<font class='color-rosa'>"+(notif.i_user_age1 > 0 ? notif.i_user_age1 : "")+"</font>";
		} else if(notif.i_user_profile_type == 6){
			user_profile = "<font class='color-blu'>"+(notif.i_user_age1 > 0 ? notif.i_user_age1 : "")+"</font>";
			user_profile += "&nbsp;&nbsp;<font class='color-rosa'>"+(notif.i_user_age2 > 0 ? notif.i_user_age2 : "")+"</font>";
		} else if(notif.i_user_profile_type == 7){
			user_profile = "<font class='color-blu'>"+(notif.i_user_age1 > 0 ? notif.i_user_age1 : "")+"</font>";
			user_profile += "&nbsp;&nbsp;<font class='color-blu'>"+(notif.i_user_age2 > 0 ? notif.i_user_age2 : "")+"</font>";
		} else if(notif.i_user_profile_type == 9){
			user_profile = "<font class='color-rosa'>"+(notif.i_user_age1 > 0 ? notif.i_user_age1 : "")+"</font>";
			user_profile += "&nbsp;&nbsp;<font class='color-rosa'>"+(notif.i_user_age2 > 0 ? notif.i_user_age2 : "")+"</font>";
		}
		return user_profile;
	};
	
	$scope.showFriendRequests();
	
	/*
	 * ---------------------------------------------
	 * RICHIESTE DI AMICIZIA. FINE
	 */
	
	
	
	/*
	 * SUGGERIMENTI DI AMICIZIA. INIZIO
	 * ---------------------------------------------
	 */
	
	$scope.showFriendSuggestions_ = function(){
		var deferred_friends = $q.defer();
		var promise_friends = deferred_friends.promise;
		promise_friends.then(function(result){
			
			if($scope.frs_page > 0){
				$scope.friend_rs_list = $scope.friend_rs_list.concat(result.notifications);
				$scope.$broadcast('scroll.infiniteScrollComplete');
			} else {
				$scope.friend_rs_list = result.notifications;
				$ionicScrollDelegate.$getByHandle('notifications').scrollTop(true);
				// carichiamo subito la seconda pagina (problema tablet con lista che non arriva fino in fondo)
				if(result.notifications.length == 10){
					$scope.getMoreRequestsSuggestions();
				}
				
			}
			if(result.notifications.length < 10){
				$scope.showLoadMoreRequestsSuggestions = false;
			} else {
				$timeout(function(){$scope.showLoadMoreRequestsSuggestions = true;}, 1000);
				
			}
			
			$timeout(function(){$scope.friendsLoading = false;}, 1000);
			
		}, function(reason){
		});
		$scope.friend_requests = false;
		Friends.getSuggestions(userId, $scope.frs_page, deferred_friends);
	};
	
	$scope.showFriendSuggestions = function(){
		
		$scope.friendsLoading = true;
		
		$('#friend_requests').removeClass("button-rosso").addClass("button-stable").css("border-bottom","1px solid rgb(214,214,214)");
		$('#friend_suggestions').removeClass("button-stable").addClass("button-rosso").css("border-bottom","1px solid rgb(164,44,69)");
		$scope.frs_page = 0;
		$scope.showFriendSuggestions_();
	};

	/*
	 * ---------------------------------------------
	 * SUGGERIMENTI DI AMICIZIA. FINE
	 */
	
	$scope.showFriendRS = function(notif){
		if($scope.friend_requests){
			$scope.showModalUser(notif.i_user_id);
		} else {
			$scope.showModalUser(notif.s_suggested_id);
		}
	};
	
	$scope.getMoreRequestsSuggestions = function(){
		$scope.frs_page = $scope.frs_page+1;
		if($scope.friend_requests){
			$scope.showFriendRequests_();
		} else {
			$scope.showFriendSuggestions_();
		}
	};
	
	if(window.StatusBar){
		StatusBar.show();
	}
	
});