angular.module('ctrl.friendsmap', [])

.controller('FriendsMapCtrl', function($scope, $compile, FriendsMap, $q, $ionicScrollDelegate, $rootScope, $ionicSideMenuDelegate, $state, $ionicLoading, $timeout, $ionicModal, $translate) {
	
	$rootScope.lastMinuteView = false;
	
	try {
		cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
	} catch (e) {
	}
	
	var search_radius = 30000;
	var circle_bounds;
	var rectangle = null;
	var markerIndex = 0;
	var userMarkers = {};
	var currentLat;
	var currentLng;
	var infowindow_;
	var map = null;
	
	$scope.evt = {distance: 30, usr_type_filter: 0, personally_met:false};
	
	var mapHeight_ = (($(window).height() - $('#event_search_form').height() - 70)/2);
	var listHeight_ = ($(window).height() - $('#event_search_form').height() - 100 - (($(window).height() - $('#event_search_form').height() - 100)/2));
	var listTop_ = ($('#event_search_form').position().top + $('#event_search_form').height() + (($(window).height() - $('#event_search_form').height() - 80)/2));
	
	try {
		if(device.platform.toLowerCase() == "android"){
			listHeight_ = listHeight_+70;
		}
	} catch (e) {
		// TODO: handle exception
	}
	
	$scope.mapHeightNum = mapHeight_;
	$scope.mapHeight = mapHeight_+'px';
	$scope.listHeight = listHeight_+'px';
	$scope.listTop = listTop_+'px';

	$scope.usrSetType = function(usr_type){
		$scope.evt.usr_type_filter = usr_type;
	};
	
	$scope.getMyLocationFriends_ = function(my_position){
		if(my_position != null && my_position.coords != null && my_position.coords.latitude != null && my_position.coords.longitude != null){
			try {
				search_radius = $scope.evt.distance * 1000;
				currentLat = my_position.coords.latitude;
				currentLng = my_position.coords.longitude;
				
				var myLatLng = new google.maps.LatLng(currentLat, currentLng);
				
				if(map == null){
					map = new google.maps.Map(document.getElementById('map_canvas'), {
						zoom: 8,
						center: myLatLng,
						mapTypeId: google.maps.MapTypeId.ROADMAP,
						disableDefaultUI: true,
						overviewMapControl: false
					});
				} else {
					map.setCenter(myLatLng);
				}
				
				circle_bounds = new google.maps.Circle({center: myLatLng, radius: search_radius}).getBounds();
				if(rectangle != null){
					rectangle.setMap(map);
					rectangle.setBounds(circle_bounds);
				} else {
					rectangle = new google.maps.Rectangle({
						strokeColor: '#999999',
						strokeOpacity: 1,
						strokeWeight: 0.5,
						fillColor: '#000000',
						fillOpacity: 0.1,
						map: map,
						bounds: circle_bounds
					});
				}
				
				$scope.sqr_lat1 = circle_bounds.getNorthEast().lat();
				$scope.sqr_lng1 = circle_bounds.getNorthEast().lng();
				$scope.sqr_lat2 = circle_bounds.getSouthWest().lat();
				$scope.sqr_lng2 = circle_bounds.getSouthWest().lng();
				
				var deferred_events = $q.defer();
				var promise_events = deferred_events.promise;
				promise_events.then(function(result){
					
					if(userMarkers != null){
						for (var m_uid in userMarkers) {
					    	var user_marker = userMarkers[m_uid];
					    	user_marker.setMap(null);
						}
					}
					
					$scope.map_users = [];
					
					if(result != null && result.user_geolocations != null && result.user_geolocations.length > 0){
						for(var eg = 0; eg < result.user_geolocations.length; eg++){
							var user_gl = result.user_geolocations[eg]["user_gl"];
							var latlng_ = new google.maps.LatLng(user_gl["latitude"], user_gl["longitude"]);
							infowindow_ = new google.maps.InfoWindow();
							
							/*
							
							profile = profile.replace(/&lt;/g, "<").replace(/&gt;/g, ">");
							profile = profile.replace(/<img src=\'\/img\/announce\/Icons\/user_male.png\' border=\'0\'\/>/g, "<i class='ion-male color-blu'></i> ");
							profile = profile.replace(/<img src=\'\/img\/announce\/Icons\/user_female.png\' border=\'0\'\/>/g, "<i class='ion-female color-rosa'></i> ");
							*/
							var user_profile = "";
							if(user_gl['profile_value_id'] == 4){
								user_profile = "<font class='color-blu'>"+(user_gl['age1'] > 0 ? user_gl['age1'] : "")+"</font>";
							} else if(user_gl['profile_value_id'] == 5){
								user_profile = "<font class='color-rosa'>"+(user_gl['age1'] > 0 ? user_gl['age1'] : "")+"</font>";
							} else if(user_gl['profile_value_id'] == 6){
								user_profile = "<font class='color-blu'>"+(user_gl['age1'] > 0 ? user_gl['age1'] : "")+"</font>";
								user_profile += "&nbsp;&nbsp;<font class='color-rosa'>"+(user_gl['age2'] > 0 ? user_gl['age2'] : "")+"</font>";
							} else if(user_gl['profile_value_id'] == 7){
								user_profile = "<font class='color-blu'>"+(user_gl['age1'] > 0 ? user_gl['age1'] : "")+"</font>";
								user_profile += "&nbsp;&nbsp;<font class='color-blu'>"+(user_gl['age2'] > 0 ? user_gl['age2'] : "")+"</font>";
							} else if(user_gl['profile_value_id'] == 9){
								user_profile = "<font class='color-rosa'>"+(user_gl['age1'] > 0 ? user_gl['age1'] : "")+"</font>";
								user_profile += "&nbsp;&nbsp;<font class='color-rosa'>"+(user_gl['age2'] > 0 ? user_gl['age2'] : "")+"</font>";
							}
							user_gl['profile'] = user_profile;
							
							var user_avatar = "";
							if(user_gl['app_approved']){
								user_avatar = "<img src='https://www.erosland.it"+user_gl['avatar']+"' height='40px' />";
							} else if(!user_gl['app_approved'] && user_gl['profile_value_id'] == 6){
								user_avatar = '<div class="app-approved-30-map-c"><i class="ion-person color-blu"></i><i class="ion-person color-rosa app-approved-30-map-c-2"></i></div>';
							} else if(!user_gl['app_approved'] && user_gl['profile_value_id'] == 7){
								user_avatar = '<div class="app-approved-30-map-c"><i class="ion-person color-blu"></i><i class="ion-person color-blu app-approved-30-map-c-2"></i></div>';
							} else if(!user_gl['app_approved'] && user_gl['profile_value_id'] == 9){
								user_avatar = '<div class="app-approved-30-map-c"><i class="ion-person color-rosa"></i><i class="ion-person color-rosa app-approved-30-map-c-2"></i></div>';
							} else if(!user_gl['app_approved'] && user_gl['profile_value_id'] == 4){
								user_avatar = '<div class="app-approved-30-map-s"><i class="ion-person color-blu"></i></div>';
							} else if(!user_gl['app_approved'] && user_gl['profile_value_id'] == 5){
								user_avatar = '<div class="app-approved-30-map-s"><i class="ion-person color-rosa"></i></div>';
							} else if(!user_gl['app_approved'] && user_gl['profile_value_id'] == 42){
								user_avatar = '<div class="app-approved-30-map-g"><i class="ion-ios-people color-grigio-scuro"></i></div>';
							} else if(!user_gl['app_approved'] && user_gl['profile_value_id'] == 50){
								user_avatar = '<div class="app-approved-30-map-s"><i class="ion-person color-grigio-scuro"></i></div>';
							} else if(!user_gl['app_approved']){
								user_avatar = '<div class="app-approved-30-map-s"><i class="ion-person color-rosso"></i></div>';
							}
							
							var user_html = "<div style='height: 40px; width: 200px; line-height: normal ! important'>" +
								"<div style='float: left;' class='user-avatar circle-40'>"+user_avatar+"</div>" +
								"<div style='float: left; padding-left: 5px;'>" +
									"<div class='color-rosso'>" +
										user_gl['nick'] +
									"</div>" +
									"<div style='color: #777; width: 140px; margin-top: 5px;'>" +
										user_profile +
									"</div>" +
								"</div>" +
								"<div style='clear: both;'></div>" +
							"</div>";
							
							var marker_ = new google.maps.Marker({
								id: user_gl['uid'],
								position: latlng_,
								map: map,
								title: user_gl["nick"],
								//html: $compile(user_html)($scope)[0],
								html: user_html,
								icon: "https://www.erosland.it/img/map_marker_blu.png"
							});
							marker_.setZIndex(0);
							userMarkers[user_gl["uid"]] = marker_;
							
							google.maps.event.addListener(marker_, 'click', (function(marker_) {
								return function() {
									infowindow_.setContent(this.html);
									infowindow_.open(map, marker_);
								}
							})(marker_));
							
							var map_user = {};
							map_user.uid = user_gl["uid"];
							map_user.nick = user_gl["nick"];
							map_user.avatar = user_gl["avatar"];
							map_user.profile = user_profile;
							map_user.profile_value_id = user_gl["profile_value_id"];
							map_user.app_approved = user_gl["app_approved"];
							$scope.map_users.push(map_user);
							
						}
					}
					
				}, function(reason){
				});
				
				FriendsMap.getFriends(userId, $scope.sqr_lat1, $scope.sqr_lat2, $scope.sqr_lng1, $scope.sqr_lng2, true, $scope.evt.usr_type_filter, $scope.evt.personally_met, deferred_events);
				
				//Marker + infowindow + angularjs compiled ng-click
				var contentString = "<div><a ng-click='clickTest()'>Click me!</a></div>";
				var compiled = $compile(contentString)($scope);
				
				var infowindow = new google.maps.InfoWindow({
					content: compiled[0]
				});
				
				var marker = new google.maps.Marker({
					position: myLatLng,
					map: map,
					title: $translate.instant('mia_posizione')
				});
				
				google.maps.event.addListener(marker, 'click', function() {
					infowindow.open(map,marker);
				});
				
				$timeout(function(){$ionicScrollDelegate.$getByHandle('scrollMapUsers').scrollTop(true);}, 600);
				
			} catch (e) {
				alert("error: "+e);
			}
		}
	};
	
	$scope.getMyLocationFriends = function() {
		
		var my_geoloc_status = JSON.parse(localStorage.getItem("my_geolocation_status"));
		
		if(my_geoloc_status != null && my_geoloc_status.latitude != null && my_geoloc_status.longitude != null){
			//alert("set event map my_geolocation_status");
			$scope.getMyLocationFriends_({coords:{latitude:my_geoloc_status.latitude, longitude:my_geoloc_status.longitude}});
		}
		
		$rootScope.diagnosticGPS(true);
		
		/*
		$ionicLoading.show({
			template: '<ion-spinner icon="circles" class="spinner-bianco"></ion-spinner>'
		});
		*/
		
		$timeout(function(){
			navigator.geolocation.getCurrentPosition(function(geo_position) {
				if(geo_position != null && geo_position.coords != null && geo_position.coords.latitude != null && geo_position.coords.longitude != null){
					$scope.getMyLocationFriends_(geo_position);
				}
			}, function(error) {
				//$ionicLoading.hide();
				//alert("position: no gps. error: "+JSON.stringify(error));
			});
		},1000);
		
	};
	
	setTimeout(function(){$scope.getMyLocationFriends()}, 1000);
	
	$scope.focusUserMarker = function(uid){
		var selectedMarker = userMarkers[uid];
		map.panTo(selectedMarker.position);
		google.maps.event.trigger(selectedMarker, "click");
		markerIndex += 1;
		selectedMarker.setZIndex(markerIndex);
	}
	
	$scope.clickTest = function() {
	};
	
	$scope.setPersonallyMet = function(){
		$scope.evt.personally_met = !$scope.evt.personally_met;
		$ionicLoading.show({template: $scope.evt.personally_met ? $translate.instant('trova_conosciuti_di_persona') : $translate.instant('trova_tutti_amici')});
		$timeout(function(){$ionicLoading.hide()}, 1000);
	};
	
	$scope.closeModalSearch = function(){
		$scope.modalFMPT.hide();
		$scope.modalFMPT.remove();
	};
	
	$scope.selectProfType = function(){
		$ionicModal.fromTemplateUrl('templates/modal-friendsmap-proftype.html', {
			id: "friendsmap-proftype",
			scope: $scope,
			animation: 'slide-in-up',
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalFMPT = modal;
			$scope.modalFMPT.show();
		});
	};
		
	if(window.StatusBar){
		StatusBar.show();
	}
	
});