angular.module('ctrl.home', [])

.controller('HomeCtrl', function($scope, $rootScope, $http, $state, Shorts, $q, Notifications, $ionicModal, $ionicScrollDelegate, $ionicSideMenuDelegate, $ionicLoading, NotificationSettings, $translate, $anchorScroll, $ionicPopover, $timeout) {
	
	$scope.homeLoading = true;
	
	$scope.showHomeRefresh = false;
	
	$scope.pullToRefresh = "scorri_per_aggiornare";
	
	$rootScope.lastMinuteView = false;
		
	$scope.showLoadMoreShorts = false;
	
	// Conteggio notifiche
	var deferred_notifications = $q.defer();
	var promise_notifications = deferred_notifications.promise;
	promise_notifications.then(function(result){
		$rootScope.n_friends = result.friends;
		$rootScope.n_messages = result.messages;
		$rootScope.n_notifications = result.notifications;
	}, function(reason){
		
	});
	Notifications.get(userId, deferred_notifications);
	
	if(!$rootScope.notifList || $rootScope.notifList.length == 0){
		var deferred_notif_settings = $q.defer();
		var promise_notif_settings = deferred_notif_settings.promise;
		promise_notif_settings.then(function(result){
			$rootScope.notifList = result.notifications;
		}, function(reason){
			
		});
		NotificationSettings.get(userId, deferred_notif_settings);
	}
	
	$scope.shortsGetPage = 0;
	
	$scope.shortsGet = function(){
		var deferred_shorts = $q.defer();
		var promise_shorts = deferred_shorts.promise;
		promise_shorts.then(function(result){
			
			for ( var t = 0; t < result.twits.length; t++) {
				result.twits[t].twit.twitText = convertDecNCR2Char(result.twits[t].twit.twitText);
			}
			
			if($scope.shortsGetPage > 0){
				$scope.shorts = $scope.shorts.concat(result.twits);
				$scope.$broadcast('scroll.infiniteScrollComplete');
			} else {
				$scope.currentShowIndex = 0;
				$scope.shorts = result.twits;
				$timeout(function(){
					$scope.homeLoading = false;
					$scope.showHomeRefresh = true;
					//$ionicScrollDelegate.$getByHandle('homeShortsScroll').scrollTo(0, 48, false);
				},1000);
			}
			
			if(result.twits.length == 10){
				$scope.showLoadMoreShorts = true;
			} else {
				$scope.showLoadMoreShorts = false;
			}
			
			//zoomInElements();
			
			/*
			$timeout(function() {
	            var watchers = ($scope.$$watchers) ? $scope.$$watchers.length : 0;
	            var child = $scope.$$childHead;
	            while (child) {
	                watchers += (child.$$watchers) ? child.$$watchers.length : 0;
	                child = child.$$nextSibling;
	            }
	            log("watchers: "+watchers);
	        }, 5000);			
			*/
			
		}, function(reason){
		});
		//log("controller-Home. shortGet");
		Shorts.get(userId, $scope.shortsGetPage, userId, deferred_shorts);
	};
	
	$scope.shortsGetMore = function(){
		/*
		if($scope.currentShowIndex < $scope.shorts.length-1){
			
			if($scope.currentShowIndex > 0){
				log($($('.shorts-element')[$scope.currentShowIndex-1]).position().top+" -> "+$ionicScrollDelegate.$getByHandle('homeShortsScroll').getScrollPosition().top);
			}
			
			if($scope.currentShowIndex == 0 || $($('.shorts-element')[$scope.currentShowIndex-1]).position().top < $ionicScrollDelegate.$getByHandle('homeShortsScroll').getScrollPosition().top){
				$scope.currentShowIndex ++;
				log("show "+$scope.currentShowIndex+" ("+$scope.shorts.length+")");
			} else {
				$scope.$broadcast('scroll.infiniteScrollComplete');
			}
		}
		*/
		$scope.shortsGetPage = $scope.shortsGetPage +1;
		//log("controller-Home. shortsGetMore");
		$scope.shortsGet();
	};
	
	$scope.shortHomePulling = function(){
		$scope.pullToRefresh = "rilascia_per_aggiornare";
		$scope.$apply();
	};
	$scope.shortHomeRefresh = function(){
		$scope.pullToRefresh = "scorri_per_aggiornare";
		$scope.shortsGetPage = 0;
		var deferred_shorts = $q.defer();
		var promise_shorts = deferred_shorts.promise;
		promise_shorts.then(function(result){
			/*
			$rootScope.home_shorts = result.twits;
			$scope.shorts = $rootScope.home_shorts;
			*/
			$scope.shorts = result.twits;
			$scope.$broadcast('scroll.refreshComplete');
			//$ionicScrollDelegate.$getByHandle('homeShortsScroll').scrollTo(0, 50, false);
		}, function(reason){
		});
		//log("controller-Home. shortHomeRefresh");
		Shorts.get(userId, $scope.shortsGetPage, userId, deferred_shorts);
	};
	
	$scope.shortsGet();

	$scope.sendShort = function(){
		
		$ionicLoading.show({
			template: '<ion-spinner icon="circles" class="spinner-bianco"></ion-spinner>'
		});
		
		$('#short_send').attr("disabled", "disabled");
		$('#short_text').attr("disabled", "disabled");
		
		var deferred_shorts = $q.defer();
		var promise_shorts = deferred_shorts.promise;
		promise_shorts.then(function(result){
			
			$ionicLoading.hide();
			
			if(result.send_short == "ok"){
				
				$scope.closeModalS();
				
				$('#short_send').removeAttr("disabled");
				$('#short_text').removeAttr("disabled");
				$scope.shortText.value = "";
				$scope.shortsGetPage = 0;
				$scope.shortsGet();
				$ionicScrollDelegate.$getByHandle('homeShortsScroll').scrollTop(true);
				//$ionicScrollDelegate.$getByHandle('homeShortsScroll').scrollTo(0, 50, false);
			} else {
				
				alert("Si è verificato un errore!");
				
				$('#short_send').removeAttr("disabled");
				$('#short_text').removeAttr("disabled");
			}
		}, function(reason){
			$ionicLoading.hide();
		});
		Shorts.writeShort(userId, "X", $scope.shortText.value, deferred_shorts);
	};
	
	$scope.twitMyLikeTrue = function(twitMyLike){
		return twitMyLike != null && twitMyLike ? "shorts-button button-selected" : "shorts-button button-selected hide-element";
	};
	$scope.twitMyLikeFalse = function(twitMyLike){
		return twitMyLike != null && !twitMyLike ? "shorts-button button-selected" : "shorts-button button-selected hide-element";
	};
	$scope.twitCanLike = function(twitMyLike){
		return twitMyLike == null ? "shorts-button" : "shorts-button hide-element";
	};
	$scope.shortNoLikes = function(twitNoLikes){
		return twitNoLikes != null ? "shorts-no-likes" : "shorts-no-likes hide-element";
	};
	$scope.shortLikes = function(twitLikes){
		return twitLikes != null ? "shorts-likes" : "shorts-likes hide-element";
	};
	
	$scope.shortRemoveLike = function(shortId, like){
		if(userUpiId != null && userUpiId != 0){
			var deferred_shortRemoveLike = $q.defer();
			var promise_shortRemoveLike = deferred_shortRemoveLike.promise;
			promise_shortRemoveLike.then(function(result){
				if($(result).find("result").text() == "true"){
					/*
					for(var t=0; t<$rootScope.home_shorts.length; t++){
						if($rootScope.home_shorts[t].twit.twitId == shortId){
							$rootScope.home_shorts[t].twit.twitMyLike = null;
							if(like == 1){
								if($rootScope.home_shorts[t].twit.twitLikes > 1){
									$rootScope.home_shorts[t].twit.twitLikes = $rootScope.home_shorts[t].twit.twitLikes-1;
								} else {
									$rootScope.home_shorts[t].twit.twitLikes = null;
								}
							} else {
								if($rootScope.home_shorts[t].twit.twitNoLikes > 1){
									$rootScope.home_shorts[t].twit.twitNoLikes = $rootScope.home_shorts[t].twit.twitNoLikes-1;
								} else {
									$rootScope.home_shorts[t].twit.twitNoLikes = null;
								}
							}
							break;
						}
					}
					*/
					for(var t=0; t<$scope.shorts.length; t++){
						if($scope.shorts[t].twit.twitId == shortId){
							$scope.shorts[t].twit.twitMyLike = null;
							if(like == 1){
								if($scope.shorts[t].twit.twitLikes > 1){
									$scope.shorts[t].twit.twitLikes = $scope.shorts[t].twit.twitLikes-1;
								} else {
									$scope.shorts[t].twit.twitLikes = null;
								}
							} else {
								if($scope.shorts[t].twit.twitNoLikes > 1){
									$scope.shorts[t].twit.twitNoLikes = $scope.shorts[t].twit.twitNoLikes-1;
								} else {
									$scope.shorts[t].twit.twitNoLikes = null;
								}
							}
							break;
						}
					}
					
					$('#short_like_'+shortId).hide();
					$('#short_no_like_'+shortId).hide();
					$('#shorts_like_button_'+shortId).show();
					$('#shorts_no_like_button_'+shortId).show();
					if(like == 1){
						var like_count = parseInt($('#shorts_like_count_'+shortId).find("span").text());
						like_count = like_count-1;
						$('#shorts_like_count_'+shortId).find("span").text(""+like_count);
						if(like_count == 0){
							$('#shorts_like_count_'+shortId).hide();
						}
					} else {
						var no_like_count = parseInt($('#shorts_no_like_count_'+shortId).find("span").text());
						no_like_count = no_like_count-1;
						$('#shorts_no_like_count_'+shortId).find("span").text(""+no_like_count);
						if(no_like_count == 0){
							$('#shorts_no_like_count_'+shortId).hide();
						}
					}
				} else {
					alert("Attenzione: errore shortRemoveLike result");
				}
			}, function(reason){
				alert("Attenzione: errore shortRemoveLike result");
			});
			Shorts.shortRemoveLike(shortId, like, deferred_shortRemoveLike);
		}		
	};
	
	$scope.shortLike = function(shortId, like){
		if(userUpiId != null && userUpiId != 0){
			
			var deferred_shortLike = $q.defer();
			var promise_shortLike = deferred_shortLike.promise;
			promise_shortLike.then(function(result){
				if($(result).find("result").text() == "true"){

					/*
					for(var t=0; t<$rootScope.home_shorts.length; t++){
						if($rootScope.home_shorts[t].twit.twitId == shortId){
							if(like == 1){
								$rootScope.home_shorts[t].twit.twitMyLike = true;
								if($rootScope.home_shorts[t].twit.twitLikes == null){
									$rootScope.home_shorts[t].twit.twitLikes = 0;
								}
								$rootScope.home_shorts[t].twit.twitLikes = $rootScope.home_shorts[t].twit.twitLikes+1;
							} else {
								$rootScope.home_shorts[t].twit.twitMyLike = false;
								if($rootScope.home_shorts[t].twit.twitNoLikes == null){
									$rootScope.home_shorts[t].twit.twitNoLikes = 0;
								}
								$rootScope.home_shorts[t].twit.twitNoLikes = $rootScope.home_shorts[t].twit.twitNoLikes+1;
							}
							break;
						}
					}
					*/
					for(var t=0; t<$scope.shorts.length; t++){
						if($scope.shorts[t].twit.twitId == shortId){
							if(like == 1){
								$scope.shorts[t].twit.twitMyLike = true;
								if($scope.shorts[t].twit.twitLikes == null){
									$scope.shorts[t].twit.twitLikes = 0;
								}
								$scope.shorts[t].twit.twitLikes = $scope.shorts[t].twit.twitLikes+1;
							} else {
								$scope.shorts[t].twit.twitMyLike = false;
								if($scope.shorts[t].twit.twitNoLikes == null){
									$scope.shorts[t].twit.twitNoLikes = 0;
								}
								$scope.shorts[t].twit.twitNoLikes = $scope.shorts[t].twit.twitNoLikes+1;
							}
							break;
						}
					}
					
					$('#shorts_like_button_'+shortId).hide();
					$('#shorts_no_like_button_'+shortId).hide();
					if(like == 1){
						$('#short_like_'+shortId).show();
						var like_count = parseInt($('#shorts_like_count_'+shortId).find("span").text());
						like_count = like_count+1;
						$('#shorts_like_count_'+shortId).find("span").text(""+like_count);
						$('#shorts_like_count_'+shortId).show();
					} else {
						$('#short_no_like_'+shortId).show();
						var no_like_count = parseInt($('#shorts_no_like_count_'+shortId).find("span").text());
						no_like_count = no_like_count+1;
						$('#shorts_no_like_count_'+shortId).find("span").text(""+no_like_count);
						$('#shorts_no_like_count_'+shortId).show();
					}
				} else {
					alert("Attenzione: errore shortLike result");
				}
			}, function(reason){
				alert("Attenzione: errore shortLike result");
			});
			Shorts.shortLike(shortId, like, deferred_shortLike);
		}
	};
	
	// carica/mostra likes/no likes
	$scope.showShortLikes_ = function(){
		
		var deferred_shortLikes = $q.defer();
		var promise_shortLikes = deferred_shortLikes.promise;
		promise_shortLikes.then(function(result){
			
			if($scope.modalDataSL.page == 0){
				$scope.shortLikeUsers = [];
				//$('#short_likes_list').html("");
			}
			
			if($(result).find("twits_like").length >= 0){
				if($(result).find("twits_like").length < 5){
					$('#short_likes_list_others').hide();
				} else {
					$('#short_likes_list_others').show();
				}
				
				$(result).find("twits_like").each(function(){
					
					var twit_like = $(this);
					
					$scope.shortLikeUsers.push({id_user:twit_like.find("id_user").text(), image:twit_like.find("user_image").text(), nick:twit_like.find("user_nick").text(), profile:twit_like.find("user_profile").text(), profile_value_id:twit_like.find("user_profile_value_id").text(), app_approved:twit_like.find("app_approved").text(), location:twit_like.find("location").text()});
					
					//id_upi, id_user, user_image, user_nick, user_link, user_profile
					/*
					$('#short_likes_list').append(
						"<div class='item' id='short_like_element_"+twit_like.find("id_user").text()+"' style='border-top: none; border-bottom: none;'>" +
							"<div class='user-avatar circle-50' aling='center' style='float: left;'><img src='https://www.erosland.it"+twit_like.find("user_image").text()+"' height='50px'/></div>"+
							"<div style='float: left; margin-left: 5px;'>"+
								"<font class='color-rosso'>"+twit_like.find("user_nick").text()+"</font>"+
								"<div class='color-grigio' style='margin-top: 5px;'>"+twit_like.find("user_profile").text()+"</div>"+
							"</div>"+
							"<div style='clear: both;'></div>"+
						"</div>"
					);
					$('#short_like_element_'+twit_like.find("id_user").text()).fadeIn();
					*/
				});
				if($scope.modalDataSL.page > 0){
					$ionicScrollDelegate.$getByHandle('modalScroll').scrollBottom(true);
				}
			}
			
			$scope.loadingActionEnd();
			
		}, function(reason){
		});
		Shorts.showShortLikes($scope.modalDataSL.shortId, $scope.modalDataSL.like, $scope.modalDataSL.page, deferred_shortLikes);
	};
	
	// click mostra altri likes/no likes
	$scope.showShortLikesMore = function(){
		$scope.modalDataSL.page = $scope.modalDataSL.page+1;
		$scope.showShortLikes_();
	};
	
	// click vedi likes/no likes (carica pannello modal)
	$scope.showShortLikes = function(shortId, like){
		
		$scope.loadingAction(false);		
		
		//log("showShortLikes");
		
		$scope.modalDataSL = {'title': (like == '1' ? $translate.instant('piace_a') : $translate.instant('non_piace_a')), 'page': 0, 'shortId': shortId, 'like': like};
		
		$scope.shortLikeUsers = [];
		
		// mostra like/nolike
		$ionicModal.fromTemplateUrl('templates/modal-short-likes.html', {
			id: 'modal-short-likes',
			scope: $scope,
			animation: 'slide-in-up',
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalSL = modal;
			$scope.modalSL.show();
			$timeout(function(){$scope.showShortLikes_();}, 1000);
		});
		
	};
	
	$scope.closeModalSL = function() {
		$scope.modalSL.hide();
		$scope.modalSL.remove();
		$scope.modalDataSL = null;
	};
	
	$scope.checkShort = function(){
		$scope.shortTextLength = 250 - $scope.shortText.value.length;
		if($scope.shortText.value.length > 0 && $scope.shortText.value.length < 251){
			$('#short_send').removeAttr("disabled").addClass("color-nero");
			$('#short_text_length').removeClass("color-rosso").addClass("color-verde");
		} else {
			$('#short_send').attr("disabled", "disabled");
			$('#short_text_length').removeClass("color-verde").addClass("color-rosso");
		}
	};
	
	$rootScope.writeShort = function(){
		
		$scope.shortTextLength = 250;
		$scope.shortText = {"value":""};
		$scope.shortTextHeight = (($(window).height()*0.9)*0.35)+'px';
		
		try {
			cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
		} catch (e) {
		}
		
		$ionicModal.fromTemplateUrl('templates/modal-short-write.html', {
			id: 'modal-short',
			scope: $scope,
			animation: 'slide-in-up',
			focusFirstInput: true,
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalS = modal;
			$scope.modalS.show();
		});
		
		$scope.closeModalS = function() {
			$scope.modalS.hide();
			$scope.modalS.remove();
			try {
				cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
			} catch (e) {
			}
			if(window.StatusBar){
				StatusBar.styleBlackOpaque();
			}
		};
		
		if(window.StatusBar){
			StatusBar.styleDefault();
		}
		
	};
	
	$scope.showUserSubscription = function(){
		$ionicModal.fromTemplateUrl('templates/modal-user-subscription.html', {
			id: 'modal-user-subscription',
			scope: $scope,
			animation: 'slide-in-up',
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalUS = modal;
			$scope.modalUS.show();
			setTimeout(function() {
				showBanner($scope.userSubscriptionActiveSlide);
			}, 100);
		});
	};
	
	function showBanner(index) {
		var oldElm = document.querySelector('.slider ion-slide.slider-slide.current');
		var q = '.slider ion-slide.slider-slide[data-index="' + index + '"]';
		var elm = document.querySelector(q);

		//log("Show banner " + index);

		// Remove class "current"
		if (null !== oldElm) {
			oldElm.classList.remove("current");
		}

		// Add class "current" to current slide
		if (null !== elm) {
			elm.classList.add("current");
		}
	}

	$scope.userSubscriptionActiveSlide = 1;

	$scope.modalUserSubscriptionSlideChanged = showBanner;
	
	$scope.showOptions = function($event, shortId){
		$rootScope.abuseShortId = shortId;
		$ionicPopover.fromTemplateUrl('templates/popover-home.html', {
			scope: $scope,
		}).then(function(popover) {
			$scope.popover = popover;
			$scope.popover.show($event);
		});		
	};
	
	if(window.StatusBar){
		if($rootScope.mobileBrowser){
			// mantenere statusbar nascosta
		} else {
			StatusBar.styleBlackOpaque();
			StatusBar.show();
		}
	}
	
	/*
	function zoomInElements(){
		$('.shorts-element').each(function(){
			var bottom_of_object = $(this).position().top;
			var bottom_of_window = $ionicScrollDelegate.$getByHandle('homeShortsScroll').getScrollPosition().top + ($(window).height()-88);
			if(bottom_of_window > bottom_of_object){
				$(this).css("opacity", "1").addClass("animated element-zoom-in");
			}
		});
	}
	$('#content_home').scroll(function(){
		zoomInElements();
	});
	*/
	
});