angular.module('ctrl.lastminute', [])

.controller('LastMinuteCtrl', function($scope, $ionicSideMenuDelegate, LastMinute, $q, $rootScope, $ionicScrollDelegate, $state, $ionicModal, $translate, $timeout) {
	
	$rootScope.lastMinuteView = true;
	
	try {
		cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
	} catch (e) {
	}
	
	/*
	$rootScope.$on('$locationChangeStart', function(event, next, current) {
		alert("from "+current+" to "+next);
		//event.preventDefault();
	});
	*/
	var search_radius = 50000;
	var circle_bounds;
	var rectangle = null;
	var markerIndex = 0;
	var lm_markers = {};
	var currentLat;
	var currentLng;
	var lm_infowindow_;
	var map = null;
	//var lm_myinfowindow;

	$scope.lm = {distance: 50, lm_type_filter: 0};
	
	var mapHeight_ = (($(window).height() - $('#lm_search_form').height() - 70)/2);
	var listHeight_ = ($(window).height() - $('#lm_search_form').height() - 100 - (($(window).height() - $('#lm_search_form').height() - 100)/2));
	var listTop_ = ($('#lm_search_form').position().top + $('#lm_search_form').height() + (($(window).height() - $('#lm_search_form').height() - 80)/2));
	
	try {
		if(device.platform.toLowerCase() == "android"){
			listHeight_ = listHeight_+70;
		}
	} catch (e) {
		// TODO: handle exception
	}

	$scope.mapHeight = mapHeight_+'px';
	$scope.listHeight = listHeight_+'px';
	$scope.listTop = listTop_+'px';
	
	$scope.lmSetType = function(lm_type){
		$scope.lm.lm_type_filter = lm_type;
	};
	
	$scope.getMyLocationLastMinute_ = function(my_position){
		if(my_position != null && my_position.coords != null && my_position.coords.latitude != null && my_position.coords.longitude != null){
			try {
				search_radius = $scope.lm.distance * 1000;
				currentLat = my_position.coords.latitude;
				currentLng = my_position.coords.longitude;
				
				var myLatLng = new google.maps.LatLng(currentLat, currentLng);
				
				if(map == null){
					map = new google.maps.Map(document.getElementById('map_canvas'), {
						zoom: 8,
						center: myLatLng,
						mapTypeId: google.maps.MapTypeId.ROADMAP,
						disableDefaultUI: true,
						overviewMapControl: false
					});
				} else {
					map.setCenter(myLatLng);
				}
				
				circle_bounds = new google.maps.Circle({center: myLatLng, radius: search_radius}).getBounds();
				
				if(rectangle != null){
					rectangle.setMap(map);
					rectangle.setBounds(circle_bounds);
				} else {
					rectangle = new google.maps.Rectangle({
						strokeColor: '#999999',
						strokeOpacity: 1,
						strokeWeight: 0.5,
						fillColor: '#000000',
						fillOpacity: 0.1,
						map: map,
						bounds: circle_bounds
					});
				}
				
				$scope.sqr_lat1 = circle_bounds.getNorthEast().lat();
				$scope.sqr_lng1 = circle_bounds.getNorthEast().lng();
				$scope.sqr_lat2 = circle_bounds.getSouthWest().lat();
				$scope.sqr_lng2 = circle_bounds.getSouthWest().lng();
				/*
				$scope.sqr_lat1 = 42.03625929261793;
				$scope.sqr_lng1 = 12.64181456555059;
				$scope.sqr_lat2 = 41.766764707382066;
				$scope.sqr_lng2 = 12.27973343444944;
				*/
								
				var marker = new google.maps.Marker({
					position: myLatLng,
					map: map,
					title: $translate.instant('mia_posizione')
				});
				
				var deferred_lm = $q.defer();
				var promise_lm = deferred_lm.promise;
				promise_lm.then(function(result){
					
					if(lm_markers != null){
						for (var m_uid in lm_markers) {
					    	var user_marker = lm_markers[m_uid];
					    	user_marker.setMap(null);
						}
					}
					
					$scope.last_minute_users = [];
					
					if(result != null && result.last_minute_list != null && result.last_minute_list.length > 0){

						var data_last_minute_list = result.last_minute_list;
						data_last_minute_list.reverse();
						
						for(var ug = 0; ug < data_last_minute_list.length; ug++){

							var lm_gl = data_last_minute_list[ug]["last_minute"];
							var latlng_ = new google.maps.LatLng(lm_gl["lm_lat"], lm_gl["lm_lng"]);
							lm_infowindow_ = new google.maps.InfoWindow();
							
							var user_html = "<p style='color: #333;'>"+lm_gl["lm_name"]+"</p>"; //<p style='color: #777; width: 200px;'>"+lm_gl["lm_desc"]+"</p><p>&nbsp;</p>
							
							var marker_ = new google.maps.Marker({
								id: lm_gl['lm_id'],
								position: latlng_,
								map: map,
								title: lm_gl["lm_u_nick"],
								html: user_html,
								icon: "https://www.erosland.it/img/map_marker_red.png",
								user_id: lm_gl['lm_u_id']
							});
							marker_.setZIndex(0);
							lm_markers[lm_gl["lm_id"]] = marker_;
							
							google.maps.event.addListener(marker_, 'click', (function(marker_) {
								return function() {
									lm_infowindow_.setContent(this.html);
									lm_infowindow_.open(map, marker_);
									//lm_myinfowindow.close();
									/*
									user_card_uid=this.user_id;
									lm_last_minute_id = this.id;
									get_user_card_data(true);
									JQ('#lm_user_card_').hide();
									JQ('#lm_user_card').fadeIn();
									*/
								}
							})(marker_));
							
							var lmu = {};
							lmu.uid = lm_gl["lm_u_id"];
							lmu.nick = lm_gl["lm_u_nick"];
							lmu.avatar = lm_gl["lm_u_avatar"];
							lmu.name = lm_gl["lm_name"];
							lmu.datefrom = lm_gl["lm_datefrom"];
							lmu.profile_value_id = lm_gl["lm_u_profile_value_id"];
							lmu.app_approved = lm_gl["lm_app_approved"];
							var user_profile = "";
							if(lm_gl['lm_u_profile_value_id'] == 4){
								user_profile = "<font class='color-blu'>"+(lm_gl['lm_u_age1'] > 0 ? lm_gl['lm_u_age1'] : "")+"</font>";
							} else if(lm_gl['lm_u_profile_value_id'] == 5){
								user_profile = "<font class='color-rosa'>"+(lm_gl['lm_u_age1'] > 0 ? lm_gl['lm_u_age1'] : "")+"</font>";
							} else if(lm_gl['lm_u_profile_value_id'] == 6){
								user_profile = "<font class='color-blu'>"+(lm_gl['lm_u_age1'] > 0 ? lm_gl['lm_u_age1'] : "")+"</font>";
								user_profile += "&nbsp;&nbsp;<font class='color-rosa'>"+(lm_gl['lm_u_age2'] > 0 ? lm_gl['lm_u_age2'] : "")+"</font>";
							} else if(lm_gl['lm_u_profile_value_id'] == 7){
								user_profile = "<font class='color-blu'>"+(lm_gl['lm_u_age1'] > 0 ? lm_gl['lm_u_age1'] : "")+"</font>";
								user_profile += "&nbsp;&nbsp;<font class='color-blu'>"+(lm_gl['lm_u_age2'] > 0 ? lm_gl['lm_u_age2'] : "")+"</font>";
							} else if(lm_gl['lm_u_profile_value_id'] == 9){
								user_profile = "<font class='color-rosa'>"+(lm_gl['lm_u_age1'] > 0 ? lm_gl['lm_u_age1'] : "")+"</font>";
								user_profile += "&nbsp;&nbsp;<font class='color-rosa'>"+(lm_gl['lm_u_age2'] > 0 ? lm_gl['lm_u_age2'] : "")+"</font>";
							}
							lmu.profileHtml = user_profile;
							$scope.last_minute_users.push(lmu);
							
						}
					}
					
				}, function(reason){
				});
				
				$rootScope.sqr_lat1 = $scope.sqr_lat1;
				$rootScope.sqr_lat2 = $scope.sqr_lat2;
				$rootScope.sqr_lng1 = $scope.sqr_lng1;
				$rootScope.sqr_lng2 = $scope.sqr_lng2;
				
				LastMinute.getLastMinuteList(userId, $scope.sqr_lat1, $scope.sqr_lat2, $scope.sqr_lng1, $scope.sqr_lng2, $scope.lm.lm_type_filter, deferred_lm);
				
				
			} catch (e) {
			}
		}
	};
	
	$scope.getMyLocationLastMinute = function() {
		
		var my_geoloc_status = JSON.parse(localStorage.getItem("my_geolocation_status"));
		
		if(my_geoloc_status != null && my_geoloc_status.latitude != null && my_geoloc_status.longitude != null){
			//alert("set event map my_geolocation_status");
			$scope.getMyLocationLastMinute_({coords:{latitude:my_geoloc_status.latitude, longitude:my_geoloc_status.longitude}});
		}
		
		$rootScope.diagnosticGPS(true);
		
		/*
		$ionicLoading.show({
			template: '<ion-spinner icon="circles" class="spinner-bianco"></ion-spinner>'
		});
		*/
		
		$timeout(function(){
			navigator.geolocation.getCurrentPosition(function(geo_position) {
				if(geo_position != null && geo_position.coords != null && geo_position.coords.latitude != null && geo_position.coords.longitude != null){
					$scope.getMyLocationLastMinute_(geo_position);
				}
			}, function(error) {
				//$ionicLoading.hide();
				//alert("position: no gps. error: "+JSON.stringify(error));
			});
		},1000);
		
	};
	
	setTimeout(function(){$scope.getMyLocationLastMinute()}, 1000);
	
	$scope.closeModalSearch = function(){
		$scope.modalLPT.hide();
		$scope.modalLPT.remove();
	};
	
	$scope.selectProfType = function(){
		$ionicModal.fromTemplateUrl('templates/modal-lastminute-proftype.html', {
			id: "lastminute-proftype",
			scope: $scope,
			animation: 'slide-in-up',
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalLPT = modal;
			$scope.modalLPT.show();
		});
	};
	
});