angular.module('ctrl.messages', [])

.controller('MessagesCtrl', function($rootScope, $scope, $q, Messages, $ionicScrollDelegate, $state, $ionicModal, $ionicSideMenuDelegate, MyCamera, $sce, $ionicActionSheet, $translate, $ionicLoading, $timeout) {
	
	$scope.messagesLoading = true;
	
	$scope.showLoadNewMessages = false;
	
	$rootScope.lastMinuteView = false;
	
	$scope.messageLoading = true;
	
	if(window.StatusBar){
		StatusBar.show();
	}
	
	$scope.contentTop = 78;
	try {
		if(device.platform.toLowerCase() == "android"){
			$scope.contentTop = 78;
		} else {
			$scope.contentTop = 98;
		}
	} catch (e) {
	}

	var attachmentsUploaded = [];
	
	//cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
	
	$scope.messages = [];
	$scope.showLoadMoreMessages = false;
	
	$scope.listMessages = function(){
		var deferred_messages = $q.defer();
		var promise_messages = deferred_messages.promise;
		promise_messages.then(function(result){
			$scope.$broadcast('scroll.infiniteScrollComplete');
			if($scope.messagesPage == 0){
				$scope.messages = result.notifications;
				$ionicScrollDelegate.$getByHandle('scrollMessages').scrollTop(false);
				
				// carichiamo subito la seconda pagina (problema tablet con lista che non arriva fino in fondo)
				if(result.notifications.length == 10){
					$timeout(function(){
						$scope.messagesPage = $scope.messagesPage+1;
						if($scope.messagesNotRead == 1){
							$scope.showMessagesNotRead($scope.messagesPage);
						} else if($scope.messagesSent == 1){
							$scope.showMessagesSent($scope.messagesPage);
						} else {
							$scope.showMessagesAll($scope.messagesPage);
						}
						
						$timeout(function(){$scope.messagesLoading = false;}, 1000);
						
					}, 1000);
				} else {
					$timeout(function(){$scope.messagesLoading = false;}, 1000);
				}
				
			} else {
				$scope.messages = $scope.messages.concat(result.notifications);
			}
			$scope.showLoadMoreMessages = result.notifications.length == 10;
			
		}, function(reason){
		});
		Messages.getMessages(userId, $scope.messagesPage, $scope.messagesNotRead, $scope.messagesSent, deferred_messages);
		if($scope.messagesPage == 0){
			$scope.showLoadNewMessages = false;
		}
	};
	
	$scope.loadNewMessages = function(){
		$scope.showLoadMoreMessages = false;
		$scope.showMessagesAll(0);
	};
	
	$scope.showMessagesAll = function(page){
		
		if(page == 0){
			$scope.messagesLoading = true;
		}
		
		$scope.messagesPage = page;
		$('#messages_all').removeClass("button-stable").addClass("button-rosso").css("border-bottom","1px solid rgb(164,44,69)");
		$('#messages_not_read').removeClass("button-rosso").addClass("button-stable").css("border-bottom","1px solid rgb(214,214,214)");
		$('#messages_sent').removeClass("button-rosso").addClass("button-stable").css("border-bottom","1px solid rgb(214,214,214)");
		$scope.messagesNotRead = 0;
		$scope.messagesSent = 0;
		$scope.listMessages();
	};
	
	$scope.showMessagesNotRead = function(page){
		
		if(page == 0){
			$scope.messagesLoading = true;
		}
		
		$scope.messagesPage = page;
		$('#messages_all').removeClass("button-rosso").addClass("button-stable").css("border-bottom","1px solid rgb(214,214,214)");
		$('#messages_not_read').removeClass("button-stable").addClass("button-rosso").css("border-bottom","1px solid rgb(164,44,69)");
		$('#messages_sent').removeClass("button-rosso").addClass("button-stable").css("border-bottom","1px solid rgb(214,214,214)");
		$scope.messagesNotRead = 1;
		$scope.messagesSent = 0;
		$scope.listMessages();
	};
	
	$scope.showMessagesSent = function(page){
		
		if(page == 0){
			$scope.messagesLoading = true;
		}
		
		$scope.messagesPage = page;
		$('#messages_all').removeClass("button-rosso").addClass("button-stable").css("border-bottom","1px solid rgb(214,214,214)");
		$('#messages_not_read').removeClass("button-rosso").addClass("button-stable").css("border-bottom","1px solid rgb(214,214,214)");
		$('#messages_sent').removeClass("button-stable").addClass("button-rosso").css("border-bottom","1px solid rgb(164,44,69)");
		$scope.messagesNotRead = 0;
		$scope.messagesSent = 1;
		$scope.listMessages();
	};

	$scope.showMessagesAll(0);
	
	$(document).off('refreshMessages').on('refreshMessages', function(evt, data){
		
		try{
			/*
			log("current message", $scope.msgDetail.msgText.value);
			if($scope.msgDetail.msgText.value.length == 0){
				$scope.closeMessageDetailModal();
			}
			*/
			$scope.msgDetail.footer_height = $('#message_detail_footer').height();
			$scope.msgDetail.rPage = 0;
			$scope.getMessageDetail_();
		} catch (e) {
			log(e);
		}
		
		$scope.messagesLoading = true;
		
		//$scope.messages = [];
		$scope.showLoadMoreMessages = false;
		$scope.showMessagesAll(0);
	});
	
	$(document).off('loadNewMessages').on('loadNewMessages', function(evt, data){
		$scope.showLoadNewMessages = true;
	});

	$scope.loadMoreMessages = function(){
		if($ionicScrollDelegate.$getByHandle('scrollMessages').getScrollPosition().top == 0 && $scope.messagesPage == 0){
			$scope.$broadcast('scroll.infiniteScrollComplete');
		} else {
			$scope.messagesPage = $scope.messagesPage+1;
			if($scope.messagesNotRead == 1){
				$scope.showMessagesNotRead($scope.messagesPage);
			} else if($scope.messagesSent == 1){
				$scope.showMessagesSent($scope.messagesPage);
			} else {
				$scope.showMessagesAll($scope.messagesPage);
			}
			
		}
	};
	
	$scope.closeMessageDetailModal = function(){
		
		$timeout(function(){$scope.messageLoading = true;},1000);
		
		$scope.modalMD.hide();
		$scope.modalMD.remove();
		$scope.msgDetail = null;
		/*
		if(window.StatusBar){
			StatusBar.show();
		}
		*/
	};
	
	$scope.getMessageDetail_ = function(){
		var deferred_messages = $q.defer();
		var promise_messages = deferred_messages.promise;
		promise_messages.then(function(result){
			if(result.message_detail != null && result.message_detail.length > 0){
				
				//log($scope.msgDetail);
				
				$scope.msgDetail.message = result.message_detail[0].message;
				$scope.msgDetail.message.msg_text = $scope.msgDetail.message.msg_text != "" ? (""+$scope.msgDetail.message.msg_text).replace(/\n/g, "<br>") : " ... ";
				
				$scope.msgDetail.showPrevResp = result.message_detail[0].message_response_list.length == 5;

				if(result.message_detail[0].message_response_list.length > 0){
					for ( var mr = 0; mr < result.message_detail[0].message_response_list.length; mr++) {
						var m_text = result.message_detail[0].message_response_list[mr].message_response.msg_text != "" ? (""+result.message_detail[0].message_response_list[mr].message_response.msg_text).replace(/\n/g, "<br>") : " ... ";
						if(m_text != "..."){
							// CHECK EMOJI
							m_text = convertDecNCR2Char(m_text);
						}
						result.message_detail[0].message_response_list[mr].message_response.msg_text = m_text;
					}
				}
				
				if($scope.msgDetail.rPage == 0){
					$scope.msgDetail.responses = result.message_detail[0].message_response_list.reverse();
					$ionicScrollDelegate.$getByHandle('messageDetailModalScroll').scrollBottom(true);
				} else {
					$scope.msgDetail.responses = result.message_detail[0].message_response_list.reverse().concat($scope.msgDetail.responses);
				}
				
				$ionicLoading.hide();
				
				$scope.messageLoading = false;
				
			}
		}, function(reason){
		});
		Messages.getMessageDetail(userId, $scope.msgDetail.msg.m_id, $scope.msgDetail.rPage, deferred_messages);
	};
	
	$scope.$on('modal.shown', function(event, modal){
		if(modal.id == "message-detail"){
			$scope.msgDetail.footer_height = $('#message_detail_footer').height();
			$scope.getMessageDetail_();
		}
	});
	
	$scope.showPrevResponses = function(){
		$scope.msgDetail.rPage++;
		$scope.getMessageDetail_();
	};
	
	$scope.showMessageDetail = function(msgd){
		
		if(msgd.m_new){
			for ( var midx = 0; midx < $scope.messages.length; midx++) {
				if($scope.messages[midx].notification.m_id == msgd.m_id){
					$scope.messages[midx].notification.m_new = false;
					break;
				}
			}
		}
		
		try {
			$scope.msgDetail = {msg:msgd, rPage:0, showPrevResp:false, showTA:false, content_bottom:0, footer_height:0, msgText: {value:""}, attachments: [], attachUploading: 0, iosDevice: (device.platform != 'android' && device.platform != 'Android'), mWidth:$(window).width()};
		} catch (e) {
			$scope.msgDetail = {msg:msgd, rPage:0, showPrevResp:false, showTA:false, content_bottom:0, footer_height:0, msgText: {value:""}, attachments: [], attachUploading: 0, iosDevice: false, mWidth:$(window).width()};
		}
		
		/*
		if(window.StatusBar && device.platform != 'android' && device.platform != 'Android'){
			StatusBar.hide();
		}
		*/

		$ionicModal.fromTemplateUrl('templates/modal-message-detail.html', {
			id: "message-detail",
			scope: $scope,
			animation: 'slide-in-right',
			focusFirstInput: false,
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalMD = modal;
			$scope.modalMD.show();
		});
		
	};
	
	$scope.showMsgTextArea = function(){
		$scope.msgDetail.showTA = true;
	};
	
	// keyboard show
	/*
	$scope.keyboardShowHandler = function(e){
		if($('#message_detail_footer').attr("id")){
			$('#message_detail_footer').css("position","fixed").css("bottom","0");
			$ionicScrollDelegate.$getByHandle('messageDetailModalScroll').scrollBottom(true);
			if($scope.msgDetail.content_bottom != 0){
				var message_detail_text = document.getElementById("message_detail_text");
				var scrollHeight = message_detail_text.scrollHeight;
				if(scrollHeight > 39){
					$('#message_detail_text').css("height", scrollHeight + "px");
					$('#message_detail_footer').css("height", scrollHeight + 10 + "px");
					var cnt_bottom = $scope.msgDetail.content_bottom;
					cnt_bottom = parseInt(cnt_bottom.replace("px",""));
					if($('#message_detail_footer').height() > $scope.msgDetail.footer_height){
						$('#message_detail_content').css("bottom", (cnt_bottom+($('#message_detail_footer').height() - $scope.msgDetail.footer_height))+'px');
					}
				}
			}
			if(!$("#message_detail_text").is(":focus")){
				$('#message_detail_text').focus();
			}
		}
	};
	window.addEventListener('native.keyboardshow', $scope.keyboardShowHandler);
	*/
	
	// keyboard hide
/*	
	$scope.keyboardHideHandler = function(e){
		if($('#message_detail_footer').attr("id")){
			$('#message_detail_footer').css("height", "44px");
			$('#message_detail_text').css("height", "34px");
			$('#message_detail_content').css("bottom", "44px");
//			try {
//				if(device.platform == 'android' || device.platform == 'Android'){
//					var cnt_bottom = $scope.msgDetail.content_bottom;
//					cnt_bottom = parseInt(cnt_bottom.replace("px",""));
//					$('#message_detail_content').css("bottom", (cnt_bottom+($('#message_detail_footer').height() - $scope.msgDetail.footer_height))+'px');
//				}
//			} catch (e) {
//			}
			//$ionicScrollDelegate.$getByHandle('messageDetailModalScroll').scrollBottom(true);
		}
	};
	window.addEventListener('native.keyboardhide', $scope.keyboardHideHandler);
*/
	$scope.msgAutoExpand = function() {
		/*
		var e = document.getElementById("message_detail_text");
		var hCheck = false;
		
		e.expandMin = 36;
		e.expandMax = 100;
		
		var vlen = e.value.length, ewidth = e.offsetWidth;
		if (vlen != e.valLength || ewidth != e.boxWidth) {

			if (hCheck && (vlen < e.valLength || ewidth != e.boxWidth)) e.style.height = "0px";
			var h = Math.max(e.expandMin, Math.min(e.scrollHeight, e.expandMax));
			e.style.overflow = (e.scrollHeight > h ? "auto" : "hidden");
			e.style.height = h + "px";
			
			e.valLength = vlen;
			e.boxWidth = ewidth;
			
			$('#message_detail_text').css("height",  h + "px");
			$('#message_detail_footer').css("height",  h + 10 + "px");
			
		}
		*/
		/*
		var scrollHeight = document.getElementById("message_detail_text").scrollHeight;
		if(scrollHeight > lastScrollHeight){
			lastScrollHeight = scrollHeight;
		}
		var lines = Math.floor(scrollHeight/16);
		lines = lines == 1 ? 20 : (lines*20);
		//document.getElementById("message_detail_text").style.height = Math.min(lines, 84) + "px";
		$('#message_detail_text').css("height", Math.min(lines, 84) + "px");
		$('#message_detail_footer').css("height", Math.min(lines, 84) + 10 + "px");
		log(scrollHeight+" -> "+lines);
		*/
		
		if($scope.msgDetail.content_bottom == 0){
			$scope.msgDetail.content_bottom = $('#message_detail_content').css("bottom");
		}
		var message_detail_text = document.getElementById("message_detail_text");
		var scrollHeight = message_detail_text.scrollHeight;
		if(scrollHeight > 36){
			$('#message_detail_text').css("height", scrollHeight + "px");
			$('#message_detail_footer').css("height", scrollHeight + 10 + "px");
			var cnt_bottom = $scope.msgDetail.content_bottom;
			cnt_bottom = parseInt(cnt_bottom.replace("px",""));
			if($('#message_detail_footer').height() > $scope.footer_height){
				$('#message_detail_content').css("bottom", (cnt_bottom+($('#message_detail_footer').height() - $scope.footer_height - 40 ))+'px');//($scope.msgDetail.iosDevice ? 40 : 0)
			}
		}
	};
	
	$scope.closeAttachments = function(){
		$scope.modalMDA.hide();
		$scope.modalMDA.remove();
	};
	
	$scope.selectAttachments = function(){
		
		$ionicActionSheet.show({
			buttons: [{text: $translate.instant('scatta_foto')},{text: $translate.instant('fai_video')},{text: $translate.instant('scegli_foto_esistente')},{text: $translate.instant('scegli_video_esistente')}],
			titleText: $translate.instant('allega_foto_video'),
			cancelText: $translate.instant('chiudi'),
			cancel: function() {
				// add cancel code..
			},
			buttonClicked: function(index) {
				if(index == 0){
					$scope.attachPhoto();
				} else if(index == 1){
					$scope.attachVideo();
				} else if(index == 2){
					$scope.attachPhotoLibrary();
				} else if(index == 3){
					$scope.attachVideoLibrary();
				}
				return true;
			}
		});
		
	};
	
	$scope.attachPhotoLibrary = function(){
//		$scope.closeAttachments();
		if(navigator.camera){
			var cameraOptions = {
				quality: 75,
				destinationType: Camera.DestinationType.FILE_URI,
				sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
				allowEdit: false,
				encodingType: Camera.EncodingType.JPEG,
				saveToPhotoAlbum: false,
				mediaType: Camera.MediaType.PICTURE
			};
			MyCamera.getPicture(cameraOptions).then(
				function(fileURIs) {
					
					for ( var f = 0; f < fileURIs.length; f++) {
						var fileURI = fileURIs[f];
						var ma = {};
						ma.id = $scope.msgDetail.attachments.length;
						ma.uri = fileURI;
						ma.thumb = fileURI;
						ma.type = "pic";
						$scope.msgDetail.attachments.push(ma);
						//log("attach photo (library): "+fileURI);
					}
					$ionicScrollDelegate.$getByHandle('messageDetailModalScroll').scrollBottom(true);
					
				}, function(err) {
				}
			);
		}
	};
	
	$scope.attachVideoLibrary = function(){
//		$scope.closeAttachments();
		if(navigator.camera){
			var cameraOptions = {
				quality: 75,
				destinationType: Camera.DestinationType.FILE_URI,
				sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
				allowEdit: false,
				encodingType: Camera.EncodingType.JPEG,
				saveToPhotoAlbum: false,
				mediaType: Camera.MediaType.VIDEO
			};
			MyCamera.getPicture(cameraOptions).then(
				function(fileURI) {
					
					var ma = {};
					ma.id = $scope.msgDetail.attachments.length;
					ma.uri = fileURI;
					ma.type = "vid";
					window.PKVideoThumbnail.createThumbnail( ma.uri, ma.uri.replace(".mp4", ".jpg").replace(".MOV", ".jpg").replace(".mov",".jpg"), function(thumb){ma.thumb = thumb}, function(){ma.thumb = ""} );
					$scope.msgDetail.attachments.push(ma);
					
					$ionicScrollDelegate.$getByHandle('messageDetailModalScroll').scrollBottom(true);

					// TODO: view http://plugreg.com/plugin/ednasgoldfishuk/VideoThumbnail
					// TODO: view https://github.com/ednasgoldfishuk/VideoThumbnail

					//log("attach video (library): "+fileURI);
				}, function(err) {
				}
			);
		}
	};
	
	$scope.attachPhoto = function(){
//		$scope.closeAttachments();
		if(navigator.camera){
			var cameraOptions = {
				quality: 75,
				destinationType: Camera.DestinationType.FILE_URI,
				sourceType: Camera.PictureSourceType.CAMERA,
				allowEdit: false,
				saveToPhotoAlbum: false
			};
			MyCamera.getPicture(cameraOptions).then(
				function(fileURI) {

					var ma = {};
					ma.id = $scope.msgDetail.attachments.length;
					ma.uri = fileURI;
					ma.thumb = fileURI;
					ma.type = "pic";
					$scope.msgDetail.attachments.push(ma);
					
					$ionicScrollDelegate.$getByHandle('messageDetailModalScroll').scrollBottom(true);

					//log("attach photo: "+fileURI);
				}, function(err) {
				}
			);
		}
	};
	
	$scope.attachVideo = function(){
//		$scope.closeAttachments();
		if(navigator.device.capture){
			var cameraOptions = {
				limit: 1
			};
			MyCamera.getVideo(cameraOptions).then(
				function(mediaFiles) {
				    for (var v = 0; v < mediaFiles.length; v ++) {
				    	
						var ma = {};
						ma.id = $scope.msgDetail.attachments.length;
						ma.uri = mediaFiles[v].fullPath;
						ma.type = "vid";
						window.PKVideoThumbnail.createThumbnail( ma.uri, ma.uri.replace(".mp4", ".jpg").replace(".MOV", ".jpg").replace(".mov",".jpg"), function(thumb){ma.thumb = thumb}, function(){ma.thumb = ""} );
						$scope.msgDetail.attachments.push(ma);
						
						$ionicScrollDelegate.$getByHandle('messageDetailModalScroll').scrollBottom(true);
						
						// TODO: view http://plugreg.com/plugin/ednasgoldfishuk/VideoThumbnail
						// TODO: view https://github.com/ednasgoldfishuk/VideoThumbnail
				    	
				        //log("attach video path: "+mediaFiles[v].fullPath);
				    }	
				}, function(err) {
				}
			);
		}
	};
	
	$scope.removeAttachment = function(attachment){
		$scope.msgDetail.attachments.splice($scope.msgDetail.attachments.indexOf(attachment), 1);
		$ionicScrollDelegate.$getByHandle('messageDetailModalScroll').scrollBottom(true);
	};
	
	$scope.sendMessage_ = function(){
		
		$ionicLoading.show({
			template: '<ion-spinner icon="circles" class="spinner-bianco"></ion-spinner>'
		});
		
		var deferred_messages = $q.defer();
		var promise_messages = deferred_messages.promise;
		promise_messages.then(function(result){
			
			//log("message_sent: "+result.message_sent);
			
			$scope.msgDetail.attachUploading = 0;
			$scope.msgDetail.msgText.value = "";
			$scope.msgDetail.attachments = [];
			$scope.msgDetail.rPage = 0;
			$scope.getMessageDetail_();
		}, function(reason){
		});
		Messages.sendMessage(userId, $scope.msgDetail.msg.m_id, $scope.msgDetail.msgText.value, attachmentsUploaded.toString(), deferred_messages);

	};
	
	$scope.sendMessageAttachment = function(){
		if($scope.msgDetail.attachments.length-1 >= $scope.msgDetail.attachUploadIdx){
			var attach = $scope.msgDetail.attachments[$scope.msgDetail.attachUploadIdx];
			var params = {};
			params.uid = userId;
			params.fn = attach.uri.substr(attach.uri.lastIndexOf('/') + 1);
			params.img = attach.type == "pic" ? 1 : 0;
			var options = new FileUploadOptions();
			options.fileName = params.fn;
			options.params = params;
			var ft = new FileTransfer();
			ft.onprogress = function(progressEvent) {
				if (progressEvent.lengthComputable) {
					$('#upload_progress_'+attach.id).css("width", ((progressEvent.loaded / progressEvent.total)*100)+"%");
				} else {
				}
			};		
			ft.upload(attach.uri, encodeURI("https://www.erosland.it/erosland_app_upload_attachment.php?uid="+userId+"&fn="+params.fn+"&img="+params.img), 
				$scope.uploadAttachmnetSuccess,
				$scope.uploadAttachmnetError,
				options
			);
		} else {
			$scope.sendMessage_();
		}
	};
	
	$scope.uploadAttachmnetSuccess = function(r){
		if(r.response != "error_move" && r.response != "error_params"){
			attachmentsUploaded.push(r.response);
		}
		$scope.msgDetail.attachUploadIdx++;
		$scope.sendMessageAttachment();
	};
	
	$scope.uploadAttachmnetError = function(error){
		//log("Message attachment upload error: "+error);		
	};
	
	$scope.sendMessage = function(){
		
		attachmentsUploaded = [];
		
		// controllo allegati
		if($scope.msgDetail.attachments.length > 0){
			$scope.msgDetail.attachUploadIdx = 0;
			$scope.msgDetail.attachUploading = 1;
			$scope.sendMessageAttachment();
		} else {
			$scope.sendMessage_();
		}
		
	};
	
	$scope.closeMessageAttachment = function(){
		$scope.modalMSA.hide();
		$scope.modalMSA.remove();
		$scope.msgSA = null;
		if(window.StatusBar){
			StatusBar.show();
		}
	};
	
	$scope.showMRAttachments = function(files, file){
		
		for ( var f = 0; f < files.length; f++) {
			if(files[f].msg_file.msg_file_folder == "files"){
				files[f].msg_file.src = $sce.trustAsResourceUrl("https://www.erosland.it/nicom1/users/"+files[f].msg_file.msg_file_user_id+"/"+files[f].msg_file.msg_file_folder+"/"+files[f].msg_file.msg_file_filename);
				files[f].msg_file.poster = $sce.trustAsResourceUrl("https://www.erosland.it/nicom1/users/"+files[f].msg_file.msg_file_user_id+"/"+files[f].msg_file.msg_file_folder+"/"+files[f].msg_file.msg_file_filename.replace("mp4","jpg"));
				//log(files[f].msg_file.src);
			}
		}
		
		$scope.msgSA = {files:files, fidx: files.indexOf(file), maWidth:$(window).width()+'px', maHeight:$(window).height()+'px'};
		
		try {
			if(window.StatusBar && device.platform != 'android' && device.platform != 'Android'){
				StatusBar.hide();
			}
		} catch (e) {
		}
		
		$ionicModal.fromTemplateUrl('templates/modal-message-show-attachments.html', {
			id: "message-show-attachments",
			scope: $scope,
			animation: 'slide-in-up',
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalMSA = modal;
			$scope.modalMSA.show();
			
		});
	};
	
});