angular.module('ctrl.myphotos', [])

.controller('MyPhotosCtrl', function($scope, $q, Files, $ionicScrollDelegate, $ionicPopup, MyCamera, $ionicActionSheet, $ionicModal, $sce, $rootScope, $ionicLoading, $translate, $timeout) {
	
	$rootScope.lastMinuteView = false;
	
	if(window.StatusBar){
		StatusBar.show();
	}
	
	$scope.fileWidth = $(window).width()/3;
	$scope.showLoadMoreMyFiles = false;
	$scope.myUserId = userId;
	$scope.filesToUpload = [];
	$scope.filesToUploadBrowser = [];
	$scope.fileUploading = 0;
	$scope.fileUploadIdx = 0;
	$scope.currentFileId = "";
	$scope.fileViewed = [];
	
	$scope.getFiles = function(){
		var deferred_files = $q.defer();
		var promise_files = deferred_files.promise;
		promise_files.then(function(result){
			
			if($scope.filesPage > 0){
				$scope.$broadcast('scroll.infiniteScrollComplete');
				$scope.files = $scope.files.concat(result.my_files);
			} else {
				$scope.files = result.my_files;
				$ionicScrollDelegate.$getByHandle('myFileList').scrollTop(false);
			}
			if(result.my_files.length < 12){
				$scope.showLoadMoreMyFiles = false;
			} else {
				$timeout(function(){$scope.showLoadMoreMyFiles = true;}, 1000);
			}
			
		}, function(reason){
			
		});
		Files.getFileList(userId, "images", $scope.filesPage, deferred_files);
	};
	
	$scope.showMyFilesMore = function(){
		$scope.filesPage++;
		$scope.getFiles();
	};
	
	$scope.showFilesGrid = function(){
		$scope.files_grid = true;
		$scope.files_list = false;
		$scope.files_upload = false;
		$('#files_grid').removeClass("button-stable").addClass("button-rosso");
		$('#files_list').removeClass("button-rosso").addClass("button-stable");
		$('#files_upload').removeClass("button-rosso").addClass("button-stable");
		$scope.showLoadMoreMyFiles = false;
		$scope.filesPage = 0;
		$scope.getFiles();
	};
	
	$scope.showFilesList = function(){
		$scope.files_grid = false;
		$scope.files_list = true;
		$scope.files_upload = false;
		$('#files_grid').removeClass("button-rosso").addClass("button-stable");
		$('#files_list').removeClass("button-stable").addClass("button-rosso");
		$('#files_upload').removeClass("button-rosso").addClass("button-stable");
		$scope.showLoadMoreMyFiles = false;
		$scope.filesPage = 0;
		$scope.getFiles();
	};

	$scope.showFilesUpload = function(){
		$scope.files_grid = false;
		$scope.files_list = false;
		$scope.files_upload = true;
		$('#files_grid').removeClass("button-rosso").addClass("button-stable");
		$('#files_list').removeClass("button-rosso").addClass("button-stable");
		$('#files_upload').removeClass("button-stable").addClass("button-rosso");
		$scope.filesPage = 0;
		$scope.getFiles();
	};
	
	$scope.showFilesGrid();
	
	$scope.lockUnlockFile = function(file){
		$ionicPopup.confirm({
			title: file.pub == 't' ? $translate.instant('rendi_privata') : $translate.instant('rendi_pubblica'),
			template: file.pub == 't' ? $translate.instant('rendi_privata_conferma') : $translate.instant('rendi_pubblica_conferma'),
			cancelText: $translate.instant('no'),
			okText: $translate.instant('si')
		}).then(function(res) {
			if(res){
				var fileU = jQuery.extend({}, file);
				fileU.pub = fileU.pub == 'f' ? 't' : 'f';
				$scope.saveUserFile(fileU);
			}
		});
	};
	
	$scope.allowDenyVoteFile = function(file){
		$ionicPopup.confirm({
			title: file.can_vote == 't' ? $translate.instant('impedisci_voto') : $translate.instant('permetti_voto'),
			template: file.can_vote == 't' ? $translate.instant('impedisci_voto_conferma') : $translate.instant('permetti_voto_conferma'),
			cancelText: $translate.instant('no'),
			okText: $translate.instant('si')
		}).then(function(res) {
			if(res){
				var fileU = jQuery.extend({}, file);
				fileU.can_vote = fileU.can_vote == 'f' ? 't' : 'f';
				$scope.saveUserFile(fileU);
			}
		});
	};
	
	$scope.selectFiles = function(){
		$ionicActionSheet.show({
			buttons: [{text: $translate.instant('scatta_foto')},{text: $translate.instant('scegli_foto_esistente')}],
			titleText: $translate.instant('carica_foto'),
			cancelText: $translate.instant('chiudi'),
			cancel: function() {
				// add cancel code..
			},
			buttonClicked: function(index) {
				if(index == 0){
					$scope.selectPhoto();
				} else if(index == 1){
					$scope.selectPhotoLibrary();
				}
				return true;
			}
		});
	};
	
	$scope.selectPhotoLibrary = function(){
		if(navigator.camera && device.platform != "browser"){
			var cameraOptions = {
				quality: 75,
				destinationType: Camera.DestinationType.FILE_URI,
				sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
				allowEdit: false,
				encodingType: Camera.EncodingType.JPEG,
				saveToPhotoAlbum: false,
				mediaType: Camera.MediaType.PICTURE
			};
			MyCamera.getPicture(cameraOptions).then(
				function(fileURIs) {
					for ( var f = 0; f < fileURIs.length; f++) {
						var fileURI = fileURIs[f];
						
						var ma = {};
						ma.id = $scope.filesToUpload.length;
						ma.uri = fileURI;
						ma.thumb = fileURI;
						ma.type = "pic";
						$scope.filesToUpload.push(ma);
						
						log("attach photo (library): "+fileURI);
					}
				}, function(err) {
				}
			);
		} else {
			$('input:file').off("change").on("change", function(evt){
				var files = evt.target.files;
			    for (var i = 0, f; f = files[i]; i++) {
			    	$scope.filesToUploadBrowser.push(f);
					var reader = new FileReader();
					reader.onload = function(evt) {
					    var fileURI = evt.target.result;
						var ma = {};
						ma.id = $scope.filesToUpload.length;
						ma.uri = fileURI;
						ma.thumb = fileURI;
						ma.type = "pic";
						$scope.filesToUpload.push(ma);
						$scope.$apply();
					}
					reader.readAsDataURL(f);
			    }
			});
			$('#files-upload').trigger("click");
		}
	};

	$scope.selectPhoto = function(){
		if(navigator.camera){
			var cameraOptions = {
				quality: 75,
				destinationType: Camera.DestinationType.FILE_URI,
				sourceType: Camera.PictureSourceType.CAMERA,
				allowEdit: false,
				saveToPhotoAlbum: false
			};
			MyCamera.getPicture(cameraOptions).then(
				function(fileURI) {
					var ma = {};
					ma.id = $scope.filesToUpload.length;
					ma.uri = fileURI;
					ma.thumb = fileURI;
					ma.type = "pic";
					$scope.filesToUpload.push(ma);
					
					log("attach photo: "+fileURI);
				}, function(err) {
				}
			);
		}
	};
	
	$scope.removeFileToUpload = function(file){
		$scope.filesToUpload.splice($scope.filesToUpload.indexOf(file), 1);
		if(device.platform == "browser"){
			$scope.filesToUploadBrowser.splice($scope.filesToUploadBrowser.indexOf(file), 1);
		}
	};
	
	$scope.uploadFiles = function(){
		if($scope.filesToUpload.length > 0){
			$scope.fileUploadIdx = 0;
			$scope.fileUploading = 1;
			$scope.uploadFile();
		}
	};
	
	$scope.uploadFile = function(){
		if($scope.filesToUpload.length-1 >= $scope.fileUploadIdx){
			if(device.platform == "browser"){
				var file = $scope.filesToUploadBrowser[$scope.fileUploadIdx];
				var file_obj = $scope.filesToUpload[$scope.fileUploadIdx];
				var xhr = new XMLHttpRequest();
				if (xhr.upload) {
					xhr.onreadystatechange=function(){
						if (xhr.readyState==4 && xhr.status==200){
							if(xhr.responseText == "success: ok"){
								$scope.uploadFileSuccess();
							}
						}
					}
					xhr.upload.addEventListener("progress", function(e) {
						var pc = Math.ceil(e.loaded / e.total * 100);
						$('#upload_progress_'+file_obj.id).css("width", pc+"%");
					}, false);
					xhr.open("POST", "https://www.erosland.it/nicomFileUpload.php?uid="+userId+"&f_vote=0&f_pub=1", true);
					xhr.setRequestHeader("X_FILENAME", file.name.replace(/[^a-z0-9\s\.]/gi, ''));
					xhr.setRequestHeader("X_FILETYPE", file.type);
					xhr.send(file);
				}
			} else {
				var file = $scope.filesToUpload[$scope.fileUploadIdx];
				var params = {};
				params.uid = userId;
				params.fn = file.uri.substr(file.uri.lastIndexOf('/') + 1);
				params.img = file.type == "pic" ? 1 : 0;
				params.f_pub = 1;
				var options = new FileUploadOptions();
				options.fileName = params.fn;
				options.params = params;
				var ft = null;
				try {
					ft = new FileTransfer();
				} catch (e) {
					alert(e);
				}
				if(ft != null){
					ft.onprogress = function(progressEvent) {
						if (progressEvent.lengthComputable) {
							$('#upload_progress_'+file.id).css("width", ((progressEvent.loaded / progressEvent.total)*100)+"%");
						} else {
						}
					};		
					ft.upload(file.uri, encodeURI("https://www.erosland.it/erosland_app_upload.php?uid="+userId+"&f_pub="+params.f_pub+"&fn="+params.fn+"&img="+params.img), 
						$scope.uploadFileSuccess,
						$scope.uploadFileError,
						options
					);
				}
			}
			
		} else {
			$scope.filesToUpload = [];
			$scope.filesToUploadBrowser = [];
			$scope.fileUploading = 0;
			$scope.fileUploadIdx = 0;
			$ionicPopup.alert({
				title: $translate.instant('caricamento_foto'),
				template: $translate.instant('caricamento_foto_completato')
			});
		}
	};
	
	$scope.uploadFileSuccess = function(r){
		/*
		if(r.response != "error_move" && r.response != "error_params"){
			attachmentsUploaded.push(r.response);
		}
		*/
		$scope.fileUploadIdx++;
		$scope.uploadFile();
	};
	
	$scope.uploadFileError = function(error){
		log("File upload error", error);		
	};
	
	$scope.closeShowMyFiles = function(){
		$scope.modalSMF.hide();
		$scope.modalSMF.remove();
		$scope.fileDett = null;
		if(window.StatusBar){
			StatusBar.show();
		}
	};
	
	$scope.showMyFiles = function(files, file){
		
		// per video
//		for ( var f = 0; f < files.length; f++) {
//			files[f].src = $sce.trustAsResourceUrl("https://www.erosland.it/nicom1/users/"+userId+"/files/"+files[f].id+".mp4");
//			files[f].poster = $sce.trustAsResourceUrl("https://www.erosland.it/nicom1/users/"+userId+"/files/"+files[f].id+".jpg");
//		}

		$scope.fileDett = {files:files, fidx: files.indexOf(file), maWidth:$(window).width()+'px', maHeight:$(window).height()+'px', folder: "images", uid:userId};
		
		$scope.currentFileId = file.id;
		$scope.fileViewed[file.id] = true;
		
		if(window.StatusBar && device.platform != 'android' && device.platform != 'Android'){
			StatusBar.hide();
		}

		$ionicModal.fromTemplateUrl('templates/modal-file-show-files.html', {
			id: "file-show-files",
			scope: $scope,
			animation: 'slide-in-up',
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalSMF = modal;
			$scope.modalSMF.show();
		});
	};
	
	$scope.closeEditFile = function(){
		$scope.modalFE.hide();
		$scope.modalFE.remove();
		$scope.fileDett = null;
		if(window.StatusBar){
			StatusBar.show();
		}
	};
	
	$scope.saveEditFile = function(){
		
		var fileU = jQuery.extend({}, $scope.fileDett.file);
		fileU.name = $scope.fileDett.fName;
		fileU.notes = $scope.fileDett.fNotes;
		
		$scope.saveUserFile(fileU);
		
		$scope.modalFE.hide();
		$scope.modalFE.remove();
		$scope.fileDett = null;
		if(window.StatusBar){
			StatusBar.show();
		}
	};
	
	$scope.$on('modal.shown', function(event, modal){
		if(modal.id == "file-edit"){
			$scope.fileDett.fileObjHeight = $(window).height() - $('#file_edit_header').height() - $('#file_edit_fields').height() - 50;
		}
	});

	$scope.editFile = function(f){
		
		// per video
//		f.src = $sce.trustAsResourceUrl("https://www.erosland.it/nicom1/users/"+userId+"/files/"+f.id+".mp4");
//		f.poster = $sce.trustAsResourceUrl("https://www.erosland.it/nicom1/users/"+userId+"/files/"+f.id+".jpg");

		$scope.fileDett = {file: f, maWidth:$(window).width()+'px', maHeight:$(window).height()+'px', folder: "images", uid:userId, fName: f.name, fNotes: f.notes, fileObjHeight: $(window).height()*0.5};
		
		if(window.StatusBar && device.platform != 'android' && device.platform != 'Android'){
			StatusBar.hide();
		}

		$ionicModal.fromTemplateUrl('templates/modal-file-edit.html', {
			id: "file-edit",
			scope: $scope,
			animation: 'slide-in-up',
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalFE = modal;
			$scope.modalFE.show();
		});
	};
	
	$scope.saveUserFile = function(file){
		var deferred_files = $q.defer();
		var promise_files = deferred_files.promise;
		promise_files.then(function(result){
			if(result.user_file_update != "error_params"){
				for ( var f = 0; f < $scope.files.length; f++) {
					if($scope.files[f].id == result.user_file_update.id){
//						result.user_file_update.pub = result.user_file_update.pub == "1" ? "t" : "f";
//						result.user_file_update.can_vote = result.user_file_update.can_vote == "1" ? "t" : "f";
//						result.user_file_update.auth = result.user_file_update.auth == "1" ? "t" : "f";
//						result.user_file_update.auth_demand = result.user_file_update.auth_demand == "1" ? "t" : "f";
//						result.user_file_update.exclude = result.user_file_update.exclude == "1" ? "t" : "f";
						$scope.files[f] = result.user_file_update;
						break;
					}
				}
			}
		}, function(reason){
		});
		Files.updateFile(file, deferred_files);
	};
	
	$scope.fileSlideHasChanged = function(index){
		$scope.currentFileId = $scope.files[index].id;
		$scope.fileViewed[$scope.files[index].id] = true;
	};
	
	$scope.deleteFile = function(file){
		$ionicPopup.confirm({
			title: $translate.instant('elimina_foto'),
			template: $translate.instant('elimina_foto_conferma'),
			cancelText: $translate.instant('no'),
			okText: $translate.instant('si')
		}).then(function(res) {
			if(res){
				$ionicLoading.show({
					template: '<ion-spinner icon="circles" class="spinner-bianco"></ion-spinner>'
				});
				var deferred_files = $q.defer();
				var promise_files = deferred_files.promise;
				promise_files.then(function(result){
					$ionicLoading.hide();
					if(result.user_file_delete == "ok"){
						$('#myfile_'+file.id).fadeIn(300, function(){
							$scope.files.splice($scope.files.indexOf(file), 1);
						});
					}
				}, function(reason){
					$ionicLoading.hide();
				});
				Files.deleteFile(file.id, "images", deferred_files);
			}
		});
	};
	
	$scope.showStatusWebApp = function(){
		$ionicPopup.alert({
			title: $translate.instant('status_foto'),
			templateUrl: 'templates/popup-photo-status.html' 
		});
	};
	
});