angular.module('ctrl.notifications', [])

.controller('NotificationsCtrl', function($scope, $q, Notifications, $ionicScrollDelegate, $rootScope, $ionicSideMenuDelegate, $state, $timeout, Subscription) {
	
	$scope.notificationsLoading = true;
	
	$scope.showLoadNewNotifications = false;
	
	$scope.pullToRefresh = "scorri_per_aggiornare";
	
	$scope.hideNotifications = false;
	
	$rootScope.lastMinuteView = false;
	
	$scope.notificationPage = 0;
	
	$scope.showLoadMoreNotifications = false;
	
	$scope.listNotifications = function(){
		var deferred_notifications = $q.defer();
		var promise_notifications = deferred_notifications.promise;
		promise_notifications.then(function(result){
			if($scope.notificationPage > 0){
				$scope.notif_list = $scope.notif_list.concat(result.notifications);
				$scope.$broadcast('scroll.infiniteScrollComplete');
			} else {
				$scope.notif_list = result.notifications;
				$ionicScrollDelegate.$getByHandle('notificationScroller').scrollTop(false);
			}
			if(result.notifications.length < 10){
				$scope.showLoadMoreNotifications = false;
			} else {
				$scope.showLoadMoreNotifications = true;
			}
			$scope.notificationCountUpdate();
			$timeout(function(){$scope.notificationsLoading = false;}, 1000);
			
		}, function(reason){
		});
		Notifications.list(userId, $scope.notificationPage, $rootScope.mySubscription == "true", deferred_notifications);
		if($scope.notificationPage == 0){
			$scope.showLoadNewNotifications = false;
		}
	};
	
	$scope.listMoreNotifications = function(){
		$scope.notificationPage = $scope.notificationPage+1;
		$scope.listNotifications();
	};
	
	var deferred_subscription = $q.defer();
	var promise_subscription = deferred_subscription.promise;
	promise_subscription.then(function(result){
		mySubscription = result.subscription;
		$rootScope.mySubscription = result.subscription;
		$scope.listNotifications();
		$scope.hideNotifications = $rootScope.mySubscription != "true";
	}, function(reason){
	});
	Subscription.check(userId, deferred_subscription);
	
	$(document).off('refreshNotifications').on('refreshNotifications', function(evt, data){
		$scope.notificationsLoading = true;
		$scope.notificationPage = 0;
		$scope.showLoadMoreNotifications = false;
		$scope.listNotifications();
	});
	
	$scope.loadNewNotifications = function(){
		$scope.notificationsLoading = true;
		$scope.notificationPage = 0;
		$scope.showLoadMoreNotifications = false;
		$scope.listNotifications();
	};

	$(document).off('loadNewNotifications').on('loadNewNotifications', function(evt, data){
		$scope.showLoadNewNotifications = true;
	});
	
	$scope.getUserProfileRequest = function(notif){
		var user_profile = "";
		/*
		if(notif.n_user_profile_type > 41){
			user_profile = notif.n_user_profile.split("|")[0];
		} else if(notif.n_user_profile_type == 4){
			user_profile = "<i class='ion-male color-blu'></i> "+(notif.n_user_age1 > 0 ? notif.n_user_age1 : "");
		} else if(notif.n_user_profile_type == 5){
			user_profile = "<i class='ion-female color-rosa'></i> "+(notif.n_user_age1 > 0 ? notif.n_user_age1 : "");
		} else if(notif.n_user_profile_type == 6){
			user_profile = "<i class='ion-male color-blu'></i> "+(notif.n_user_age1 > 0 ? notif.n_user_age1 : "");
			user_profile += "&nbsp;&nbsp;<i class='ion-female color-rosa'></i> "+(notif.n_user_age2 > 0 ? notif.n_user_age2 : "");
		} else if(notif.n_user_profile_type == 7){
			user_profile = "<i class='ion-male color-blu'></i> "+(notif.n_user_age1 > 0 ? notif.n_user_age1 : "");
			user_profile += "&nbsp;&nbsp;<i class='ion-male color-blu'></i> "+(notif.n_user_age2 > 0 ? notif.n_user_age2 : "");
		} else if(notif.n_user_profile_type == 9){
			user_profile = "<i class='ion-female color-rosa'></i> "+(notif.n_user_age1 > 0 ? notif.n_user_age1 : "");
			user_profile += "&nbsp;&nbsp;<i class='ion-female color-rosa'></i> "+(notif.n_user_age2 > 0 ? notif.n_user_age2 : "");
		}
		*/
		if(notif.n_user_profile_type > 41){
			user_profile = notif.n_user_profile.split("|")[0];
		} else if(notif.n_user_profile_type == 4){
			user_profile = "<font class='color-blu'>"+(notif.n_user_age1 > 0 ? notif.n_user_age1 : "")+"</font>";
		} else if(notif.n_user_profile_type == 5){
			user_profile = "<font class='color-rosa'>"+(notif.n_user_age1 > 0 ? notif.n_user_age1 : "")+"</font>";
		} else if(notif.n_user_profile_type == 6){
			user_profile = "<font class='color-blu'>"+(notif.n_user_age1 > 0 ? notif.n_user_age1 : "")+"</font>";
			user_profile += "&nbsp;&nbsp;<font class='color-rosa'>"+(notif.n_user_age2 > 0 ? notif.n_user_age2 : "")+"</font>";
		} else if(notif.n_user_profile_type == 7){
			user_profile = "<font class='color-blu'>"+(notif.n_user_age1 > 0 ? notif.n_user_age1 : "")+"</font>";
			user_profile += "&nbsp;&nbsp;<font class='color-blu'>"+(notif.n_user_age2 > 0 ? notif.n_user_age2 : "")+"</font>";
		} else if(notif.n_user_profile_type == 9){
			user_profile = "<font class='color-rosa'>"+(notif.n_user_age1 > 0 ? notif.n_user_age1 : "")+"</font>";
			user_profile += "&nbsp;&nbsp;<font class='color-rosa'>"+(notif.n_user_age2 > 0 ? notif.n_user_age2 : "")+"</font>";
		}
		return user_profile;
	};
	
	$scope.notificationsPulling = function(){
		$scope.pullToRefresh = "rilascia_per_aggiornare";
		$scope.$apply();
	};
	$scope.notificationsRefresh = function(){
		$scope.notificationsLoading = true;
		$scope.pullToRefresh = "scorri_per_aggiornare";
		
		$scope.notificationPage = 0;
		$scope.showLoadMoreNotifications = false;
		$scope.listNotifications();
	};
		
	if(window.StatusBar){
		StatusBar.show();
	}
});