angular.module('ctrl.personallymet', [])

.controller('PersonallyMetCtrl', function($scope, $q, $rootScope, $state, $ionicScrollDelegate, $ionicSideMenuDelegate, PersonallyMet, $ionicPopup, $translate) {
	
	$rootScope.lastMinuteView = false;
		
	$scope.lineWidth = ($(window).width()-80)+'px';
	
	$scope.personallyMetPage = 0;
	
	$scope.showLoadMorePersonallyMet = false;
	
	$scope.listPersonallyMetRequests = function(){
		var deferred_personallymet = $q.defer();
		var promise_personallymet = deferred_personallymet.promise;
		promise_personallymet.then(function(result){
			if($scope.personallyMetPage > 0){
				$scope.req_list = $scope.req_list.concat(result.user_contact.list);
				$scope.$broadcast('scroll.infiniteScrollComplete');
			} else {
				$scope.req_list = result.user_contact.list;
				$ionicScrollDelegate.$getByHandle('personallyMetScroller').scrollTop(false);
			}
			if(result.user_contact.list == null || result.user_contact.list.length < 10){
				$scope.showLoadMorePersonallyMet = false;
			} else {
				$scope.showLoadMorePersonallyMet = true;
			}
		}, function(reason){
		});
		PersonallyMet.req_list(userId, $scope.personallyMetPage, deferred_personallymet);
	};
	
	$scope.listMorePersonallyMet = function(){
		$scope.personallyMetPage = $scope.personallyMetPage+1;
		$scope.listPersonallyMetRequests();
	};
	
	$scope.listPersonallyMetRequests();
	
	$scope.pmReqAdd = function(objId){
		$ionicPopup.confirm({
			title: $translate.instant('conosciuti_di_persona'),
			template: $translate.instant('conosciuti_di_persona_conferma_richiesta'),
			cancelText: $translate.instant('annulla'),
			okText: $translate.instant('conferma')
		}).then(function(res) {
			if(res){
				var deferred_personallymet = $q.defer();
				var promise_personallymet = deferred_personallymet.promise;
				promise_personallymet.then(function(result){
					if(result.user_contact == "req_conf_ok"){
						$('#uc_'+objId).fadeOut();
						if($rootScope.pm_requests > 0){
							$rootScope.pm_requests = $rootScope.pm_requests-1;
						}
					}
				}, function(reason){
				});
				PersonallyMet.req_conf(objId, deferred_personallymet);
			}
		});
	};
	
	$scope.pmReqRem = function(objId){
		$ionicPopup.confirm({
			title: $translate.instant('conosciuti_di_persona'),
			template: $translate.instant('conosciuti_di_persona_elimina_richiesta'),
			cancelText: $translate.instant('annulla'),
			okText: $translate.instant('elimina')
		}).then(function(res) {
			if(res){
				var deferred_personallymet = $q.defer();
				var promise_personallymet = deferred_personallymet.promise;
				promise_personallymet.then(function(result){
					if(result.user_contact == "req_rem_ok"){
						$('#uc_'+objId).fadeOut();
						if($rootScope.pm_requests > 0){
							$rootScope.pm_requests = $rootScope.pm_requests-1;
						}
					}
				}, function(reason){
				});
				PersonallyMet.req_rem(objId, deferred_personallymet);
			}
		});
	};
	
	$(document).off('refreshRequests').on('refreshRequests', function(evt, data){
		$scope.personallyMetPage = 0;
		$scope.showLoadMorePersonallyMet = false;
		$scope.listPersonallyMetRequests();
	});

	if(window.StatusBar){
		StatusBar.show();
	}
});