angular.module('ctrl.search', [])

.controller('SearchCtrl', function($scope, $ionicModal, Search, $q, $ionicScrollDelegate, $rootScope, $ionicSideMenuDelegate, $state, $timeout) {
	
	$scope.scrollCheck = true;
	
	$scope.searchLoading = true;
	
	$scope.search = {nick:"", page:0, focusIn: false, focusInDelay: false, friendInput:false, searchFriends: true};
	
	$scope.pullToRefresh = "scorri_per_aggiornare";
	
	$scope.searchTop = 7;
	
	try {
		if($rootScope.mobileBrowser){
			$scope.searchTop = 7;
		} else {
			if ( device.platform == 'android' || device.platform == 'Android'){
				$scope.searchTop = 7;
			} else {
				$scope.searchTop = 27;
			}
		}
	} catch (e) {
	}
	
	$scope.nickLength = 0;
	
	$scope.searchNick_ = function(){
		
		if($scope.search.page == 0){
			$scope.searchLoading = true;
		}
		
		var deferred_search = $q.defer();
		var promise_search = deferred_search.promise;
		promise_search.then(function(result){
			$scope.searchLoading = false;
			//log(result);
			if($scope.search.searchFriends){
				if($scope.search.page == 0){
					$scope.friends = result.friends;
				} else {
					$scope.friends = $scope.friends.concat(result.friends);
				}
			} else {
				if($scope.search.page == 0){
					$scope.friends = result.users;
				} else {
					$scope.friends = $scope.friends.concat(result.users);
				}
			}
			if($scope.search.page > 0){
				$scope.$broadcast('scroll.infiniteScrollComplete');
			}
			if($scope.search.searchFriends){
				if(result.friends.length == 10){
					$scope.showLoadMoreFriends = true;
				} else {
					$scope.showLoadMoreFriends = false;
				}
			} else {
				if(result.users != null && result.users.length == 10){
					$scope.showLoadMoreFriends = true;
				} else {
					$scope.showLoadMoreFriends = false;
				}
			}
		}, function(reason){
		});
		if($scope.search.searchFriends){
			//log("search friends: "+$scope.search.nick+", "+$scope.search.page);
			Search.searchFriends(userId, $scope.search.nick, $scope.search.page, deferred_search);
		} else {
			//log("search all users: "+$scope.search.nick+", "+$scope.search.page);
			Search.searchUsers($scope.search.nick, $scope.search.page, deferred_search);
		}
	};
	
	$scope.searchNick = function(){
		$scope.search.page = 0;
		$timeout(function(){
			if($scope.nickLength != $scope.search.nick){
				$scope.nickLength = $scope.search.nick;
				$scope.searchNick_();
			}
		}, 1000);
	};
	
	$scope.searchAll = function(){
		$ionicScrollDelegate.$getByHandle('searchScroll').scrollTop(false);
		$scope.search.searchFriends = !$scope.search.searchFriends;
		$scope.search.page = 0;
		$scope.nickLength = 0;
		$scope.searchNick();
	};
	
	$scope.searchAllClose = function(){
		$scope.search.searchFriends = true;
	};
	
	$scope.searchFriendsMore = function(){
		$scope.search.page++;
		$scope.nickLength = 0;
		$scope.searchNick();
	};
	
	$scope.searchFriendClick = function(){
		$ionicScrollDelegate.$getByHandle('searchScroll').scrollTop(false);
		$scope.search.friendInput = true;
	};
	
	$scope.searchFocus = function(){
		$scope.search.focusIn = true;
		$timeout(function(){$scope.search.focusInDelay = true;}, 600);
	};
	
	$scope.getUserProfile = function(user){
		var user_profile = "";
		if(user.profile_value_id > 41){
			user_profile = user.profile;
		} else if(user.profile_value_id == 4){
			user_profile = "<font class='color-blu'>"+(user.age_1 > 0 ? user.age_1 : "")+"</font>";
		} else if(user.profile_value_id == 5){
			user_profile = "<font class='color-rosa'>"+(user.age_1 > 0 ? user.age_1 : "")+"</font>";
		} else if(user.profile_value_id == 6){
			user_profile = "<font class='color-blu'>"+(user.age_1 > 0 ? user.age_1 : "")+"</font>";
			user_profile += "&nbsp;&nbsp;<font class='color-rosa'>"+(user.age_2 > 0 ? user.age_2 : "")+"</font>";
		} else if(user.profile_value_id == 7){
			user_profile = "<font class='color-blu'>"+(user.age_1 > 0 ? user.age_1 : "")+"</font>";
			user_profile += "&nbsp;&nbsp;<font class='color-blu'>"+(user.age_2 > 0 ? user.age_2 : "")+"</font>";
		} else if(user.profile_value_id == 9){
			user_profile = "<font class='color-rosa'>"+(user.age_1 > 0 ? user.age_1 : "")+"</font>";
			user_profile += "&nbsp;&nbsp;<font class='color-rosa'>"+(user.age_2 > 0 ? user.age_2 : "")+"</font>";
		}
		return user_profile;
	};
	
	$scope.closeSearchNick = function(){
		$scope.search = {nick:"", page:0, focusIn: false, focusInDelay: false, friendInput: false, searchFriends: true};
		$ionicScrollDelegate.$getByHandle('searchScroll').scrollTop(false);
	};
	
	$rootScope.lastMinuteView = false;
	
	if(window.StatusBar){
		StatusBar.show();
	}
	
	var cw = ($(window).width()-20);
	var ch = (($(window).width()-20) * 290 / 775);
	if(cw > 775){
		cw = 775;
	}
	if(ch > 290){
		ch = 290;
	}
	$scope.sCoverWidth = cw;
	$scope.sCoverHeight = ch;
	
	window.addEventListener('orientationchange', function(){
		
		$timeout(function(){
			cw = ($(window).width()-20);
			ch = (($(window).width()-20) * 290 / 775);
			if(cw > 775){
				cw = 775;
			}
			if(ch > 290){
				ch = 290;
			}
			$scope.sCoverWidth = cw;
			$scope.sCoverHeight = ch;
			
			$scope.$apply();
		},1000);
		
	});
	
	$scope.showLoadMoreUsers = false;
	$scope.showLoadMoreFriends = false;
	
	$scope.searchProfile = {profileValueId:6, age1From:20, age1To:50, age2From:20, age2To:50, countryId:24, regionId:0, zoneId:0, cityId:0};
	
	$scope.countries = [{val:1, name:'Albania'}, {val:12, name:'Algeria'}, {val:3, name:'Australia'}, {val:2, name:'Austria'}, {val:4, name:'Belgium'}, {val:80, name:'Bosna Hercegovina'}, {val:6, name:'Brazil'}, {val:5, name:'Bulgaria'}, {val:66, name:'Byelorussia'}, {val:7, name:'Canada'}, {val:9, name:'Chile'}, {val:21, name:'Croatia'}, {val:56, name:'Cyprus'}, {val:60, name:'Czech Republic'}, {val:11, name:'Denmark'}, {val:69, name:'Emirates'}, {val:58, name:'Estonia'}, {val:15, name:'Finland'}, {val:16, name:'France'}, {val:74, name:'French Polinesia'}, {val:10, name:'Germany'}, {val:18, name:'Greece'}, {val:33, name:'Holland'}, {val:19, name:'HongKong'}, {val:55, name:'Hungary'}, {val:23, name:'Ireland'}, {val:64, name:'Israel'}, {val:24, name:'Italia'}, {val:25, name:'Japan'}, {val:57, name:'Latvia'}, {val:54, name:'Lebanon'}, {val:72, name:'Lesotho'}, {val:79, name:'Liechtensten'}, {val:59, name:'Lithuania'}, {val:28, name:'Luxembourg'}, {val:77, name:'Makedonija'}, {val:31, name:'Malta'}, {val:68, name:'Mauritius'}, {val:32, name:'Mexico'}, {val:78, name:'Moldova'}, {val:30, name:'Monaco'}, {val:29, name:'Morocco'}, {val:35, name:'New Zealand'}, {val:34, name:'Norway'}, {val:73, name:'Papua New Guinea'}, {val:40, name:'Paraguay'}, {val:36, name:'Peru'}, {val:37, name:'Philippines'}, {val:38, name:'Poland'}, {val:39, name:'Portugal'}, {val:62, name:'Repubblica di San Marino'}, {val:41, name:'Romania'}, {val:42, name:'Russia'}, {val:75, name:'Samoa New Zeland'}, {val:76, name:'Samoa USA'}, {val:43, name:'Saudi Arabia'}, {val:61, name:'Slovakia'}, {val:46, name:'Slovenia'}, {val:71, name:'South Africa'}, {val:27, name:'South Korea'}, {val:14, name:'Spain'}, {val:67, name:'Srbija - Crna Gora'}, {val:47, name:'Swaziland'}, {val:44, name:'Sweden'}, {val:8, name:'Switzerland'}, {val:50, name:'Taiwan'}, {val:48, name:'Thailand'}, {val:49, name:'Turkey'}, {val:70, name:'Ukraine'}, {val:17, name:'United Kingdom'}, {val:51, name:'USA'}, {val:63, name:'Vaticano'}]; 
	$scope.regions = [];
	$scope.zones = [];
	$scope.cities = [];
	
	$scope.countryName = "";
	$scope.regionName = "";
	$scope.zoneName = "";
	$scope.cityName = "";
	
	$scope.getCountryName = function(){
		$scope.countryName = "";
		for ( var cn = 0; cn < $scope.countries.length; cn++) {
			if($scope.countries[cn].val == $scope.searchProfile.countryId){
				$scope.countryName = $scope.countries[cn].name;
				break;
			}
		}
	};
	
	$scope.getRegionName = function(){
		$scope.regionName = "";
		for ( var rn = 0; rn < $scope.regions.length; rn++) {
			if($scope.regions[rn].val == $scope.searchProfile.regionId){
				$scope.regionName = $scope.regions[rn].name;
				break;
			}
		}
	};

	$scope.getZoneName = function(){
		$scope.zoneName = "";
		for ( var zn = 0; zn < $scope.zones.length; zn++) {
			if($scope.zones[zn].val == $scope.searchProfile.zoneId){
				$scope.zoneName = $scope.zones[zn].name;
				break;
			}
		}
	};

	$scope.getCityName = function(){
		$scope.cityName = "";
		for ( var cn = 0; cn < $scope.cities.length; cn++) {
			if($scope.cities[cn].val == $scope.searchProfile.cityId){
				$scope.cityName = $scope.cities[cn].name;
				break;
			}
		}
	};

	$scope.getCountryName();
	
	$scope.getRegionList = function(){
		var deferred_search = $q.defer();
		var promise_search = deferred_search.promise;
		promise_search.then(function(result){
			$scope.regions = [];
			for ( var r = 0; r < result.locs.length; r++) {
				var opt = result.locs[r].region.option;
				var rVal = opt.match(/value='([0-9]+)'/)[1];
				var rName = opt.match(/\&gt\;([^&]+)\&lt\;\//)[1];
				$scope.regions.push({val:rVal, name:rName});
			}
		}, function(reason){
		});
		Search.getRegions($scope.searchProfile.countryId, deferred_search);
	};
	
	$scope.getZoneList = function(){
		var deferred_search = $q.defer();
		var promise_search = deferred_search.promise;
		promise_search.then(function(result){
			$scope.zones = [];
			for ( var z = 0; z < result.locs.length; z++) {
				if(result.locs[z].zone){
					var opt = result.locs[z].zone.option;
					var zVal = opt.match(/value='([0-9]+)'/)[1];
					var zName = opt.match(/\&gt\;([^&]+)\&lt\;\//)[1];
					$scope.zones.push({val:zVal, name:zName});
				}
			}
		}, function(reason){
		});
		Search.getZones($scope.searchProfile.countryId, $scope.searchProfile.regionId, deferred_search);
	};

	$scope.getCityList = function(){
		var deferred_search = $q.defer();
		var promise_search = deferred_search.promise;
		promise_search.then(function(result){
			$scope.cities = [];
			for ( var c = 0; c < result.locs.length; c++) {
				if(result.locs[c].city){
					var opt = result.locs[c].city.option;
					var cVal = opt.match(/value='([0-9]+)'/)[1];
					var cName = opt.match(/\&gt\;([^&]+)\&lt\;\//)[1];
					$scope.cities.push({val:cVal, name:cName});
				}
			}
		}, function(reason){
		});
		Search.getCities($scope.searchProfile.countryId, $scope.searchProfile.regionId, $scope.searchProfile.zoneId, deferred_search);
	};
	
	$scope.countrySelected = function(){
		$scope.regions = [];
		$scope.zones = [];
		$scope.cities = [];
		$scope.getRegionList();
		$scope.getCountryName();
	};

	$scope.regionSelected = function(){
		$scope.getRegionName();
		$scope.cities = [];
		$scope.searchProfile.cityId = 0;
		if($scope.searchProfile.regionId==0){
			$scope.zones = [];
			$scope.searchProfile.zoneId = 0;
		} else {
			$scope.getZoneList();
		}
	};
	
	$scope.zoneSelected = function(){
		$scope.getZoneName();
		if($scope.searchProfile.zoneId==0){
			$scope.cities = [];
			$scope.searchProfile.cityId = 0;
		} else {
			$scope.getCityList();
		}
	};

	$scope.citySelected = function(){
		$scope.getCityName();
	};
	
	$scope.checkAge1From = function(){
		if($scope.searchProfile.age1From > $scope.searchProfile.age1To){
			$scope.searchProfile.age1To = parseInt($scope.searchProfile.age1From)+1;
			if($scope.searchProfile.age1To == 71){
				$scope.searchProfile.age1To = 70;
			}
		}
	};

	$scope.checkAge1To = function(){
		if($scope.searchProfile.age1From > $scope.searchProfile.age1To){
			$scope.searchProfile.age1From = parseInt($scope.searchProfile.age1To)-1;
			if($scope.searchProfile.age1From == 17){
				$scope.searchProfile.age1From = 18;
			}
		}
	};

	$scope.checkAge2From = function(){
		if($scope.searchProfile.age2From > $scope.searchProfile.age2To){
			$scope.searchProfile.age2To = parseInt($scope.searchProfile.age2From)+1;
			if($scope.searchProfile.age2To == 71){
				$scope.searchProfile.age2To = 70;
			}
		}
	};

	$scope.checkAge2To = function(){
		if($scope.searchProfile.age2From > $scope.searchProfile.age2To){
			$scope.searchProfile.age2From = parseInt($scope.searchProfile.age2To)-1;
			if($scope.searchProfile.age2From == 17){
				$scope.searchProfile.age2From = 18;
			}
		}
	};

	$scope.getRegionList();
	
	$scope.closeModalSearch = function(){
		$scope.modalSPT.hide();
		$scope.modalSPT.remove();
	};
	
	$scope.selectProfType = function(){
		$ionicModal.fromTemplateUrl('templates/modal-search-proftype.html', {
			id: "search-proftype",
			scope: $scope,
			animation: 'slide-in-up',
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalSPT = modal;
			$scope.modalSPT.show();
		});
	};
	
	$scope.selectAge1 = function(){
		$ionicModal.fromTemplateUrl('templates/modal-search-age1.html', {
			id: "search-age1",
			scope: $scope,
			animation: 'slide-in-up',
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalSPT = modal;
			$scope.modalSPT.show();
		});
	};

	$scope.selectAge2 = function(){
		$ionicModal.fromTemplateUrl('templates/modal-search-age2.html', {
			id: "search-age2",
			scope: $scope,
			animation: 'slide-in-up',
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalSPT = modal;
			$scope.modalSPT.show();
		});
	};
	
	$scope.selectProfLocation = function(){
		$ionicModal.fromTemplateUrl('templates/modal-search-location.html', {
			id: "search-location",
			scope: $scope,
			animation: 'slide-in-up',
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalSPT = modal;
			$scope.modalSPT.show();
		});
	};

	$scope.closeSearchProfType = function(){
		$scope.modalSPT.hide();
		$scope.modalSPT.remove();
		
		$scope.users = [];
		$scope.searchUsersPage = 0;
		$scope.searchUsers();
		
	};
	
	$scope.users = [];
	$scope.searchUsersPage = 0;
	$scope.lastLoginTime = 0;

	$scope.searchUsers = function(){
		
		if($ionicScrollDelegate.$getByHandle('searchScroll').getScrollPosition().top == 0 && $scope.searchUsersPage > 0){
			$scope.searchUsersPage--;
			$scope.$broadcast('scroll.infiniteScrollComplete');
			return;
		}
		
		var deferred_search = $q.defer();
		var promise_search = deferred_search.promise;
		promise_search.then(function(result){
			
			var cur_date = new Date();
			
			$scope.lastLoginTime = result.users[result.users.length-1].user.last_login;
			
			for ( var uidx = 0; uidx < result.users.length; uidx++) {
				var profile = "";
				var usr = result.users[uidx];
				if(usr.user.age_1 != null){
					profile = $scope.getUserProfile(usr.user);
					/*
					if(usr.user.profile.indexOf("Trav") == -1){
						profile += usr.user.profile.indexOf("donna, donna") != -1 || usr.user.profile.indexOf("Donna") != -1 || usr.user.profile.indexOf("woman, woman") != -1 || usr.user.profile.indexOf("Woman") != -1 ? "<i class='ion-female color-rosa'></i>" : "<i class='ion-male color-blu'></i>";
					}
					profile += " "+usr.user.age_1;
					if(usr.user.age_2 != null && usr.user.age_2 != "null"){
						profile += usr.user.profile.indexOf("uomo, uomo") != -1 || usr.user.profile.indexOf("man, man") != -1 || usr.user.profile.indexOf("Uomo") != -1 || (usr.user.profile.indexOf("Man") != -1 && usr.user.profile.indexOf("Woman") == -1) ? " <i class='ion-male color-blu'></i>" : " <i class='ion-female color-rosa'></i>";
						profile += " "+usr.user.age_2;
					}
					*/
				}
				
				usr.user.userProfile = profile == "" ? usr.user.profile : profile;

				var ll_date = new Date(parseInt(usr.user.last_login));
				if(cur_date.getDate() == ll_date.getDate()){
					usr.user.lastLogin = ll_date.getHours()+":"+(ll_date.getMinutes()<10 ? "0"+ll_date.getMinutes() : ll_date.getMinutes());
				} else {
					usr.user.lastLogin = ll_date.getDate() + "/" + (ll_date.getMonth()+1)+" "+ll_date.getHours()+":"+(ll_date.getMinutes()<10 ? "0"+ll_date.getMinutes() : ll_date.getMinutes());
				}
				
				if($scope.regionName != ""){
					usr.user.location = usr.user.location.replace($scope.regionName, "");
				}

				$scope.users.push(usr);
			}
			
			$scope.$broadcast('scroll.refreshComplete');
			
			if($scope.searchUsersPage > 0){
				$scope.$broadcast('scroll.infiniteScrollComplete');
			}
			
			if(result.users.length == 10){
				$scope.showLoadMoreUsers = true;
			} else {
				$scope.showLoadMoreUsers = false;
			}
			
			$scope.searchLoading = false;			
			
		}, function(reason){
		});
		Search.getUsers(userId,
			$scope.searchProfile.profileValueId,
			$scope.searchProfile.countryId,
			$scope.searchProfile.regionId == 0 ? "X" : $scope.searchProfile.regionId,
			$scope.searchProfile.zoneId == 0 ? "X" : $scope.searchProfile.zoneId,
			$scope.searchProfile.cityId == 0 ? "X" : $scope.searchProfile.cityId,
			$scope.searchProfile.profileValueId != 42 && $scope.searchProfile.profileValueId != 51 ? $scope.searchProfile.age1From : "X",
			$scope.searchProfile.profileValueId != 42 && $scope.searchProfile.profileValueId != 51 ? $scope.searchProfile.age1To : "X",
			$scope.searchProfile.profileValueId == 6 || $scope.searchProfile.profileValueId == 7 || $scope.searchProfile.profileValueId == 9 ? $scope.searchProfile.age2From : "X",
			$scope.searchProfile.profileValueId == 6 || $scope.searchProfile.profileValueId == 7 || $scope.searchProfile.profileValueId == 9 ? $scope.searchProfile.age2To : "X",
			$scope.searchUsersPage,
			$scope.lastLoginTime,
			deferred_search);
	};
	
	$scope.searchUsersMore = function(){
		$scope.searchUsersPage++;
		$scope.searchUsers();
	};
	
	$scope.searchPulling = function(){
		$scope.pullToRefresh = "rilascia_per_aggiornare";
		$scope.$apply();
	};
	$scope.searchRefresh = function(){
		$scope.pullToRefresh = "scorri_per_aggiornare";
		
		$scope.users = [];
		$scope.searchUsersPage = 0;
		$scope.lastLoginTime = 0;
		$scope.searchUsers();
	};
	
	$scope.showModalUserSearch = function(uid){
		try {
			cordova.plugins.Keyboard.close();
		} catch (e) {
		}
		$timeout(function(){$scope.showModalUser(uid);}, 1000);
	};
	
	setTimeout(function(){
		//$('#header_bar').addClass("header-bar-shadow");
		$scope.searchUsers();
	}, 1000);
	
	$scope.searchScrolling = function(){
		if($scope.scrollCheck && $ionicScrollDelegate.$getByHandle('searchScroll').getScrollPosition().top > $(window).width()){
			$scope.scrollCheck = false;
		}
	};
	$scope.seachScrollComplete = function(){
		if($ionicScrollDelegate.$getByHandle('searchScroll').getScrollPosition().top <= 0){
			$scope.scrollCheck = true;
		}
	};
	$scope.scrollSearchTop = function(){
		$scope.scrollTopClicked = true;
		$ionicScrollDelegate.$getByHandle('searchScroll').scrollTop(true);
		$timeout(function(){$scope.scrollCheck = true;},300);
	};
	
});