angular.module('ctrl.video', [])

.controller('VideoCtrl', function($scope, $ionicModal, Video, $q, $rootScope, Subscription) {
	
	$scope.hideVideos = false;
	
	$scope.videoSearch = {profileValueId:6, orderBy: 1, time: 1, page: 0};
	
	$scope.pullToRefresh = "scorri_per_aggiornare";
			
	$scope.getUserProfile = function(user){
		var user_profile = "";
		if(user.profile_value_id > 41){
			user_profile = user.profile;
		} else if(user.profile_value_id == 4){
			user_profile = "<i class='ion-male color-blu'></i> "+(user.age_1 > 0 ? user.age_1 : "");
		} else if(user.profile_value_id == 5){
			user_profile = "<i class='ion-female color-rosa'></i> "+(user.age_1 > 0 ? user.age_1 : "");
		} else if(user.profile_value_id == 6){
			user_profile = "<i class='ion-male color-blu'></i> "+(user.age_1 > 0 ? user.age_1 : "");
			user_profile += "&nbsp;&nbsp;<i class='ion-female color-rosa'></i> "+(user.age_2 > 0 ? user.age_2 : "");
		} else if(user.profile_value_id == 7){
			user_profile = "<i class='ion-male color-blu'></i> "+(user.age_1 > 0 ? user.age_1 : "");
			user_profile += "&nbsp;&nbsp;<i class='ion-male color-blu'></i> "+(user.age_2 > 0 ? user.age_2 : "");
		} else if(user.profile_value_id == 9){
			user_profile = "<i class='ion-female color-rosa'></i> "+(user.age_1 > 0 ? user.age_1 : "");
			user_profile += "&nbsp;&nbsp;<i class='ion-female color-rosa'></i> "+(user.age_2 > 0 ? user.age_2 : "");
		}
		return user_profile;
	};
	
	if(window.StatusBar){
		StatusBar.show();
	}
	
	var cw = ($(window).width()-20);
	var ch = (($(window).width()-20) * 240 / 320);
	if(cw > 320){
		cw = 320;
	}
	if(ch > 240){
		ch = 240;
	}
	$scope.sCoverWidth = cw;
	$scope.sCoverHeight = ch;
	$scope.wWidth = $(window).width();
	
	window.addEventListener('orientationchange', function(){
		cw = ($(window).width()-20);
		ch = (($(window).width()-20) * 240 / 320);
		if(cw > 320){
			cw = 320;
		}
		if(ch > 240){
			ch = 240;
		}
		$scope.sCoverWidth = cw;
		$scope.sCoverHeight = ch;
		$scope.wWidth = $(window).width();
	});
	
	
	$scope.showLoadMoreVideos = false;
	
	/*
	$scope.videos = [
	                 {id: 1, uid: 308314, views: 123, file: {userRank:9.85, commentsCount:6, name:"Senza titolo che poi sarebbe il titolo.", userVotes:20, desc:"", canVote:true, fileId:"HEGRGWEC"}},
	                 {id: 2, uid: 335215, views: 57, file: {userRank:9.85, commentsCount:6, name:"Senza titolo che poi sarebbe il titolo.", userVotes:20, desc:"", canVote:false, fileId:"KG9Q83BV"}}
	                 ];
	*/
	$scope.videoList = function(){
		var deferred_video = $q.defer();
		var promise_video = deferred_video.promise;
		promise_video.then(function(result){
			
			if($scope.videoSearch.page == 0){
				$scope.videos = result.video_list;
			} else {
				$scope.videos = $scope.videos.concat(result.video_list);
			}
			
			$scope.$broadcast('scroll.refreshComplete');
			
			if($scope.videoSearch.page > 0){
				$scope.$broadcast('scroll.infiniteScrollComplete');
			}
			
			if(result.video_list.length == 10){
				$scope.showLoadMoreVideos = true;
			} else {
				$scope.showLoadMoreVideos = false;
			}
			
		}, function(reason){
		});
		Video.list($scope.videoSearch.profileValueId, $scope.videoSearch.orderBy, $scope.videoSearch.time, $scope.videoSearch.page, deferred_video);
	};
	
	var deferred_subscription = $q.defer();
	var promise_subscription = deferred_subscription.promise;
	promise_subscription.then(function(result){
		mySubscription = result.subscription;
		$rootScope.mySubscription = result.subscription;
		$scope.videoList();
		$scope.hideVideos = $rootScope.mySubscription != "true";
	}, function(reason){
	});
	Subscription.check(userId, deferred_subscription);
	
	$scope.loadMoreVideos = function(){
		$scope.videoSearch.page++;
		$scope.videoList();
	};
	
	$scope.videoPulling = function(){
		$scope.pullToRefresh = "rilascia_per_aggiornare";
		$scope.$apply();
	};
	$scope.videoRefresh = function(){
		$scope.pullToRefresh = "scorri_per_aggiornare";
		
		$scope.videoSearch.page = 0;
		$scope.videoList();
	};
	
	$scope.showHideVideoNick = function(vid){
		if($('#videonick_'+vid).hasClass("animated")){
			$('#videonick_'+vid).removeClass("animated fadeInLeft");
		} else {
			$('#videonick_'+vid).addClass("animated fadeInLeft");
		}
		/*
		if($('#videonickcnt_'+vid).width() == 60){
			$('#videonickcnt_'+vid).animate({'width':($scope.sCoverWidth-15)+'px', 'border-top-left-radius':'30px', 'border-bottom-left-radius':'30px', 'border-top-right-radius':'3px', 'border-bottom-right-radius':'3px'},500)
		} else {
			$('#videonickcnt_'+vid).animate({'width':'60px', 'border-top-left-radius':'30px', 'border-bottom-left-radius':'30px', 'border-top-right-radius':'30px', 'border-bottom-right-radius':'30px'},500)
		}
		*/
	};
	
	$scope.showUserOrVideo = function(vid){
		if($('#videonick_'+vid.file.fileId).hasClass("animated")){
			$scope.showModalUser(vid.uid);
		} else {
			$scope.showUserVideo(vid);
		}
	};
	
	$scope.showUserVideo = function(vid){
		$rootScope.selectedMUId = vid.uid;
		$rootScope.mud = [];
		$rootScope.mud["modalData"+$rootScope.selectedMUId] = {};
		$rootScope.mud["modalData"+$rootScope.selectedMUId].videos = [vid];
		$scope.showVideo(vid.file);
		
	};
	
	$scope.selectProfType = function(){
		$ionicModal.fromTemplateUrl('templates/modal-video-proftype.html', {
			id: "video-proftype",
			scope: $scope,
			animation: 'slide-in-up',
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalSVT = modal;
			$scope.modalSVT.show();
		});
	};
	
	$scope.selectOrder = function(){
		$ionicModal.fromTemplateUrl('templates/modal-video-order.html', {
			id: "video-order",
			scope: $scope,
			animation: 'slide-in-up',
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalSVT = modal;
			$scope.modalSVT.show();
		});
	};
	
	$scope.selectTime = function(){
		$ionicModal.fromTemplateUrl('templates/modal-video-time.html', {
			id: "video-time",
			scope: $scope,
			animation: 'slide-in-up',
			hardwareBackButtonClose: false
		}).then(function(modal) {
			$scope.modalSVT = modal;
			$scope.modalSVT.show();
		});
	};

	$scope.closeModalVideo = function(){
		$scope.modalSVT.hide();
		$scope.modalSVT.remove();
	};
	
	$scope.closeVideoProfType = function(){
		$scope.modalSVT.hide();
		$scope.modalSVT.remove();

		// reload videos
		$scope.videoSearch.page = 0;
		$scope.videoList();
		
	};
	
});