angular.module('srv.events', [])

.factory('Events', function($http){
	
	return {
		
		getEvents: function(sqr_lat1, sqr_lat2, sqr_lng1, sqr_lng2, dateTime, deferred_events){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonGeolocationGetEvents&sp=f'+sqr_lat1+'&sp=f'+sqr_lat2+'&sp=f'+sqr_lng1+'&sp=f'+sqr_lng2+'&sp=S'+dateTime, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_events.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_events.reject("error call");
			});
		},
		
		getEventDetails: function(eventId, deferred_events){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonEventDetails&sp='+eventId, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_events.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_events.reject("error call");
			});
		},
		
		eventJoinRequest: function(eventId, userId, deferred_events){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonEventJoinExt&sp='+userId+'&sp='+eventId, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_events.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_events.reject("error call");
			});
		},
		
		eventJoin: function(eventId, userId, status, deferred_events){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonEventJoin&sp='+userId+'&sp='+eventId+'&sp='+(status == 0 ? "T" : "F")+'&sp='+(status == 2 ? "T" : "F")+'&sp='+(status == 1 ? "T" : "F"), dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_events.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_events.reject("error call");
			});
		},

		countJoinUsers: function(eventId, userId, status, deferred_events){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonEventInfo&sp='+eventId+'&sp='+userId+'&sp='+status, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_events.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_events.reject("error call");
			});
		},
		
		listJoinUsers: function(eventId, yes_val, maybe_val, no_val, standby_val, userType, page, userId, friends, nick, deferred_events){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=xml&context=JoinUsers&sp='+eventId+'&sp='+yes_val+'&sp='+maybe_val+'&sp='+no_val+'&sp='+standby_val+'&sp='+userType+'&sp='+page+'&sp='+userId+'&sp='+friends+'&sp='+nick, dataType: 'xml'})
			.success(function(data, status, headers, config){
				deferred_events.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_events.reject("error call");
			});
		},
		
		listWall: function(eventId, userId, lastWallId, deferred_events){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonEventWallList&sp='+eventId+'&sp='+userId+'&sp='+lastWallId, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_events.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_events.reject("error call");
			});
		},
		
		sendWallMessage: function(eventId, userId, txt, deferred_events){
			$http.post('https://www.erosland.it/nicom1/nicom1?service=json&context=JsonEventWallWrite&sp='+userId+'&sp='+eventId, {'txt':txt}, {cache: false, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_events.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_events.reject("error call");
			});
		}
		
				
	}

});