angular.module('srv.files', [])

.factory('Files', function($http){
	
	return {
		
		getFileList: function(userId, folder, page, deferred_files){
			$http({method: "POST",cache: false,url: 'https://www.erosland.it/ajax/myFiles.php',data: {'uid':userId,'folder':folder,'page':page},dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_files.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_files.reject("error call");
			});
		},
		
		updateFile: function(file, deferred_files){
			$http.post('https://www.erosland.it/nicom1/nicom1', 'service=json&context=JsonUserFileUpdate&sp=S'+file.id+'&sp=S'+file.name+'&sp=S'+file.notes+'&sp='+(file.pub == "t" ? "T" : "F")+'&sp='+(file.can_vote == "t" ? "T" : "F"), {cache: false, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_files.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_files.reject("error call");
			});
		},
		
		deleteFile: function(fileId, folder, deferred_files){
			$http.post('https://www.erosland.it/nicom1/nicom1', 'service=json&context=JsonUserFileDelete&sp=S'+fileId+'&sp=S'+folder, {cache: false, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_files.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_files.reject("error call");
			});
		},
		
		fileView: function(fileId, deferred_files){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonUserFileView&sp=S'+fileId, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_files.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_files.reject("error call");
			});
		}
		
	}

});