angular.module('srv.friends', [])

.factory('Friends', function($http){
	
	return {
		
		// Lista richieste amicizia
		getRequests: function(userId, page, deferred_friends){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonNotifications&sp='+userId+'&sp=Slist&sp=1&sp='+page, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_friends.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_friends.reject("error call");
			});
		},
		
		// Lista suggerimenti amicizia
		getSuggestions: function(userId, page, deferred_friends){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonNotifications&sp='+userId+'&sp=Slist&sp=2&sp='+page, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_friends.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_friends.reject("error call");
			});
		},
		
		// Accetta, rifiuta, ignora richiesta amicizia. action: 1 accetta, 2 rifiuta, 3 ignora
		friendRequestAction: function(userId, obj_id, action, deferred_friends){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonInvites&sp='+userId+'&sp='+obj_id+'&sp='+action, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_friends.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_friends.reject("error call");
			});
		},
		
		// Accetta, rifiuta, ignora suggerimento amicizia. action: 1 accetta, 2 rifiuta, 3 ignora
		friendSuggestionAction: function(userId, obj_id, action, deferred_friends){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonFriendSuggestion&sp='+userId+'&sp='+obj_id+'&sp='+action, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_friends.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_friends.reject("error call");
			});
		},
		
		areFriends: function(userId, selectedUserId, deferred_friends){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonCheckFriendship&sp='+userId+'&sp='+selectedUserId, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_friends.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_friends.reject("error call");
			});
		},
		
		addFriend: function(userId, selectedUserId, deferred_friends){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonSendFriendshipRequest&sp='+userId+'&sp='+selectedUserId, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_friends.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_friends.reject("error call");
			});
		},
		
		checkFan: function(userId, selectedUserId, deferred_friends){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=xml&context=Fan&sp='+userId+'&sp='+selectedUserId+'&sp=0', dataType: 'xml'})
			.success(function(data, status, headers, config){
				deferred_friends.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_friends.reject("error call");
			});
		},
		
		addFan: function(userId, selectedUserId, deferred_friends){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=xml&context=Fan&sp='+userId+'&sp='+selectedUserId+'&sp=1', dataType: 'xml'})
			.success(function(data, status, headers, config){
				deferred_friends.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_friends.reject("error call");
			});
		}
		
	}

});