angular.module('srv.search', [])

.factory('Search', function($http){
	
	return {
		
		getRegions: function(countryId, deferred_search){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonLocale&sp='+countryId, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_search.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_search.reject("error call");
			});
		},
				
		getZones: function(countryId, regionId, deferred_search){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonLocale&sp='+countryId+'&sp='+regionId, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_search.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_search.reject("error call");
			});
		},

		getCities: function(countryId, regionId, zoneId, deferred_search){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonLocale&sp='+countryId+'&sp='+regionId+'&sp='+zoneId, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_search.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_search.reject("error call");
			});
		},
		
		getUsers: function(userId, profileValueId, countryId, regionId, zoneId, cityId, age1From, age1To, age2From, age2To, page, lastLoginTime, deferred_search){
			
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonUserSearch&sp='+userId+'&sp='+profileValueId+'&sp='+countryId+'&sp='+regionId+'&sp='+zoneId+'&sp='+cityId+'&sp='+age1From+'&sp='+age1To+'&sp='+age2From+'&sp='+age2To+'&sp='+page+'&sp=S'+lastLoginTime, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_search.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_search.reject("error call");
			});
		},
		
		searchFriends: function(userId, nick, page, deferred_search){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonSearchFriends&sp='+userId+'&sp=S'+nick+'&sp='+page, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_search.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_search.reject("error call");
			});
		},
		
		searchUsers: function(nick, page, deferred_search){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonSearchAllUsers&sp=S'+nick+'&sp='+page, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_search.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_search.reject("error call");
			});
		}

	}

});