angular.module('srv.user', [])

.factory('UserProfile', function($http){
	return {
		
		getHtml: function(selectedUserId, deferred_userProfile){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/users/'+selectedUserId+'/erosland/u_it', dataType: 'html'})
			.success(function(data, status, headers, config){
				deferred_userProfile.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_userProfile.reject("error call");
			});
		},
		
		getInfo: function(selectedUserId, deferred_userProfile){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonUserInfo&sp='+selectedUserId, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_userProfile.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_userProfile.reject("error call");
			});
		},
		
		getPhotos: function(userId, selectedUserId, page, deferred_userProfile){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonUserPhotos&sp='+userId+'&sp='+selectedUserId+'&sp='+page+"&sp=X&sp=X&sp=F", dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_userProfile.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_userProfile.reject("error call");
			});
		},
		
		countPhotos: function(userId, selectedUserId, deferred_userProfile){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonUserPhotos&sp='+userId+'&sp='+selectedUserId+'&sp=0&sp=X&sp=X&sp=F&sp=T', dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_userProfile.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_userProfile.reject("error call");
			});
		},
		
		getPhotosApproved: function(userId, selectedUserId, page, deferred_userProfile){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonUserPhotos&sp='+userId+'&sp='+selectedUserId+'&sp='+page+"&sp=X&sp=X&sp=T", dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_userProfile.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_userProfile.reject("error call");
			});
		},

		countPhotosApproved: function(userId, selectedUserId, deferred_userProfile){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonUserPhotos&sp='+userId+'&sp='+selectedUserId+'&sp=0&sp=X&sp=X&sp=T&sp=T', dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_userProfile.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_userProfile.reject("error call");
			});
		},

		getVideos: function(userId, selectedUserId, page, deferred_userProfile){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonUserPhotos&sp='+userId+'&sp='+selectedUserId+'&sp='+page+'&sp=Sfiles', dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_userProfile.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_userProfile.reject("error call");
			});
		},
		
		showUserFeedback: function(userId, page, deferred_userProfile){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonUserFeedbacks&sp='+userId+'&sp='+page, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_userProfile.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_userProfile.reject("error call");
			});
		},
		
		getFeedbacksInfo: function(userId, deferred_userProfile){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonUserFeedbacksInfo&sp='+userId, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_userProfile.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_userProfile.reject("error call");
			});
		},
		
		canFeedback: function(userId, selectedUserId, deferred_userProfile){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonUserFeedbackCheck&sp='+userId+'&sp='+selectedUserId, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_userProfile.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_userProfile.reject("error call");
			});
		},
		
		actFileVotes: function(action, fileId, vote, idUpi, page, deferred_fileVotes){
			if("add" == action){
				// vota file, parametri: "add", "FILEID", vote, idUpi

				$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=xml&context=FileVotes&sp=Sadd&sp=S'+fileId+'&sp='+vote+'&sp='+idUpi, dataType: 'xml'})
				.success(function(data, status, headers, config){
					deferred_fileVotes.resolve(data);
				}).error(function(data, status, headers, config){
					deferred_fileVotes.reject("error call");
				});
				
			} else if("list" == action){
				// lista voti, parametri: "list", "FILEID", null, null, page
				
				$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=xml&context=FileVotes&sp=Slist&sp=S'+fileId+'&sp=X&sp=X&sp='+page, dataType: 'xml'})
				.success(function(data, status, headers, config){
					deferred_fileVotes.resolve(data);
				}).error(function(data, status, headers, config){
					deferred_fileVotes.reject("error call");
				});
				
			}
		},
		
		actFileComments: function(action, fileId, fileCommentId, comment, page, idUpi, idUser, deferred_fileComments){
			if("abuse" == action){
				// segnalazione abuso, parametri: "abuse", fileCommentId, "testo segnalazione", idUpi
				
				$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=xml&context=FileComments&sp=Sabuse&sp=S'+fileCommentId+'&sp=S'+comment+'&sp='+idUpi, dataType: 'xml'})
				.success(function(data, status, headers, config){
					deferred_fileComments.resolve(data);
				}).error(function(data, status, headers, config){
					deferred_fileComments.reject("error call");
				});

			} else if("cnt" == action){
				// conteggio commenti, parametri: "cnt", "FILEID"
				
				$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=xml&context=FileComments&sp=Scnt&sp=S'+fileId, dataType: 'xml'})
				.success(function(data, status, headers, config){
					deferred_fileComments.resolve(data);
				}).error(function(data, status, headers, config){
					deferred_fileComments.reject("error call");
				});

			} else if("add" == action){
				// aggiungi commento, parametri: "add", "FILEID", "testo commento", idUpi
				
				$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=xml&context=FileComments&sp=Sadd&sp=S'+fileId+'&sp=S'+comment+'&sp='+idUpi, dataType: 'xml'})
				.success(function(data, status, headers, config){
					deferred_fileComments.resolve(data);
				}).error(function(data, status, headers, config){
					deferred_fileComments.reject("error call");
				});

			} else if("del" == action){
				// rimuovi commento, parametri: "del", fileCommentId

				$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=xml&context=FileComments&sp=Sdel&sp='+fileCommentId, dataType: 'xml'})
				.success(function(data, status, headers, config){
					deferred_fileComments.resolve(data);
				}).error(function(data, status, headers, config){
					deferred_fileComments.reject("error call");
				});
				
			} else if("list" == action){
				// lista commenti, parametri: "list", "FILEID", page, idUpi, idUser
				
				$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=xml&context=FileComments&sp=Slist&sp=S'+fileId+'&sp='+page+'&sp='+idUpi+'&sp='+idUser, dataType: 'xml'})
				.success(function(data, status, headers, config){
					deferred_fileComments.resolve(data);
				}).error(function(data, status, headers, config){
					deferred_fileComments.reject("error call");
				});
			}
			
		}
		
	}
});