angular.module('erosland.services', [])

.factory('Settings', function($http){
	return {
		check_setting: function(userId, setting, deferred_settings){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/ajax/app_settings.php?uid='+userId+'&s='+setting+'&act=check', dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_settings.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_settings.reject(data);
			});
		}
	}
})

.factory('Abuse', function($http){
	return {
		report: function(object_id, object_type, sender_id, message, deferred_abuse){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonAbuse&sp='+sender_id+'&sp='+object_id+'&sp=S'+object_type+'&sp=S'+message, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_abuse.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_abuse.reject(data);
			});
		}
	}
})

.factory('Subscription', function($http){
	return {
		check: function(user_id, deferred_subscription){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonCheckSubscription&sp='+user_id, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_subscription.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_subscription.reject(data);
			});
		}
	}
})

.factory('Geolocation', function($http){
	return {
		setPosition: function(user_id, latitude, longitude, error_code, hidden, deferred_geolocation){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonSetGeolocation&sp='+user_id+'&sp=S'+latitude+'&sp=S'+longitude+'&sp='+error_code+'&sp=S0.0.0.0'+'&sp='+(hidden ? 'T': 'F'), dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_geolocation.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_geolocation.reject(data);
			});
		},
		
		getGeolocationStatus: function(user_id, deferred_geolocation){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonGetUserGeolocation&sp='+user_id, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_geolocation.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_geolocation.reject(data);
			});
		},
		
		setPositionStatus: function(user_id, status_type, status_name, visible_all, personally_met, deferred_geolocation){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonSetGeolocationStatus&sp='+user_id+'&sp='+status_type+'&sp=S'+status_name+'&sp='+(visible_all ? 'T': 'F')+'&sp='+(personally_met ? 'T': 'F'), dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_geolocation.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_geolocation.reject(data);
			});
		}
		
	}
})

.factory('NotificationSettings', function($http){
	return {
		get: function(userId, deferred_notifications){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonNotificationSettings&sp='+userId, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_notifications.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_notifications.reject(data);
			});
		},
		
		set: function(userId, n_type, n_enabled, deferred_notifications){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonNotificationSettings&sp='+userId+'&sp='+n_type+'&sp='+(n_enabled ? "T" : "F"), dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_notifications.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_notifications.reject(data);
			});
		},
		
		email_get: function(userId, deferred_notifications){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonEmailSettingsList&sp='+userId, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_notifications.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_notifications.reject(data);
			});
		},
		
		email_set: function(userId, email_id, email_enabled, deferred_notifications){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonEmailSettingsUpdate&sp='+userId+'&sp='+email_id+'&sp='+(email_enabled ? "T" : "F"), dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_notifications.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_notifications.reject(data);
			});
		}
				
	}
})

.factory('Notifications', function($http){
	return {
		get: function(userId, deferred_notifications){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonNotifications&sp='+userId+'&sp=Scount', dataType: 'json'})
			.success(function(data, status, headers, config){
				if(data != null && data.notifications != null && data.notifications.length > 0 && data.notifications[0].notification != null){
					var notif = data.notifications[0].notification;
					var n_friends = 0;
					if(notif.i_count != null && notif.i_count > 0){
						n_friends += notif.i_count;
					}
					if(notif.s_count != null && notif.s_count > 0){
						n_friends += notif.s_count;
					}
					deferred_notifications.resolve({'friends':n_friends, 'messages':notif.m_count, 'notifications':notif.n_count});
				}
			}).error(function(data, status, headers, config){
				deferred_notifications.reject("error Notifications.get call");
			});
		},
	
		list: function(userId, page, subsOk, deferred_notifications){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonNotifications&sp='+userId+'&sp=Slist&sp=4&sp='+page+'&sp=X&sp=X&sp='+(subsOk ? "T" : "F"), dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_notifications.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_notifications.reject("error call");
			});
		},
		
	}
})

.factory('PersonallyMet', function($http){
	return {
		check: function(userId, selectedUserId, deferred_presonallymet){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonUserContacts&sp='+userId+'&sp='+selectedUserId+'&sp=Scheck', dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_presonallymet.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_presonallymet.reject("error PersonallyMey.check call");
			});
		},
		
		add: function(userId, selectedUserId, deferred_presonallymet){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonUserContacts&sp='+userId+'&sp='+selectedUserId+'&sp=Sadd', dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_presonallymet.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_presonallymet.reject("error PersonallyMey.add call");
			});
		},

		rem: function(userId, selectedUserId, deferred_presonallymet){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonUserContacts&sp='+userId+'&sp='+selectedUserId+'&sp=Srem', dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_presonallymet.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_presonallymet.reject("error PersonallyMey.add call");
			});
		},

		list: function(userId, page, deferred_presonallymet){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonUserContacts&sp='+userId+'&sp=X&sp=Slist&sp='+page, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_presonallymet.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_presonallymet.reject("error PersonallyMey.add call");
			});
		},

		req_cnt: function(userId, deferred_presonallymet){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonUserContacts&sp='+userId+'&sp=X&sp=Sreq_cnt', dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_presonallymet.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_presonallymet.reject("error PersonallyMey.add call");
			});
		},

		req_list: function(userId, page, deferred_presonallymet){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonUserContacts&sp='+userId+'&sp=X&sp=Sreq_list&sp='+page, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_presonallymet.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_presonallymet.reject("error PersonallyMey.add call");
			});
		},

		req_conf: function(objId, deferred_presonallymet){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonUserContacts&sp=X&sp=X&sp=Sreq_conf&sp=X&sp='+objId, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_presonallymet.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_presonallymet.reject("error PersonallyMey.add call");
			});
		},
		
		req_rem: function(objId, deferred_presonallymet){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonUserContacts&sp=X&sp=X&sp=Sreq_rem&sp=X&sp='+objId, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_presonallymet.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_presonallymet.reject("error PersonallyMey.add call");
			});
		}

	}
})

.factory('ModalUser', function(UserProfile, $q, $http, $rootScope){
		
	return {
		
		init : function(uid, deferred_mud){
			
			var cw = $(window).width();
			if(cw > 775){
				cw = 775;
			}
			var ch = ($(window).width() * 300 / 775);
			if(ch > 300){
				ch = 300;
			}
			
			var modalUser = {};
			modalUser.wHeight = $(window).height()+'px';
			//modalUser.wHeightNum = $(window).height();
			//modalUser.wWidthNum = $(window).width();
			modalUser.coverWidth = cw+'px';
			modalUser.coverWidthNum = cw;
			modalUser.coverHeight = ch+'px';
			modalUser.coverAndProfileHeightVideos = (ch+90)+'px';
			modalUser.contentViewHeight = ($(window).height() - (ch+90))+'px';
			modalUser.slideHeight = ($(window).height() - (ch+90+40))+'px';
			modalUser.slideProfileHeight = ($(window).height() - (ch+90+40+20));
			if($('#cover_image').height() > 300){
				var new_height = ($(window).width()*$('#cover_image').height())/755;
				$('#cover_image').css("margin-top","-"+((new_height - 123)/2)+"px");
			}
			
			modalUser.activeSlide = 0;
			modalUser.showLoadMorePhotos = false;
			
			var deferred_userProfileInfo = $q.defer();
			var promise_userProfileInfo = deferred_userProfileInfo.promise;
			promise_userProfileInfo.then(function(result){
				modalUser.user = result.users[0].user;
				
				//log(modalUser.user);
				
				var profile = "";
				if(modalUser.user.profileValueId > 41){
					profile = modalUser.user.profile;
				} else if(modalUser.user.profileValueId == 4){
					profile = "<font class='color-blu'>"+(modalUser.user.age_1 > 0 ? modalUser.user.age_1 : "")+"</font>";
				} else if(modalUser.user.profileValueId == 5){
					profile = "<font class='color-rosa'>"+(modalUser.user.age_1 > 0 ? modalUser.user.age_1 : "")+"</font>";
				} else if(modalUser.user.profileValueId == 6){
					profile = "<font class='color-blu'>"+(modalUser.user.age_1 > 0 ? modalUser.user.age_1 : "")+"</font>";
					profile += "&nbsp;&nbsp;<font class='color-rosa'>"+(modalUser.user.age_2 > 0 ? modalUser.user.age_2 : "")+"</font>";
				} else if(modalUser.user.profileValueId == 7){
					profile = "<font class='color-blu'>"+(modalUser.user.age_1 > 0 ? modalUser.user.age_1 : "")+"</font>";
					profile += "&nbsp;&nbsp;<font class='color-blu'>"+(modalUser.user.age_2 > 0 ? modalUser.user.age_2 : "")+"</font>";
				} else if(modalUser.user.profileValueId == 9){
					profile = "<font class='color-rosa'>"+(modalUser.user.age_1 > 0 ? modalUser.user.age_1 : "")+"</font>";
					profile += "&nbsp;&nbsp;<font class='color-rosa'>"+(modalUser.user.age_2 > 0 ? modalUser.user.age_2 : "")+"</font>";
				}
				
				modalUser.userProfile = profile == "" ? modalUser.user.profile : profile;
				
				// utente caricato -> carico profilo html
				
				var deferred_userProfile = $q.defer();
				var promise_userProfile = deferred_userProfile.promise;
				promise_userProfile.then(function(result){
					
					/*
					try {
						result = result.replace(/\/img\/announce\/Icons\/user_female\.png/g, "https://www.erosland.it/img/announce/Icons/user_female.png");
						result = result.replace(/\/img\/announce\/Icons\/user_male\.png/g, "https://www.erosland.it/img/announce/Icons/user_male.png");
					} catch (e) {
					}
					*/
					try {
						result = result.replace(/\<img alt="Donna" src="\/img\/announce\/Icons\/user_female.png"\>\<\/img\>/g, "<i class='ion-female color-rosa'></i>");
						result = result.replace(/\<img alt="Uomo" src="\/img\/announce\/Icons\/user_male.png"\>\<\/img\>/g, "<i class='ion-male color-blu'></i>");
					} catch (e) {
					}
					
					// profilo
					modalUser.userProfileHtml = result;
					// luogo
					modalUser.userProfileHtml = "<div><font class='simplybold'>Luogo</font><br>"+modalUser.user.location+"</div>" + modalUser.userProfileHtml;
					
					// profilo html caricato -> carico feedback
					modalUser.feedbacksInfo = {"cnt":0,"perc":0};
					var deferred_userFeedbacksInfo = $q.defer();
					var promise_userFeedbacksInfo = deferred_userFeedbacksInfo.promise;
					promise_userFeedbacksInfo.then(function(result){
						modalUser.feedbacksInfo.cnt = result.feedbacks_info[0];
						modalUser.feedbacksInfo.perc = Math.round(result.feedbacks_info[1]);
						
						// feedback caricato -> carico video (solo se mobileBrowser)
						if($rootScope.mobileBrowser){
							var deferred_userProfileVideos = $q.defer();
							var promise_userProfileVideos = deferred_userProfileVideos.promise;
							promise_userProfileVideos.then(function(result){
								
								modalUser.videos = result.files;
								if(result.files.length > 0){
									modalUser.showVideos = true;
									modalUser.coverAndProfileHeightVideos = (ch+90+65)+'px';
									modalUser.contentViewHeight = ($(window).height() - (ch+90+65))+'px';
									modalUser.slideHeight = ($(window).height() - (ch+90+40+65))+'px';
									modalUser.slideProfileHeight = ($(window).height() - (ch+90+40+20+65));
								} else {
									modalUser.showVideos = false;
								}
								
								// video caricati
								deferred_mud.resolve(modalUser);
								
							}, function(reason){
								deferred_mud.resolve(modalUser);
							});
							modalUser.userVideosPage = 0;
							UserProfile.getVideos(userId, uid, modalUser.userVideosPage, deferred_userProfileVideos);
						} else {
							modalUser.showVideos = false;
							deferred_mud.resolve(modalUser);
						}
							
					}, function(reason){
						deferred_mud.resolve(modalUser);
					});
					UserProfile.getFeedbacksInfo(uid, deferred_userFeedbacksInfo);
					
				}, function(reason){
					deferred_mud.resolve(modalUser);
				});
				UserProfile.getHtml(uid, deferred_userProfile);
				
			}, function(reason){
				deferred_mud.resolve(modalUser);
			});
			UserProfile.getInfo(uid, deferred_userProfileInfo);
			
			$.ajax({
				type: "GET",
				url: "https://www.erosland.it/nicom1/nicom1",
				data: 'service=json&context=JsonViewUserProfile&sp='+userId+"&sp="+uid,
				dataType: "json",
				cache: false,
				success: function(data) {
				}
			});
			
		},
		
		sendWink: function(userIdFrom, userIdTo, deferred_user){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonSendWink&sp='+userIdFrom+'&sp='+userIdTo, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_user.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_user.reject(data);
			});
		},
		
		addToBlacklist: function(userId, userIdToAdd, deferred_user){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonAddBlackList&sp='+userId+'&sp='+userIdToAdd, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_user.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_user.reject(data);
			});
		},
		
		addToFavorites: function(userId, userIdToAdd, deferred_user){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonAddToFavorites&sp='+userId+'&sp='+userIdToAdd, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_user.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_user.reject(data);
			});
		},

		getReplyRate: function(userId, deferred_user){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonUserReplyRate&sp='+userId, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_user.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_user.reject(data);
			});
		},
		
		getInteractions: function(userIdFrom, userIdTo, iType, iPage, last_chat_time, deferred_user){
			// iType: 1 messaggi, 2 shorts, 3 occhiolini, 4 chat
			
			if(iType == 4){
				$http({method: 'GET', cache: false, url:'https://www.erosland.it/chat_history_nicom.php?uid_f='+userIdFrom+'&uid_t='+userIdTo+'&t='+last_chat_time, dataType: 'json'})
				.success(function(data, status, headers, config){
					deferred_user.resolve(data);
				}).error(function(data, status, headers, config){
					deferred_user.reject(data);
				});
			} else {
				$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonInteractions&sp='+userIdFrom+'&sp='+userIdTo+'&sp='+iType+'&sp='+iPage, dataType: 'json'})
				.success(function(data, status, headers, config){
					deferred_user.resolve(data);
				}).error(function(data, status, headers, config){
					deferred_user.reject(data);
				});
			}
		},
		
		getMessageDetail: function(messageId, deferred_user){
			$http({method: 'GET', cache: false, url:'https://www.erosland.it/nicom1/nicom1?service=json&context=JsonMessageDetailComplete&sp='+messageId, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_user.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_user.reject(data);
			});
		},
		
		sendFeedback: function(userId, selectedUserId, txt, type, deferred_feedback){
			$http.post('https://www.erosland.it/nicom1/nicom1', 'service=json&context=JsonSendFeedback&sp='+userId+'&sp='+selectedUserId+'&sp=S'+txt+'&sp='+type, {cache: false, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_feedback.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_feedback.reject("error call");
			});
		},
		
		sendLastMinuteRequest: function(userId, lastMinuteId, txt, deferred_lastminute){
			$http.post('https://www.erosland.it/nicom1/nicom1', 'service=json&context=JsonLastMinuteRequest&sp='+userId+'&sp='+lastMinuteId+'&sp=S'+txt, {cache: false, dataType: 'json'})
			.success(function(data, status, headers, config){
				deferred_lastminute.resolve(data);
			}).error(function(data, status, headers, config){
				deferred_lastminute.reject("error call");
			});
		}
		
	}
	
});